// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewAckAlertByIDParams creates a new AckAlertByIDParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAckAlertByIDParams() *AckAlertByIDParams {
	return &AckAlertByIDParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAckAlertByIDParamsWithTimeout creates a new AckAlertByIDParams object
// with the ability to set a timeout on a request.
func NewAckAlertByIDParamsWithTimeout(timeout time.Duration) *AckAlertByIDParams {
	return &AckAlertByIDParams{
		timeout: timeout,
	}
}

// NewAckAlertByIDParamsWithContext creates a new AckAlertByIDParams object
// with the ability to set a context for a request.
func NewAckAlertByIDParamsWithContext(ctx context.Context) *AckAlertByIDParams {
	return &AckAlertByIDParams{
		Context: ctx,
	}
}

// NewAckAlertByIDParamsWithHTTPClient creates a new AckAlertByIDParams object
// with the ability to set a custom HTTPClient for a request.
func NewAckAlertByIDParamsWithHTTPClient(client *http.Client) *AckAlertByIDParams {
	return &AckAlertByIDParams{
		HTTPClient: client,
	}
}

/*
AckAlertByIDParams contains all the parameters to send to the API endpoint

	for the ack alert by Id operation.

	Typically these are written to a http.Request.
*/
type AckAlertByIDParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.AlertAck

	// ID.
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ack alert by Id params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AckAlertByIDParams) WithDefaults() *AckAlertByIDParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ack alert by Id params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AckAlertByIDParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := AckAlertByIDParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the ack alert by Id params
func (o *AckAlertByIDParams) WithTimeout(timeout time.Duration) *AckAlertByIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ack alert by Id params
func (o *AckAlertByIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ack alert by Id params
func (o *AckAlertByIDParams) WithContext(ctx context.Context) *AckAlertByIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ack alert by Id params
func (o *AckAlertByIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ack alert by Id params
func (o *AckAlertByIDParams) WithHTTPClient(client *http.Client) *AckAlertByIDParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ack alert by Id params
func (o *AckAlertByIDParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the ack alert by Id params
func (o *AckAlertByIDParams) WithUserAgent(userAgent *string) *AckAlertByIDParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the ack alert by Id params
func (o *AckAlertByIDParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the ack alert by Id params
func (o *AckAlertByIDParams) WithBody(body *models.AlertAck) *AckAlertByIDParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the ack alert by Id params
func (o *AckAlertByIDParams) SetBody(body *models.AlertAck) {
	o.Body = body
}

// WithID adds the id to the ack alert by Id params
func (o *AckAlertByIDParams) WithID(id string) *AckAlertByIDParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the ack alert by Id params
func (o *AckAlertByIDParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *AckAlertByIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
