// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddCollectorGroupReader is a Reader for the AddCollectorGroup structure.
type AddCollectorGroupReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddCollectorGroupReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddCollectorGroupOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddCollectorGroupTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddCollectorGroupDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddCollectorGroupOK creates a AddCollectorGroupOK with default headers values
func NewAddCollectorGroupOK() *AddCollectorGroupOK {
	return &AddCollectorGroupOK{}
}

/*
AddCollectorGroupOK describes a response with status code 200, with default header values.

successful operation
*/
type AddCollectorGroupOK struct {
	Payload *models.CollectorGroup
}

// IsSuccess returns true when this add collector group o k response has a 2xx status code
func (o *AddCollectorGroupOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add collector group o k response has a 3xx status code
func (o *AddCollectorGroupOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add collector group o k response has a 4xx status code
func (o *AddCollectorGroupOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add collector group o k response has a 5xx status code
func (o *AddCollectorGroupOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add collector group o k response a status code equal to that given
func (o *AddCollectorGroupOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add collector group o k response
func (o *AddCollectorGroupOK) Code() int {
	return 200
}

func (o *AddCollectorGroupOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/collector/groups][%d] addCollectorGroupOK %s", 200, payload)
}

func (o *AddCollectorGroupOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/collector/groups][%d] addCollectorGroupOK %s", 200, payload)
}

func (o *AddCollectorGroupOK) GetPayload() *models.CollectorGroup {
	return o.Payload
}

func (o *AddCollectorGroupOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.CollectorGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddCollectorGroupTooManyRequests creates a AddCollectorGroupTooManyRequests with default headers values
func NewAddCollectorGroupTooManyRequests() *AddCollectorGroupTooManyRequests {
	return &AddCollectorGroupTooManyRequests{}
}

/*
AddCollectorGroupTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddCollectorGroupTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add collector group too many requests response has a 2xx status code
func (o *AddCollectorGroupTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add collector group too many requests response has a 3xx status code
func (o *AddCollectorGroupTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add collector group too many requests response has a 4xx status code
func (o *AddCollectorGroupTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add collector group too many requests response has a 5xx status code
func (o *AddCollectorGroupTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add collector group too many requests response a status code equal to that given
func (o *AddCollectorGroupTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add collector group too many requests response
func (o *AddCollectorGroupTooManyRequests) Code() int {
	return 429
}

func (o *AddCollectorGroupTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/collector/groups][%d] addCollectorGroupTooManyRequests", 429)
}

func (o *AddCollectorGroupTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/collector/groups][%d] addCollectorGroupTooManyRequests", 429)
}

func (o *AddCollectorGroupTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddCollectorGroupDefault creates a AddCollectorGroupDefault with default headers values
func NewAddCollectorGroupDefault(code int) *AddCollectorGroupDefault {
	return &AddCollectorGroupDefault{
		_statusCode: code,
	}
}

/*
AddCollectorGroupDefault describes a response with status code -1, with default header values.

Error
*/
type AddCollectorGroupDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add collector group default response has a 2xx status code
func (o *AddCollectorGroupDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add collector group default response has a 3xx status code
func (o *AddCollectorGroupDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add collector group default response has a 4xx status code
func (o *AddCollectorGroupDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add collector group default response has a 5xx status code
func (o *AddCollectorGroupDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add collector group default response a status code equal to that given
func (o *AddCollectorGroupDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add collector group default response
func (o *AddCollectorGroupDefault) Code() int {
	return o._statusCode
}

func (o *AddCollectorGroupDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/collector/groups][%d] addCollectorGroup default %s", o._statusCode, payload)
}

func (o *AddCollectorGroupDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/collector/groups][%d] addCollectorGroup default %s", o._statusCode, payload)
}

func (o *AddCollectorGroupDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddCollectorGroupDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
