// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewAddConfigSourceParams creates a new AddConfigSourceParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAddConfigSourceParams() *AddConfigSourceParams {
	return &AddConfigSourceParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAddConfigSourceParamsWithTimeout creates a new AddConfigSourceParams object
// with the ability to set a timeout on a request.
func NewAddConfigSourceParamsWithTimeout(timeout time.Duration) *AddConfigSourceParams {
	return &AddConfigSourceParams{
		timeout: timeout,
	}
}

// NewAddConfigSourceParamsWithContext creates a new AddConfigSourceParams object
// with the ability to set a context for a request.
func NewAddConfigSourceParamsWithContext(ctx context.Context) *AddConfigSourceParams {
	return &AddConfigSourceParams{
		Context: ctx,
	}
}

// NewAddConfigSourceParamsWithHTTPClient creates a new AddConfigSourceParams object
// with the ability to set a custom HTTPClient for a request.
func NewAddConfigSourceParamsWithHTTPClient(client *http.Client) *AddConfigSourceParams {
	return &AddConfigSourceParams{
		HTTPClient: client,
	}
}

/*
AddConfigSourceParams contains all the parameters to send to the API endpoint

	for the add config source operation.

	Typically these are written to a http.Request.
*/
type AddConfigSourceParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.ConfigSource

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the add config source params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddConfigSourceParams) WithDefaults() *AddConfigSourceParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the add config source params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddConfigSourceParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := AddConfigSourceParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the add config source params
func (o *AddConfigSourceParams) WithTimeout(timeout time.Duration) *AddConfigSourceParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the add config source params
func (o *AddConfigSourceParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the add config source params
func (o *AddConfigSourceParams) WithContext(ctx context.Context) *AddConfigSourceParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the add config source params
func (o *AddConfigSourceParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the add config source params
func (o *AddConfigSourceParams) WithHTTPClient(client *http.Client) *AddConfigSourceParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the add config source params
func (o *AddConfigSourceParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the add config source params
func (o *AddConfigSourceParams) WithUserAgent(userAgent *string) *AddConfigSourceParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the add config source params
func (o *AddConfigSourceParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the add config source params
func (o *AddConfigSourceParams) WithBody(body *models.ConfigSource) *AddConfigSourceParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the add config source params
func (o *AddConfigSourceParams) SetBody(body *models.ConfigSource) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AddConfigSourceParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
