// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddDashboardReader is a Reader for the AddDashboard structure.
type AddDashboardReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddDashboardReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddDashboardOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddDashboardTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddDashboardDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddDashboardOK creates a AddDashboardOK with default headers values
func NewAddDashboardOK() *AddDashboardOK {
	return &AddDashboardOK{}
}

/*
AddDashboardOK describes a response with status code 200, with default header values.

successful operation
*/
type AddDashboardOK struct {
	Payload *models.Dashboard
}

// IsSuccess returns true when this add dashboard o k response has a 2xx status code
func (o *AddDashboardOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add dashboard o k response has a 3xx status code
func (o *AddDashboardOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add dashboard o k response has a 4xx status code
func (o *AddDashboardOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add dashboard o k response has a 5xx status code
func (o *AddDashboardOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add dashboard o k response a status code equal to that given
func (o *AddDashboardOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add dashboard o k response
func (o *AddDashboardOK) Code() int {
	return 200
}

func (o *AddDashboardOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /dashboard/dashboards][%d] addDashboardOK %s", 200, payload)
}

func (o *AddDashboardOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /dashboard/dashboards][%d] addDashboardOK %s", 200, payload)
}

func (o *AddDashboardOK) GetPayload() *models.Dashboard {
	return o.Payload
}

func (o *AddDashboardOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Dashboard)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddDashboardTooManyRequests creates a AddDashboardTooManyRequests with default headers values
func NewAddDashboardTooManyRequests() *AddDashboardTooManyRequests {
	return &AddDashboardTooManyRequests{}
}

/*
AddDashboardTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddDashboardTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add dashboard too many requests response has a 2xx status code
func (o *AddDashboardTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add dashboard too many requests response has a 3xx status code
func (o *AddDashboardTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add dashboard too many requests response has a 4xx status code
func (o *AddDashboardTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add dashboard too many requests response has a 5xx status code
func (o *AddDashboardTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add dashboard too many requests response a status code equal to that given
func (o *AddDashboardTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add dashboard too many requests response
func (o *AddDashboardTooManyRequests) Code() int {
	return 429
}

func (o *AddDashboardTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /dashboard/dashboards][%d] addDashboardTooManyRequests", 429)
}

func (o *AddDashboardTooManyRequests) String() string {
	return fmt.Sprintf("[POST /dashboard/dashboards][%d] addDashboardTooManyRequests", 429)
}

func (o *AddDashboardTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddDashboardDefault creates a AddDashboardDefault with default headers values
func NewAddDashboardDefault(code int) *AddDashboardDefault {
	return &AddDashboardDefault{
		_statusCode: code,
	}
}

/*
AddDashboardDefault describes a response with status code -1, with default header values.

Error
*/
type AddDashboardDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add dashboard default response has a 2xx status code
func (o *AddDashboardDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add dashboard default response has a 3xx status code
func (o *AddDashboardDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add dashboard default response has a 4xx status code
func (o *AddDashboardDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add dashboard default response has a 5xx status code
func (o *AddDashboardDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add dashboard default response a status code equal to that given
func (o *AddDashboardDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add dashboard default response
func (o *AddDashboardDefault) Code() int {
	return o._statusCode
}

func (o *AddDashboardDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /dashboard/dashboards][%d] addDashboard default %s", o._statusCode, payload)
}

func (o *AddDashboardDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /dashboard/dashboards][%d] addDashboard default %s", o._statusCode, payload)
}

func (o *AddDashboardDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddDashboardDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
