// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddDevicePropertyReader is a Reader for the AddDeviceProperty structure.
type AddDevicePropertyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddDevicePropertyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddDevicePropertyOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddDevicePropertyTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddDevicePropertyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddDevicePropertyOK creates a AddDevicePropertyOK with default headers values
func NewAddDevicePropertyOK() *AddDevicePropertyOK {
	return &AddDevicePropertyOK{}
}

/*
AddDevicePropertyOK describes a response with status code 200, with default header values.

successful operation
*/
type AddDevicePropertyOK struct {
	Payload *models.EntityProperty
}

// IsSuccess returns true when this add device property o k response has a 2xx status code
func (o *AddDevicePropertyOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add device property o k response has a 3xx status code
func (o *AddDevicePropertyOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add device property o k response has a 4xx status code
func (o *AddDevicePropertyOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add device property o k response has a 5xx status code
func (o *AddDevicePropertyOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add device property o k response a status code equal to that given
func (o *AddDevicePropertyOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add device property o k response
func (o *AddDevicePropertyOK) Code() int {
	return 200
}

func (o *AddDevicePropertyOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /device/devices/{deviceId}/properties][%d] addDevicePropertyOK %s", 200, payload)
}

func (o *AddDevicePropertyOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /device/devices/{deviceId}/properties][%d] addDevicePropertyOK %s", 200, payload)
}

func (o *AddDevicePropertyOK) GetPayload() *models.EntityProperty {
	return o.Payload
}

func (o *AddDevicePropertyOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.EntityProperty)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddDevicePropertyTooManyRequests creates a AddDevicePropertyTooManyRequests with default headers values
func NewAddDevicePropertyTooManyRequests() *AddDevicePropertyTooManyRequests {
	return &AddDevicePropertyTooManyRequests{}
}

/*
AddDevicePropertyTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddDevicePropertyTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add device property too many requests response has a 2xx status code
func (o *AddDevicePropertyTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add device property too many requests response has a 3xx status code
func (o *AddDevicePropertyTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add device property too many requests response has a 4xx status code
func (o *AddDevicePropertyTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add device property too many requests response has a 5xx status code
func (o *AddDevicePropertyTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add device property too many requests response a status code equal to that given
func (o *AddDevicePropertyTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add device property too many requests response
func (o *AddDevicePropertyTooManyRequests) Code() int {
	return 429
}

func (o *AddDevicePropertyTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /device/devices/{deviceId}/properties][%d] addDevicePropertyTooManyRequests", 429)
}

func (o *AddDevicePropertyTooManyRequests) String() string {
	return fmt.Sprintf("[POST /device/devices/{deviceId}/properties][%d] addDevicePropertyTooManyRequests", 429)
}

func (o *AddDevicePropertyTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddDevicePropertyDefault creates a AddDevicePropertyDefault with default headers values
func NewAddDevicePropertyDefault(code int) *AddDevicePropertyDefault {
	return &AddDevicePropertyDefault{
		_statusCode: code,
	}
}

/*
AddDevicePropertyDefault describes a response with status code -1, with default header values.

Error
*/
type AddDevicePropertyDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add device property default response has a 2xx status code
func (o *AddDevicePropertyDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add device property default response has a 3xx status code
func (o *AddDevicePropertyDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add device property default response has a 4xx status code
func (o *AddDevicePropertyDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add device property default response has a 5xx status code
func (o *AddDevicePropertyDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add device property default response a status code equal to that given
func (o *AddDevicePropertyDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add device property default response
func (o *AddDevicePropertyDefault) Code() int {
	return o._statusCode
}

func (o *AddDevicePropertyDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /device/devices/{deviceId}/properties][%d] addDeviceProperty default %s", o._statusCode, payload)
}

func (o *AddDevicePropertyDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /device/devices/{deviceId}/properties][%d] addDeviceProperty default %s", o._statusCode, payload)
}

func (o *AddDevicePropertyDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddDevicePropertyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
