// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddDNSMappingReader is a Reader for the AddDNSMapping structure.
type AddDNSMappingReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddDNSMappingReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddDNSMappingOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddDNSMappingTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddDNSMappingDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddDNSMappingOK creates a AddDNSMappingOK with default headers values
func NewAddDNSMappingOK() *AddDNSMappingOK {
	return &AddDNSMappingOK{}
}

/*
AddDNSMappingOK describes a response with status code 200, with default header values.

successful operation
*/
type AddDNSMappingOK struct {
	Payload *models.RestDNSMappingV3
}

// IsSuccess returns true when this add Dns mapping o k response has a 2xx status code
func (o *AddDNSMappingOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add Dns mapping o k response has a 3xx status code
func (o *AddDNSMappingOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add Dns mapping o k response has a 4xx status code
func (o *AddDNSMappingOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add Dns mapping o k response has a 5xx status code
func (o *AddDNSMappingOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add Dns mapping o k response a status code equal to that given
func (o *AddDNSMappingOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add Dns mapping o k response
func (o *AddDNSMappingOK) Code() int {
	return 200
}

func (o *AddDNSMappingOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/dnsmappings][%d] addDnsMappingOK %s", 200, payload)
}

func (o *AddDNSMappingOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/dnsmappings][%d] addDnsMappingOK %s", 200, payload)
}

func (o *AddDNSMappingOK) GetPayload() *models.RestDNSMappingV3 {
	return o.Payload
}

func (o *AddDNSMappingOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.RestDNSMappingV3)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddDNSMappingTooManyRequests creates a AddDNSMappingTooManyRequests with default headers values
func NewAddDNSMappingTooManyRequests() *AddDNSMappingTooManyRequests {
	return &AddDNSMappingTooManyRequests{}
}

/*
AddDNSMappingTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddDNSMappingTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add Dns mapping too many requests response has a 2xx status code
func (o *AddDNSMappingTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add Dns mapping too many requests response has a 3xx status code
func (o *AddDNSMappingTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add Dns mapping too many requests response has a 4xx status code
func (o *AddDNSMappingTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add Dns mapping too many requests response has a 5xx status code
func (o *AddDNSMappingTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add Dns mapping too many requests response a status code equal to that given
func (o *AddDNSMappingTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add Dns mapping too many requests response
func (o *AddDNSMappingTooManyRequests) Code() int {
	return 429
}

func (o *AddDNSMappingTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/dnsmappings][%d] addDnsMappingTooManyRequests", 429)
}

func (o *AddDNSMappingTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/dnsmappings][%d] addDnsMappingTooManyRequests", 429)
}

func (o *AddDNSMappingTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddDNSMappingDefault creates a AddDNSMappingDefault with default headers values
func NewAddDNSMappingDefault(code int) *AddDNSMappingDefault {
	return &AddDNSMappingDefault{
		_statusCode: code,
	}
}

/*
AddDNSMappingDefault describes a response with status code -1, with default header values.

Error
*/
type AddDNSMappingDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add DNS mapping default response has a 2xx status code
func (o *AddDNSMappingDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add DNS mapping default response has a 3xx status code
func (o *AddDNSMappingDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add DNS mapping default response has a 4xx status code
func (o *AddDNSMappingDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add DNS mapping default response has a 5xx status code
func (o *AddDNSMappingDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add DNS mapping default response a status code equal to that given
func (o *AddDNSMappingDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add DNS mapping default response
func (o *AddDNSMappingDefault) Code() int {
	return o._statusCode
}

func (o *AddDNSMappingDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/dnsmappings][%d] addDNSMapping default %s", o._statusCode, payload)
}

func (o *AddDNSMappingDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/dnsmappings][%d] addDNSMapping default %s", o._statusCode, payload)
}

func (o *AddDNSMappingDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddDNSMappingDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
