// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewAddEventSourceParams creates a new AddEventSourceParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAddEventSourceParams() *AddEventSourceParams {
	return &AddEventSourceParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAddEventSourceParamsWithTimeout creates a new AddEventSourceParams object
// with the ability to set a timeout on a request.
func NewAddEventSourceParamsWithTimeout(timeout time.Duration) *AddEventSourceParams {
	return &AddEventSourceParams{
		timeout: timeout,
	}
}

// NewAddEventSourceParamsWithContext creates a new AddEventSourceParams object
// with the ability to set a context for a request.
func NewAddEventSourceParamsWithContext(ctx context.Context) *AddEventSourceParams {
	return &AddEventSourceParams{
		Context: ctx,
	}
}

// NewAddEventSourceParamsWithHTTPClient creates a new AddEventSourceParams object
// with the ability to set a custom HTTPClient for a request.
func NewAddEventSourceParamsWithHTTPClient(client *http.Client) *AddEventSourceParams {
	return &AddEventSourceParams{
		HTTPClient: client,
	}
}

/*
AddEventSourceParams contains all the parameters to send to the API endpoint

	for the add event source operation.

	Typically these are written to a http.Request.
*/
type AddEventSourceParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body models.EventSource

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the add event source params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddEventSourceParams) WithDefaults() *AddEventSourceParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the add event source params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddEventSourceParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := AddEventSourceParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the add event source params
func (o *AddEventSourceParams) WithTimeout(timeout time.Duration) *AddEventSourceParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the add event source params
func (o *AddEventSourceParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the add event source params
func (o *AddEventSourceParams) WithContext(ctx context.Context) *AddEventSourceParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the add event source params
func (o *AddEventSourceParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the add event source params
func (o *AddEventSourceParams) WithHTTPClient(client *http.Client) *AddEventSourceParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the add event source params
func (o *AddEventSourceParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the add event source params
func (o *AddEventSourceParams) WithUserAgent(userAgent *string) *AddEventSourceParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the add event source params
func (o *AddEventSourceParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the add event source params
func (o *AddEventSourceParams) WithBody(body models.EventSource) *AddEventSourceParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the add event source params
func (o *AddEventSourceParams) SetBody(body models.EventSource) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AddEventSourceParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
