// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewAddJobMonitorParams creates a new AddJobMonitorParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAddJobMonitorParams() *AddJobMonitorParams {
	return &AddJobMonitorParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAddJobMonitorParamsWithTimeout creates a new AddJobMonitorParams object
// with the ability to set a timeout on a request.
func NewAddJobMonitorParamsWithTimeout(timeout time.Duration) *AddJobMonitorParams {
	return &AddJobMonitorParams{
		timeout: timeout,
	}
}

// NewAddJobMonitorParamsWithContext creates a new AddJobMonitorParams object
// with the ability to set a context for a request.
func NewAddJobMonitorParamsWithContext(ctx context.Context) *AddJobMonitorParams {
	return &AddJobMonitorParams{
		Context: ctx,
	}
}

// NewAddJobMonitorParamsWithHTTPClient creates a new AddJobMonitorParams object
// with the ability to set a custom HTTPClient for a request.
func NewAddJobMonitorParamsWithHTTPClient(client *http.Client) *AddJobMonitorParams {
	return &AddJobMonitorParams{
		HTTPClient: client,
	}
}

/*
AddJobMonitorParams contains all the parameters to send to the API endpoint

	for the add job monitor operation.

	Typically these are written to a http.Request.
*/
type AddJobMonitorParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.BatchJob

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the add job monitor params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddJobMonitorParams) WithDefaults() *AddJobMonitorParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the add job monitor params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddJobMonitorParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := AddJobMonitorParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the add job monitor params
func (o *AddJobMonitorParams) WithTimeout(timeout time.Duration) *AddJobMonitorParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the add job monitor params
func (o *AddJobMonitorParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the add job monitor params
func (o *AddJobMonitorParams) WithContext(ctx context.Context) *AddJobMonitorParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the add job monitor params
func (o *AddJobMonitorParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the add job monitor params
func (o *AddJobMonitorParams) WithHTTPClient(client *http.Client) *AddJobMonitorParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the add job monitor params
func (o *AddJobMonitorParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the add job monitor params
func (o *AddJobMonitorParams) WithUserAgent(userAgent *string) *AddJobMonitorParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the add job monitor params
func (o *AddJobMonitorParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the add job monitor params
func (o *AddJobMonitorParams) WithBody(body *models.BatchJob) *AddJobMonitorParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the add job monitor params
func (o *AddJobMonitorParams) SetBody(body *models.BatchJob) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AddJobMonitorParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
