// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// AddRecipientGroupReader is a Reader for the AddRecipientGroup structure.
type AddRecipientGroupReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AddRecipientGroupReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAddRecipientGroupOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewAddRecipientGroupTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewAddRecipientGroupDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAddRecipientGroupOK creates a AddRecipientGroupOK with default headers values
func NewAddRecipientGroupOK() *AddRecipientGroupOK {
	return &AddRecipientGroupOK{}
}

/*
AddRecipientGroupOK describes a response with status code 200, with default header values.

successful operation
*/
type AddRecipientGroupOK struct {
	Payload *models.RecipientGroup
}

// IsSuccess returns true when this add recipient group o k response has a 2xx status code
func (o *AddRecipientGroupOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this add recipient group o k response has a 3xx status code
func (o *AddRecipientGroupOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add recipient group o k response has a 4xx status code
func (o *AddRecipientGroupOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this add recipient group o k response has a 5xx status code
func (o *AddRecipientGroupOK) IsServerError() bool {
	return false
}

// IsCode returns true when this add recipient group o k response a status code equal to that given
func (o *AddRecipientGroupOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the add recipient group o k response
func (o *AddRecipientGroupOK) Code() int {
	return 200
}

func (o *AddRecipientGroupOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/recipientgroups][%d] addRecipientGroupOK %s", 200, payload)
}

func (o *AddRecipientGroupOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/recipientgroups][%d] addRecipientGroupOK %s", 200, payload)
}

func (o *AddRecipientGroupOK) GetPayload() *models.RecipientGroup {
	return o.Payload
}

func (o *AddRecipientGroupOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.RecipientGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAddRecipientGroupTooManyRequests creates a AddRecipientGroupTooManyRequests with default headers values
func NewAddRecipientGroupTooManyRequests() *AddRecipientGroupTooManyRequests {
	return &AddRecipientGroupTooManyRequests{}
}

/*
AddRecipientGroupTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type AddRecipientGroupTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this add recipient group too many requests response has a 2xx status code
func (o *AddRecipientGroupTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this add recipient group too many requests response has a 3xx status code
func (o *AddRecipientGroupTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this add recipient group too many requests response has a 4xx status code
func (o *AddRecipientGroupTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this add recipient group too many requests response has a 5xx status code
func (o *AddRecipientGroupTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this add recipient group too many requests response a status code equal to that given
func (o *AddRecipientGroupTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the add recipient group too many requests response
func (o *AddRecipientGroupTooManyRequests) Code() int {
	return 429
}

func (o *AddRecipientGroupTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/recipientgroups][%d] addRecipientGroupTooManyRequests", 429)
}

func (o *AddRecipientGroupTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/recipientgroups][%d] addRecipientGroupTooManyRequests", 429)
}

func (o *AddRecipientGroupTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewAddRecipientGroupDefault creates a AddRecipientGroupDefault with default headers values
func NewAddRecipientGroupDefault(code int) *AddRecipientGroupDefault {
	return &AddRecipientGroupDefault{
		_statusCode: code,
	}
}

/*
AddRecipientGroupDefault describes a response with status code -1, with default header values.

Error
*/
type AddRecipientGroupDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this add recipient group default response has a 2xx status code
func (o *AddRecipientGroupDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this add recipient group default response has a 3xx status code
func (o *AddRecipientGroupDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this add recipient group default response has a 4xx status code
func (o *AddRecipientGroupDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this add recipient group default response has a 5xx status code
func (o *AddRecipientGroupDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this add recipient group default response a status code equal to that given
func (o *AddRecipientGroupDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the add recipient group default response
func (o *AddRecipientGroupDefault) Code() int {
	return o._statusCode
}

func (o *AddRecipientGroupDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/recipientgroups][%d] addRecipientGroup default %s", o._statusCode, payload)
}

func (o *AddRecipientGroupDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/recipientgroups][%d] addRecipientGroup default %s", o._statusCode, payload)
}

func (o *AddRecipientGroupDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AddRecipientGroupDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
