// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// CreateLogPartitionReader is a Reader for the CreateLogPartition structure.
type CreateLogPartitionReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateLogPartitionReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewCreateLogPartitionOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewCreateLogPartitionTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewCreateLogPartitionDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewCreateLogPartitionOK creates a CreateLogPartitionOK with default headers values
func NewCreateLogPartitionOK() *CreateLogPartitionOK {
	return &CreateLogPartitionOK{}
}

/*
CreateLogPartitionOK describes a response with status code 200, with default header values.

successful operation
*/
type CreateLogPartitionOK struct {
	Payload *models.Pagination
}

// IsSuccess returns true when this create log partition o k response has a 2xx status code
func (o *CreateLogPartitionOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this create log partition o k response has a 3xx status code
func (o *CreateLogPartitionOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create log partition o k response has a 4xx status code
func (o *CreateLogPartitionOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this create log partition o k response has a 5xx status code
func (o *CreateLogPartitionOK) IsServerError() bool {
	return false
}

// IsCode returns true when this create log partition o k response a status code equal to that given
func (o *CreateLogPartitionOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the create log partition o k response
func (o *CreateLogPartitionOK) Code() int {
	return 200
}

func (o *CreateLogPartitionOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /log/partitions][%d] createLogPartitionOK %s", 200, payload)
}

func (o *CreateLogPartitionOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /log/partitions][%d] createLogPartitionOK %s", 200, payload)
}

func (o *CreateLogPartitionOK) GetPayload() *models.Pagination {
	return o.Payload
}

func (o *CreateLogPartitionOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Pagination)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateLogPartitionTooManyRequests creates a CreateLogPartitionTooManyRequests with default headers values
func NewCreateLogPartitionTooManyRequests() *CreateLogPartitionTooManyRequests {
	return &CreateLogPartitionTooManyRequests{}
}

/*
CreateLogPartitionTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type CreateLogPartitionTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this create log partition too many requests response has a 2xx status code
func (o *CreateLogPartitionTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create log partition too many requests response has a 3xx status code
func (o *CreateLogPartitionTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create log partition too many requests response has a 4xx status code
func (o *CreateLogPartitionTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this create log partition too many requests response has a 5xx status code
func (o *CreateLogPartitionTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this create log partition too many requests response a status code equal to that given
func (o *CreateLogPartitionTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the create log partition too many requests response
func (o *CreateLogPartitionTooManyRequests) Code() int {
	return 429
}

func (o *CreateLogPartitionTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /log/partitions][%d] createLogPartitionTooManyRequests", 429)
}

func (o *CreateLogPartitionTooManyRequests) String() string {
	return fmt.Sprintf("[POST /log/partitions][%d] createLogPartitionTooManyRequests", 429)
}

func (o *CreateLogPartitionTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewCreateLogPartitionDefault creates a CreateLogPartitionDefault with default headers values
func NewCreateLogPartitionDefault(code int) *CreateLogPartitionDefault {
	return &CreateLogPartitionDefault{
		_statusCode: code,
	}
}

/*
CreateLogPartitionDefault describes a response with status code -1, with default header values.

Error
*/
type CreateLogPartitionDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this create log partition default response has a 2xx status code
func (o *CreateLogPartitionDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this create log partition default response has a 3xx status code
func (o *CreateLogPartitionDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this create log partition default response has a 4xx status code
func (o *CreateLogPartitionDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this create log partition default response has a 5xx status code
func (o *CreateLogPartitionDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this create log partition default response a status code equal to that given
func (o *CreateLogPartitionDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the create log partition default response
func (o *CreateLogPartitionDefault) Code() int {
	return o._statusCode
}

func (o *CreateLogPartitionDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /log/partitions][%d] createLogPartition default %s", o._statusCode, payload)
}

func (o *CreateLogPartitionDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /log/partitions][%d] createLogPartition default %s", o._statusCode, payload)
}

func (o *CreateLogPartitionDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *CreateLogPartitionDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
