// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// DeleteDeviceGroupByIDReader is a Reader for the DeleteDeviceGroupByID structure.
type DeleteDeviceGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteDeviceGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteDeviceGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewDeleteDeviceGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewDeleteDeviceGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteDeviceGroupByIDOK creates a DeleteDeviceGroupByIDOK with default headers values
func NewDeleteDeviceGroupByIDOK() *DeleteDeviceGroupByIDOK {
	return &DeleteDeviceGroupByIDOK{}
}

/*
DeleteDeviceGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type DeleteDeviceGroupByIDOK struct {
	Payload interface{}
}

// IsSuccess returns true when this delete device group by Id o k response has a 2xx status code
func (o *DeleteDeviceGroupByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete device group by Id o k response has a 3xx status code
func (o *DeleteDeviceGroupByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete device group by Id o k response has a 4xx status code
func (o *DeleteDeviceGroupByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete device group by Id o k response has a 5xx status code
func (o *DeleteDeviceGroupByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete device group by Id o k response a status code equal to that given
func (o *DeleteDeviceGroupByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the delete device group by Id o k response
func (o *DeleteDeviceGroupByIDOK) Code() int {
	return 200
}

func (o *DeleteDeviceGroupByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /device/groups/{id}][%d] deleteDeviceGroupByIdOK %s", 200, payload)
}

func (o *DeleteDeviceGroupByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /device/groups/{id}][%d] deleteDeviceGroupByIdOK %s", 200, payload)
}

func (o *DeleteDeviceGroupByIDOK) GetPayload() interface{} {
	return o.Payload
}

func (o *DeleteDeviceGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteDeviceGroupByIDTooManyRequests creates a DeleteDeviceGroupByIDTooManyRequests with default headers values
func NewDeleteDeviceGroupByIDTooManyRequests() *DeleteDeviceGroupByIDTooManyRequests {
	return &DeleteDeviceGroupByIDTooManyRequests{}
}

/*
DeleteDeviceGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type DeleteDeviceGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this delete device group by Id too many requests response has a 2xx status code
func (o *DeleteDeviceGroupByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete device group by Id too many requests response has a 3xx status code
func (o *DeleteDeviceGroupByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete device group by Id too many requests response has a 4xx status code
func (o *DeleteDeviceGroupByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete device group by Id too many requests response has a 5xx status code
func (o *DeleteDeviceGroupByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this delete device group by Id too many requests response a status code equal to that given
func (o *DeleteDeviceGroupByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the delete device group by Id too many requests response
func (o *DeleteDeviceGroupByIDTooManyRequests) Code() int {
	return 429
}

func (o *DeleteDeviceGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[DELETE /device/groups/{id}][%d] deleteDeviceGroupByIdTooManyRequests", 429)
}

func (o *DeleteDeviceGroupByIDTooManyRequests) String() string {
	return fmt.Sprintf("[DELETE /device/groups/{id}][%d] deleteDeviceGroupByIdTooManyRequests", 429)
}

func (o *DeleteDeviceGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewDeleteDeviceGroupByIDDefault creates a DeleteDeviceGroupByIDDefault with default headers values
func NewDeleteDeviceGroupByIDDefault(code int) *DeleteDeviceGroupByIDDefault {
	return &DeleteDeviceGroupByIDDefault{
		_statusCode: code,
	}
}

/*
DeleteDeviceGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type DeleteDeviceGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this delete device group by Id default response has a 2xx status code
func (o *DeleteDeviceGroupByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this delete device group by Id default response has a 3xx status code
func (o *DeleteDeviceGroupByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this delete device group by Id default response has a 4xx status code
func (o *DeleteDeviceGroupByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this delete device group by Id default response has a 5xx status code
func (o *DeleteDeviceGroupByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this delete device group by Id default response a status code equal to that given
func (o *DeleteDeviceGroupByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the delete device group by Id default response
func (o *DeleteDeviceGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *DeleteDeviceGroupByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /device/groups/{id}][%d] deleteDeviceGroupById default %s", o._statusCode, payload)
}

func (o *DeleteDeviceGroupByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /device/groups/{id}][%d] deleteDeviceGroupById default %s", o._statusCode, payload)
}

func (o *DeleteDeviceGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *DeleteDeviceGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
