// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// DeleteJobMonitorReader is a Reader for the DeleteJobMonitor structure.
type DeleteJobMonitorReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteJobMonitorReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteJobMonitorOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewDeleteJobMonitorTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewDeleteJobMonitorDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteJobMonitorOK creates a DeleteJobMonitorOK with default headers values
func NewDeleteJobMonitorOK() *DeleteJobMonitorOK {
	return &DeleteJobMonitorOK{}
}

/*
DeleteJobMonitorOK describes a response with status code 200, with default header values.

successful operation
*/
type DeleteJobMonitorOK struct {
	Payload interface{}
}

// IsSuccess returns true when this delete job monitor o k response has a 2xx status code
func (o *DeleteJobMonitorOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete job monitor o k response has a 3xx status code
func (o *DeleteJobMonitorOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete job monitor o k response has a 4xx status code
func (o *DeleteJobMonitorOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete job monitor o k response has a 5xx status code
func (o *DeleteJobMonitorOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete job monitor o k response a status code equal to that given
func (o *DeleteJobMonitorOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the delete job monitor o k response
func (o *DeleteJobMonitorOK) Code() int {
	return 200
}

func (o *DeleteJobMonitorOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/batchjobs/{id}][%d] deleteJobMonitorOK %s", 200, payload)
}

func (o *DeleteJobMonitorOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/batchjobs/{id}][%d] deleteJobMonitorOK %s", 200, payload)
}

func (o *DeleteJobMonitorOK) GetPayload() interface{} {
	return o.Payload
}

func (o *DeleteJobMonitorOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteJobMonitorTooManyRequests creates a DeleteJobMonitorTooManyRequests with default headers values
func NewDeleteJobMonitorTooManyRequests() *DeleteJobMonitorTooManyRequests {
	return &DeleteJobMonitorTooManyRequests{}
}

/*
DeleteJobMonitorTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type DeleteJobMonitorTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this delete job monitor too many requests response has a 2xx status code
func (o *DeleteJobMonitorTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete job monitor too many requests response has a 3xx status code
func (o *DeleteJobMonitorTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete job monitor too many requests response has a 4xx status code
func (o *DeleteJobMonitorTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete job monitor too many requests response has a 5xx status code
func (o *DeleteJobMonitorTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this delete job monitor too many requests response a status code equal to that given
func (o *DeleteJobMonitorTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the delete job monitor too many requests response
func (o *DeleteJobMonitorTooManyRequests) Code() int {
	return 429
}

func (o *DeleteJobMonitorTooManyRequests) Error() string {
	return fmt.Sprintf("[DELETE /setting/batchjobs/{id}][%d] deleteJobMonitorTooManyRequests", 429)
}

func (o *DeleteJobMonitorTooManyRequests) String() string {
	return fmt.Sprintf("[DELETE /setting/batchjobs/{id}][%d] deleteJobMonitorTooManyRequests", 429)
}

func (o *DeleteJobMonitorTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewDeleteJobMonitorDefault creates a DeleteJobMonitorDefault with default headers values
func NewDeleteJobMonitorDefault(code int) *DeleteJobMonitorDefault {
	return &DeleteJobMonitorDefault{
		_statusCode: code,
	}
}

/*
DeleteJobMonitorDefault describes a response with status code -1, with default header values.

Error
*/
type DeleteJobMonitorDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this delete job monitor default response has a 2xx status code
func (o *DeleteJobMonitorDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this delete job monitor default response has a 3xx status code
func (o *DeleteJobMonitorDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this delete job monitor default response has a 4xx status code
func (o *DeleteJobMonitorDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this delete job monitor default response has a 5xx status code
func (o *DeleteJobMonitorDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this delete job monitor default response a status code equal to that given
func (o *DeleteJobMonitorDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the delete job monitor default response
func (o *DeleteJobMonitorDefault) Code() int {
	return o._statusCode
}

func (o *DeleteJobMonitorDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/batchjobs/{id}][%d] deleteJobMonitor default %s", o._statusCode, payload)
}

func (o *DeleteJobMonitorDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/batchjobs/{id}][%d] deleteJobMonitor default %s", o._statusCode, payload)
}

func (o *DeleteJobMonitorDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *DeleteJobMonitorDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
