// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDeleteLogSourceParams creates a new DeleteLogSourceParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteLogSourceParams() *DeleteLogSourceParams {
	return &DeleteLogSourceParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteLogSourceParamsWithTimeout creates a new DeleteLogSourceParams object
// with the ability to set a timeout on a request.
func NewDeleteLogSourceParamsWithTimeout(timeout time.Duration) *DeleteLogSourceParams {
	return &DeleteLogSourceParams{
		timeout: timeout,
	}
}

// NewDeleteLogSourceParamsWithContext creates a new DeleteLogSourceParams object
// with the ability to set a context for a request.
func NewDeleteLogSourceParamsWithContext(ctx context.Context) *DeleteLogSourceParams {
	return &DeleteLogSourceParams{
		Context: ctx,
	}
}

// NewDeleteLogSourceParamsWithHTTPClient creates a new DeleteLogSourceParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteLogSourceParamsWithHTTPClient(client *http.Client) *DeleteLogSourceParams {
	return &DeleteLogSourceParams{
		HTTPClient: client,
	}
}

/*
DeleteLogSourceParams contains all the parameters to send to the API endpoint

	for the delete log source operation.

	Typically these are written to a http.Request.
*/
type DeleteLogSourceParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// ID.
	//
	// Format: int32
	ID int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete log source params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteLogSourceParams) WithDefaults() *DeleteLogSourceParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete log source params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteLogSourceParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := DeleteLogSourceParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the delete log source params
func (o *DeleteLogSourceParams) WithTimeout(timeout time.Duration) *DeleteLogSourceParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete log source params
func (o *DeleteLogSourceParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete log source params
func (o *DeleteLogSourceParams) WithContext(ctx context.Context) *DeleteLogSourceParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete log source params
func (o *DeleteLogSourceParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete log source params
func (o *DeleteLogSourceParams) WithHTTPClient(client *http.Client) *DeleteLogSourceParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete log source params
func (o *DeleteLogSourceParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the delete log source params
func (o *DeleteLogSourceParams) WithUserAgent(userAgent *string) *DeleteLogSourceParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the delete log source params
func (o *DeleteLogSourceParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithID adds the id to the delete log source params
func (o *DeleteLogSourceParams) WithID(id int32) *DeleteLogSourceParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the delete log source params
func (o *DeleteLogSourceParams) SetID(id int32) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteLogSourceParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt32(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
