// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// DeleteLogSourceReader is a Reader for the DeleteLogSource structure.
type DeleteLogSourceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteLogSourceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteLogSourceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewDeleteLogSourceTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewDeleteLogSourceDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteLogSourceOK creates a DeleteLogSourceOK with default headers values
func NewDeleteLogSourceOK() *DeleteLogSourceOK {
	return &DeleteLogSourceOK{}
}

/*
DeleteLogSourceOK describes a response with status code 200, with default header values.

successful operation
*/
type DeleteLogSourceOK struct {
	Payload interface{}
}

// IsSuccess returns true when this delete log source o k response has a 2xx status code
func (o *DeleteLogSourceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete log source o k response has a 3xx status code
func (o *DeleteLogSourceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete log source o k response has a 4xx status code
func (o *DeleteLogSourceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete log source o k response has a 5xx status code
func (o *DeleteLogSourceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete log source o k response a status code equal to that given
func (o *DeleteLogSourceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the delete log source o k response
func (o *DeleteLogSourceOK) Code() int {
	return 200
}

func (o *DeleteLogSourceOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/logsources/{id}][%d] deleteLogSourceOK %s", 200, payload)
}

func (o *DeleteLogSourceOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/logsources/{id}][%d] deleteLogSourceOK %s", 200, payload)
}

func (o *DeleteLogSourceOK) GetPayload() interface{} {
	return o.Payload
}

func (o *DeleteLogSourceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteLogSourceTooManyRequests creates a DeleteLogSourceTooManyRequests with default headers values
func NewDeleteLogSourceTooManyRequests() *DeleteLogSourceTooManyRequests {
	return &DeleteLogSourceTooManyRequests{}
}

/*
DeleteLogSourceTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type DeleteLogSourceTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this delete log source too many requests response has a 2xx status code
func (o *DeleteLogSourceTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete log source too many requests response has a 3xx status code
func (o *DeleteLogSourceTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete log source too many requests response has a 4xx status code
func (o *DeleteLogSourceTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete log source too many requests response has a 5xx status code
func (o *DeleteLogSourceTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this delete log source too many requests response a status code equal to that given
func (o *DeleteLogSourceTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the delete log source too many requests response
func (o *DeleteLogSourceTooManyRequests) Code() int {
	return 429
}

func (o *DeleteLogSourceTooManyRequests) Error() string {
	return fmt.Sprintf("[DELETE /setting/logsources/{id}][%d] deleteLogSourceTooManyRequests", 429)
}

func (o *DeleteLogSourceTooManyRequests) String() string {
	return fmt.Sprintf("[DELETE /setting/logsources/{id}][%d] deleteLogSourceTooManyRequests", 429)
}

func (o *DeleteLogSourceTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewDeleteLogSourceDefault creates a DeleteLogSourceDefault with default headers values
func NewDeleteLogSourceDefault(code int) *DeleteLogSourceDefault {
	return &DeleteLogSourceDefault{
		_statusCode: code,
	}
}

/*
DeleteLogSourceDefault describes a response with status code -1, with default header values.

Error
*/
type DeleteLogSourceDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this delete log source default response has a 2xx status code
func (o *DeleteLogSourceDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this delete log source default response has a 3xx status code
func (o *DeleteLogSourceDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this delete log source default response has a 4xx status code
func (o *DeleteLogSourceDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this delete log source default response has a 5xx status code
func (o *DeleteLogSourceDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this delete log source default response a status code equal to that given
func (o *DeleteLogSourceDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the delete log source default response
func (o *DeleteLogSourceDefault) Code() int {
	return o._statusCode
}

func (o *DeleteLogSourceDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/logsources/{id}][%d] deleteLogSource default %s", o._statusCode, payload)
}

func (o *DeleteLogSourceDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/logsources/{id}][%d] deleteLogSource default %s", o._statusCode, payload)
}

func (o *DeleteLogSourceDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *DeleteLogSourceDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
