// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// DeleteNetscanByIDReader is a Reader for the DeleteNetscanByID structure.
type DeleteNetscanByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteNetscanByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteNetscanByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewDeleteNetscanByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewDeleteNetscanByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteNetscanByIDOK creates a DeleteNetscanByIDOK with default headers values
func NewDeleteNetscanByIDOK() *DeleteNetscanByIDOK {
	return &DeleteNetscanByIDOK{}
}

/*
DeleteNetscanByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type DeleteNetscanByIDOK struct {
	Payload interface{}
}

// IsSuccess returns true when this delete netscan by Id o k response has a 2xx status code
func (o *DeleteNetscanByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete netscan by Id o k response has a 3xx status code
func (o *DeleteNetscanByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete netscan by Id o k response has a 4xx status code
func (o *DeleteNetscanByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete netscan by Id o k response has a 5xx status code
func (o *DeleteNetscanByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete netscan by Id o k response a status code equal to that given
func (o *DeleteNetscanByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the delete netscan by Id o k response
func (o *DeleteNetscanByIDOK) Code() int {
	return 200
}

func (o *DeleteNetscanByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/netscans/{id}][%d] deleteNetscanByIdOK %s", 200, payload)
}

func (o *DeleteNetscanByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/netscans/{id}][%d] deleteNetscanByIdOK %s", 200, payload)
}

func (o *DeleteNetscanByIDOK) GetPayload() interface{} {
	return o.Payload
}

func (o *DeleteNetscanByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteNetscanByIDTooManyRequests creates a DeleteNetscanByIDTooManyRequests with default headers values
func NewDeleteNetscanByIDTooManyRequests() *DeleteNetscanByIDTooManyRequests {
	return &DeleteNetscanByIDTooManyRequests{}
}

/*
DeleteNetscanByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type DeleteNetscanByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this delete netscan by Id too many requests response has a 2xx status code
func (o *DeleteNetscanByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete netscan by Id too many requests response has a 3xx status code
func (o *DeleteNetscanByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete netscan by Id too many requests response has a 4xx status code
func (o *DeleteNetscanByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete netscan by Id too many requests response has a 5xx status code
func (o *DeleteNetscanByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this delete netscan by Id too many requests response a status code equal to that given
func (o *DeleteNetscanByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the delete netscan by Id too many requests response
func (o *DeleteNetscanByIDTooManyRequests) Code() int {
	return 429
}

func (o *DeleteNetscanByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[DELETE /setting/netscans/{id}][%d] deleteNetscanByIdTooManyRequests", 429)
}

func (o *DeleteNetscanByIDTooManyRequests) String() string {
	return fmt.Sprintf("[DELETE /setting/netscans/{id}][%d] deleteNetscanByIdTooManyRequests", 429)
}

func (o *DeleteNetscanByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewDeleteNetscanByIDDefault creates a DeleteNetscanByIDDefault with default headers values
func NewDeleteNetscanByIDDefault(code int) *DeleteNetscanByIDDefault {
	return &DeleteNetscanByIDDefault{
		_statusCode: code,
	}
}

/*
DeleteNetscanByIDDefault describes a response with status code -1, with default header values.

Error
*/
type DeleteNetscanByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this delete netscan by Id default response has a 2xx status code
func (o *DeleteNetscanByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this delete netscan by Id default response has a 3xx status code
func (o *DeleteNetscanByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this delete netscan by Id default response has a 4xx status code
func (o *DeleteNetscanByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this delete netscan by Id default response has a 5xx status code
func (o *DeleteNetscanByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this delete netscan by Id default response a status code equal to that given
func (o *DeleteNetscanByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the delete netscan by Id default response
func (o *DeleteNetscanByIDDefault) Code() int {
	return o._statusCode
}

func (o *DeleteNetscanByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/netscans/{id}][%d] deleteNetscanById default %s", o._statusCode, payload)
}

func (o *DeleteNetscanByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/netscans/{id}][%d] deleteNetscanById default %s", o._statusCode, payload)
}

func (o *DeleteNetscanByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *DeleteNetscanByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
