// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// DeleteRecipientGroupByIDReader is a Reader for the DeleteRecipientGroupByID structure.
type DeleteRecipientGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteRecipientGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteRecipientGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewDeleteRecipientGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewDeleteRecipientGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteRecipientGroupByIDOK creates a DeleteRecipientGroupByIDOK with default headers values
func NewDeleteRecipientGroupByIDOK() *DeleteRecipientGroupByIDOK {
	return &DeleteRecipientGroupByIDOK{}
}

/*
DeleteRecipientGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type DeleteRecipientGroupByIDOK struct {
	Payload interface{}
}

// IsSuccess returns true when this delete recipient group by Id o k response has a 2xx status code
func (o *DeleteRecipientGroupByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete recipient group by Id o k response has a 3xx status code
func (o *DeleteRecipientGroupByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete recipient group by Id o k response has a 4xx status code
func (o *DeleteRecipientGroupByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete recipient group by Id o k response has a 5xx status code
func (o *DeleteRecipientGroupByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete recipient group by Id o k response a status code equal to that given
func (o *DeleteRecipientGroupByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the delete recipient group by Id o k response
func (o *DeleteRecipientGroupByIDOK) Code() int {
	return 200
}

func (o *DeleteRecipientGroupByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/recipientgroups/{id}][%d] deleteRecipientGroupByIdOK %s", 200, payload)
}

func (o *DeleteRecipientGroupByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/recipientgroups/{id}][%d] deleteRecipientGroupByIdOK %s", 200, payload)
}

func (o *DeleteRecipientGroupByIDOK) GetPayload() interface{} {
	return o.Payload
}

func (o *DeleteRecipientGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteRecipientGroupByIDTooManyRequests creates a DeleteRecipientGroupByIDTooManyRequests with default headers values
func NewDeleteRecipientGroupByIDTooManyRequests() *DeleteRecipientGroupByIDTooManyRequests {
	return &DeleteRecipientGroupByIDTooManyRequests{}
}

/*
DeleteRecipientGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type DeleteRecipientGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this delete recipient group by Id too many requests response has a 2xx status code
func (o *DeleteRecipientGroupByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete recipient group by Id too many requests response has a 3xx status code
func (o *DeleteRecipientGroupByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete recipient group by Id too many requests response has a 4xx status code
func (o *DeleteRecipientGroupByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete recipient group by Id too many requests response has a 5xx status code
func (o *DeleteRecipientGroupByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this delete recipient group by Id too many requests response a status code equal to that given
func (o *DeleteRecipientGroupByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the delete recipient group by Id too many requests response
func (o *DeleteRecipientGroupByIDTooManyRequests) Code() int {
	return 429
}

func (o *DeleteRecipientGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[DELETE /setting/recipientgroups/{id}][%d] deleteRecipientGroupByIdTooManyRequests", 429)
}

func (o *DeleteRecipientGroupByIDTooManyRequests) String() string {
	return fmt.Sprintf("[DELETE /setting/recipientgroups/{id}][%d] deleteRecipientGroupByIdTooManyRequests", 429)
}

func (o *DeleteRecipientGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewDeleteRecipientGroupByIDDefault creates a DeleteRecipientGroupByIDDefault with default headers values
func NewDeleteRecipientGroupByIDDefault(code int) *DeleteRecipientGroupByIDDefault {
	return &DeleteRecipientGroupByIDDefault{
		_statusCode: code,
	}
}

/*
DeleteRecipientGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type DeleteRecipientGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this delete recipient group by Id default response has a 2xx status code
func (o *DeleteRecipientGroupByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this delete recipient group by Id default response has a 3xx status code
func (o *DeleteRecipientGroupByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this delete recipient group by Id default response has a 4xx status code
func (o *DeleteRecipientGroupByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this delete recipient group by Id default response has a 5xx status code
func (o *DeleteRecipientGroupByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this delete recipient group by Id default response a status code equal to that given
func (o *DeleteRecipientGroupByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the delete recipient group by Id default response
func (o *DeleteRecipientGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *DeleteRecipientGroupByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/recipientgroups/{id}][%d] deleteRecipientGroupById default %s", o._statusCode, payload)
}

func (o *DeleteRecipientGroupByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/recipientgroups/{id}][%d] deleteRecipientGroupById default %s", o._statusCode, payload)
}

func (o *DeleteRecipientGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *DeleteRecipientGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
