// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewDeleteTopologySourceParams creates a new DeleteTopologySourceParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteTopologySourceParams() *DeleteTopologySourceParams {
	return &DeleteTopologySourceParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteTopologySourceParamsWithTimeout creates a new DeleteTopologySourceParams object
// with the ability to set a timeout on a request.
func NewDeleteTopologySourceParamsWithTimeout(timeout time.Duration) *DeleteTopologySourceParams {
	return &DeleteTopologySourceParams{
		timeout: timeout,
	}
}

// NewDeleteTopologySourceParamsWithContext creates a new DeleteTopologySourceParams object
// with the ability to set a context for a request.
func NewDeleteTopologySourceParamsWithContext(ctx context.Context) *DeleteTopologySourceParams {
	return &DeleteTopologySourceParams{
		Context: ctx,
	}
}

// NewDeleteTopologySourceParamsWithHTTPClient creates a new DeleteTopologySourceParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteTopologySourceParamsWithHTTPClient(client *http.Client) *DeleteTopologySourceParams {
	return &DeleteTopologySourceParams{
		HTTPClient: client,
	}
}

/*
DeleteTopologySourceParams contains all the parameters to send to the API endpoint

	for the delete topology source operation.

	Typically these are written to a http.Request.
*/
type DeleteTopologySourceParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// ID.
	//
	// Format: int32
	ID int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete topology source params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteTopologySourceParams) WithDefaults() *DeleteTopologySourceParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete topology source params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteTopologySourceParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := DeleteTopologySourceParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the delete topology source params
func (o *DeleteTopologySourceParams) WithTimeout(timeout time.Duration) *DeleteTopologySourceParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete topology source params
func (o *DeleteTopologySourceParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete topology source params
func (o *DeleteTopologySourceParams) WithContext(ctx context.Context) *DeleteTopologySourceParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete topology source params
func (o *DeleteTopologySourceParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete topology source params
func (o *DeleteTopologySourceParams) WithHTTPClient(client *http.Client) *DeleteTopologySourceParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete topology source params
func (o *DeleteTopologySourceParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the delete topology source params
func (o *DeleteTopologySourceParams) WithUserAgent(userAgent *string) *DeleteTopologySourceParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the delete topology source params
func (o *DeleteTopologySourceParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithID adds the id to the delete topology source params
func (o *DeleteTopologySourceParams) WithID(id int32) *DeleteTopologySourceParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the delete topology source params
func (o *DeleteTopologySourceParams) SetID(id int32) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteTopologySourceParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt32(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
