// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// DeleteTopologySourceReader is a Reader for the DeleteTopologySource structure.
type DeleteTopologySourceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteTopologySourceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteTopologySourceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewDeleteTopologySourceTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewDeleteTopologySourceDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteTopologySourceOK creates a DeleteTopologySourceOK with default headers values
func NewDeleteTopologySourceOK() *DeleteTopologySourceOK {
	return &DeleteTopologySourceOK{}
}

/*
DeleteTopologySourceOK describes a response with status code 200, with default header values.

successful operation
*/
type DeleteTopologySourceOK struct {
	Payload interface{}
}

// IsSuccess returns true when this delete topology source o k response has a 2xx status code
func (o *DeleteTopologySourceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete topology source o k response has a 3xx status code
func (o *DeleteTopologySourceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete topology source o k response has a 4xx status code
func (o *DeleteTopologySourceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete topology source o k response has a 5xx status code
func (o *DeleteTopologySourceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete topology source o k response a status code equal to that given
func (o *DeleteTopologySourceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the delete topology source o k response
func (o *DeleteTopologySourceOK) Code() int {
	return 200
}

func (o *DeleteTopologySourceOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/topologysources/{id}][%d] deleteTopologySourceOK %s", 200, payload)
}

func (o *DeleteTopologySourceOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/topologysources/{id}][%d] deleteTopologySourceOK %s", 200, payload)
}

func (o *DeleteTopologySourceOK) GetPayload() interface{} {
	return o.Payload
}

func (o *DeleteTopologySourceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteTopologySourceTooManyRequests creates a DeleteTopologySourceTooManyRequests with default headers values
func NewDeleteTopologySourceTooManyRequests() *DeleteTopologySourceTooManyRequests {
	return &DeleteTopologySourceTooManyRequests{}
}

/*
DeleteTopologySourceTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type DeleteTopologySourceTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this delete topology source too many requests response has a 2xx status code
func (o *DeleteTopologySourceTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete topology source too many requests response has a 3xx status code
func (o *DeleteTopologySourceTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete topology source too many requests response has a 4xx status code
func (o *DeleteTopologySourceTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete topology source too many requests response has a 5xx status code
func (o *DeleteTopologySourceTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this delete topology source too many requests response a status code equal to that given
func (o *DeleteTopologySourceTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the delete topology source too many requests response
func (o *DeleteTopologySourceTooManyRequests) Code() int {
	return 429
}

func (o *DeleteTopologySourceTooManyRequests) Error() string {
	return fmt.Sprintf("[DELETE /setting/topologysources/{id}][%d] deleteTopologySourceTooManyRequests", 429)
}

func (o *DeleteTopologySourceTooManyRequests) String() string {
	return fmt.Sprintf("[DELETE /setting/topologysources/{id}][%d] deleteTopologySourceTooManyRequests", 429)
}

func (o *DeleteTopologySourceTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewDeleteTopologySourceDefault creates a DeleteTopologySourceDefault with default headers values
func NewDeleteTopologySourceDefault(code int) *DeleteTopologySourceDefault {
	return &DeleteTopologySourceDefault{
		_statusCode: code,
	}
}

/*
DeleteTopologySourceDefault describes a response with status code -1, with default header values.

Error
*/
type DeleteTopologySourceDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this delete topology source default response has a 2xx status code
func (o *DeleteTopologySourceDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this delete topology source default response has a 3xx status code
func (o *DeleteTopologySourceDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this delete topology source default response has a 4xx status code
func (o *DeleteTopologySourceDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this delete topology source default response has a 5xx status code
func (o *DeleteTopologySourceDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this delete topology source default response a status code equal to that given
func (o *DeleteTopologySourceDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the delete topology source default response
func (o *DeleteTopologySourceDefault) Code() int {
	return o._statusCode
}

func (o *DeleteTopologySourceDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/topologysources/{id}][%d] deleteTopologySource default %s", o._statusCode, payload)
}

func (o *DeleteTopologySourceDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /setting/topologysources/{id}][%d] deleteTopologySource default %s", o._statusCode, payload)
}

func (o *DeleteTopologySourceDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *DeleteTopologySourceDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
