// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// DeleteWidgetByIDReader is a Reader for the DeleteWidgetByID structure.
type DeleteWidgetByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteWidgetByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteWidgetByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewDeleteWidgetByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewDeleteWidgetByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDeleteWidgetByIDOK creates a DeleteWidgetByIDOK with default headers values
func NewDeleteWidgetByIDOK() *DeleteWidgetByIDOK {
	return &DeleteWidgetByIDOK{}
}

/*
DeleteWidgetByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type DeleteWidgetByIDOK struct {
	Payload interface{}
}

// IsSuccess returns true when this delete widget by Id o k response has a 2xx status code
func (o *DeleteWidgetByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete widget by Id o k response has a 3xx status code
func (o *DeleteWidgetByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete widget by Id o k response has a 4xx status code
func (o *DeleteWidgetByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete widget by Id o k response has a 5xx status code
func (o *DeleteWidgetByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete widget by Id o k response a status code equal to that given
func (o *DeleteWidgetByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the delete widget by Id o k response
func (o *DeleteWidgetByIDOK) Code() int {
	return 200
}

func (o *DeleteWidgetByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /dashboard/widgets/{id}][%d] deleteWidgetByIdOK %s", 200, payload)
}

func (o *DeleteWidgetByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /dashboard/widgets/{id}][%d] deleteWidgetByIdOK %s", 200, payload)
}

func (o *DeleteWidgetByIDOK) GetPayload() interface{} {
	return o.Payload
}

func (o *DeleteWidgetByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteWidgetByIDTooManyRequests creates a DeleteWidgetByIDTooManyRequests with default headers values
func NewDeleteWidgetByIDTooManyRequests() *DeleteWidgetByIDTooManyRequests {
	return &DeleteWidgetByIDTooManyRequests{}
}

/*
DeleteWidgetByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type DeleteWidgetByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this delete widget by Id too many requests response has a 2xx status code
func (o *DeleteWidgetByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete widget by Id too many requests response has a 3xx status code
func (o *DeleteWidgetByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete widget by Id too many requests response has a 4xx status code
func (o *DeleteWidgetByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete widget by Id too many requests response has a 5xx status code
func (o *DeleteWidgetByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this delete widget by Id too many requests response a status code equal to that given
func (o *DeleteWidgetByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the delete widget by Id too many requests response
func (o *DeleteWidgetByIDTooManyRequests) Code() int {
	return 429
}

func (o *DeleteWidgetByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[DELETE /dashboard/widgets/{id}][%d] deleteWidgetByIdTooManyRequests", 429)
}

func (o *DeleteWidgetByIDTooManyRequests) String() string {
	return fmt.Sprintf("[DELETE /dashboard/widgets/{id}][%d] deleteWidgetByIdTooManyRequests", 429)
}

func (o *DeleteWidgetByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewDeleteWidgetByIDDefault creates a DeleteWidgetByIDDefault with default headers values
func NewDeleteWidgetByIDDefault(code int) *DeleteWidgetByIDDefault {
	return &DeleteWidgetByIDDefault{
		_statusCode: code,
	}
}

/*
DeleteWidgetByIDDefault describes a response with status code -1, with default header values.

Error
*/
type DeleteWidgetByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this delete widget by Id default response has a 2xx status code
func (o *DeleteWidgetByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this delete widget by Id default response has a 3xx status code
func (o *DeleteWidgetByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this delete widget by Id default response has a 4xx status code
func (o *DeleteWidgetByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this delete widget by Id default response has a 5xx status code
func (o *DeleteWidgetByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this delete widget by Id default response a status code equal to that given
func (o *DeleteWidgetByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the delete widget by Id default response
func (o *DeleteWidgetByIDDefault) Code() int {
	return o._statusCode
}

func (o *DeleteWidgetByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /dashboard/widgets/{id}][%d] deleteWidgetById default %s", o._statusCode, payload)
}

func (o *DeleteWidgetByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[DELETE /dashboard/widgets/{id}][%d] deleteWidgetById default %s", o._statusCode, payload)
}

func (o *DeleteWidgetByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *DeleteWidgetByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
