// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// DiscoverSubscriptionsReader is a Reader for the DiscoverSubscriptions structure.
type DiscoverSubscriptionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DiscoverSubscriptionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDiscoverSubscriptionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewDiscoverSubscriptionsTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewDiscoverSubscriptionsDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewDiscoverSubscriptionsOK creates a DiscoverSubscriptionsOK with default headers values
func NewDiscoverSubscriptionsOK() *DiscoverSubscriptionsOK {
	return &DiscoverSubscriptionsOK{}
}

/*
DiscoverSubscriptionsOK describes a response with status code 200, with default header values.

successful operation
*/
type DiscoverSubscriptionsOK struct {
	Payload *models.AzureSubscriptionIDPaginationResponse
}

// IsSuccess returns true when this discover subscriptions o k response has a 2xx status code
func (o *DiscoverSubscriptionsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this discover subscriptions o k response has a 3xx status code
func (o *DiscoverSubscriptionsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this discover subscriptions o k response has a 4xx status code
func (o *DiscoverSubscriptionsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this discover subscriptions o k response has a 5xx status code
func (o *DiscoverSubscriptionsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this discover subscriptions o k response a status code equal to that given
func (o *DiscoverSubscriptionsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the discover subscriptions o k response
func (o *DiscoverSubscriptionsOK) Code() int {
	return 200
}

func (o *DiscoverSubscriptionsOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /azure/functions/discoverSubscriptions][%d] discoverSubscriptionsOK %s", 200, payload)
}

func (o *DiscoverSubscriptionsOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /azure/functions/discoverSubscriptions][%d] discoverSubscriptionsOK %s", 200, payload)
}

func (o *DiscoverSubscriptionsOK) GetPayload() *models.AzureSubscriptionIDPaginationResponse {
	return o.Payload
}

func (o *DiscoverSubscriptionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AzureSubscriptionIDPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDiscoverSubscriptionsTooManyRequests creates a DiscoverSubscriptionsTooManyRequests with default headers values
func NewDiscoverSubscriptionsTooManyRequests() *DiscoverSubscriptionsTooManyRequests {
	return &DiscoverSubscriptionsTooManyRequests{}
}

/*
DiscoverSubscriptionsTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type DiscoverSubscriptionsTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this discover subscriptions too many requests response has a 2xx status code
func (o *DiscoverSubscriptionsTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this discover subscriptions too many requests response has a 3xx status code
func (o *DiscoverSubscriptionsTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this discover subscriptions too many requests response has a 4xx status code
func (o *DiscoverSubscriptionsTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this discover subscriptions too many requests response has a 5xx status code
func (o *DiscoverSubscriptionsTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this discover subscriptions too many requests response a status code equal to that given
func (o *DiscoverSubscriptionsTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the discover subscriptions too many requests response
func (o *DiscoverSubscriptionsTooManyRequests) Code() int {
	return 429
}

func (o *DiscoverSubscriptionsTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /azure/functions/discoverSubscriptions][%d] discoverSubscriptionsTooManyRequests", 429)
}

func (o *DiscoverSubscriptionsTooManyRequests) String() string {
	return fmt.Sprintf("[POST /azure/functions/discoverSubscriptions][%d] discoverSubscriptionsTooManyRequests", 429)
}

func (o *DiscoverSubscriptionsTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewDiscoverSubscriptionsDefault creates a DiscoverSubscriptionsDefault with default headers values
func NewDiscoverSubscriptionsDefault(code int) *DiscoverSubscriptionsDefault {
	return &DiscoverSubscriptionsDefault{
		_statusCode: code,
	}
}

/*
DiscoverSubscriptionsDefault describes a response with status code -1, with default header values.

Error
*/
type DiscoverSubscriptionsDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this discover subscriptions default response has a 2xx status code
func (o *DiscoverSubscriptionsDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this discover subscriptions default response has a 3xx status code
func (o *DiscoverSubscriptionsDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this discover subscriptions default response has a 4xx status code
func (o *DiscoverSubscriptionsDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this discover subscriptions default response has a 5xx status code
func (o *DiscoverSubscriptionsDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this discover subscriptions default response a status code equal to that given
func (o *DiscoverSubscriptionsDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the discover subscriptions default response
func (o *DiscoverSubscriptionsDefault) Code() int {
	return o._statusCode
}

func (o *DiscoverSubscriptionsDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /azure/functions/discoverSubscriptions][%d] discoverSubscriptions default %s", o._statusCode, payload)
}

func (o *DiscoverSubscriptionsDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /azure/functions/discoverSubscriptions][%d] discoverSubscriptions default %s", o._statusCode, payload)
}

func (o *DiscoverSubscriptionsDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *DiscoverSubscriptionsDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
