// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetAccessGroupListJSONReader is a Reader for the GetAccessGroupListJSON structure.
type GetAccessGroupListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAccessGroupListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAccessGroupListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAccessGroupListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAccessGroupListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAccessGroupListJSONOK creates a GetAccessGroupListJSONOK with default headers values
func NewGetAccessGroupListJSONOK() *GetAccessGroupListJSONOK {
	return &GetAccessGroupListJSONOK{}
}

/*
GetAccessGroupListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAccessGroupListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get access group list Json o k response has a 2xx status code
func (o *GetAccessGroupListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get access group list Json o k response has a 3xx status code
func (o *GetAccessGroupListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get access group list Json o k response has a 4xx status code
func (o *GetAccessGroupListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get access group list Json o k response has a 5xx status code
func (o *GetAccessGroupListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get access group list Json o k response a status code equal to that given
func (o *GetAccessGroupListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get access group list Json o k response
func (o *GetAccessGroupListJSONOK) Code() int {
	return 200
}

func (o *GetAccessGroupListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accessgroup?__json=][%d] getAccessGroupListJsonOK %s", 200, payload)
}

func (o *GetAccessGroupListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accessgroup?__json=][%d] getAccessGroupListJsonOK %s", 200, payload)
}

func (o *GetAccessGroupListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetAccessGroupListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccessGroupListJSONTooManyRequests creates a GetAccessGroupListJSONTooManyRequests with default headers values
func NewGetAccessGroupListJSONTooManyRequests() *GetAccessGroupListJSONTooManyRequests {
	return &GetAccessGroupListJSONTooManyRequests{}
}

/*
GetAccessGroupListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAccessGroupListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get access group list Json too many requests response has a 2xx status code
func (o *GetAccessGroupListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get access group list Json too many requests response has a 3xx status code
func (o *GetAccessGroupListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get access group list Json too many requests response has a 4xx status code
func (o *GetAccessGroupListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get access group list Json too many requests response has a 5xx status code
func (o *GetAccessGroupListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get access group list Json too many requests response a status code equal to that given
func (o *GetAccessGroupListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get access group list Json too many requests response
func (o *GetAccessGroupListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetAccessGroupListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/accessgroup?__json=][%d] getAccessGroupListJsonTooManyRequests", 429)
}

func (o *GetAccessGroupListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/accessgroup?__json=][%d] getAccessGroupListJsonTooManyRequests", 429)
}

func (o *GetAccessGroupListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAccessGroupListJSONDefault creates a GetAccessGroupListJSONDefault with default headers values
func NewGetAccessGroupListJSONDefault(code int) *GetAccessGroupListJSONDefault {
	return &GetAccessGroupListJSONDefault{
		_statusCode: code,
	}
}

/*
GetAccessGroupListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetAccessGroupListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get access group list Json default response has a 2xx status code
func (o *GetAccessGroupListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get access group list Json default response has a 3xx status code
func (o *GetAccessGroupListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get access group list Json default response has a 4xx status code
func (o *GetAccessGroupListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get access group list Json default response has a 5xx status code
func (o *GetAccessGroupListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get access group list Json default response a status code equal to that given
func (o *GetAccessGroupListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get access group list Json default response
func (o *GetAccessGroupListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetAccessGroupListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accessgroup?__json=][%d] getAccessGroupListJson default %s", o._statusCode, payload)
}

func (o *GetAccessGroupListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accessgroup?__json=][%d] getAccessGroupListJson default %s", o._statusCode, payload)
}

func (o *GetAccessGroupListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAccessGroupListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
