// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetAccessGroupListReader is a Reader for the GetAccessGroupList structure.
type GetAccessGroupListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAccessGroupListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAccessGroupListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAccessGroupListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAccessGroupListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAccessGroupListOK creates a GetAccessGroupListOK with default headers values
func NewGetAccessGroupListOK() *GetAccessGroupListOK {
	return &GetAccessGroupListOK{}
}

/*
GetAccessGroupListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAccessGroupListOK struct {
	Payload *models.AccessGroupPaginationResponse
}

// IsSuccess returns true when this get access group list o k response has a 2xx status code
func (o *GetAccessGroupListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get access group list o k response has a 3xx status code
func (o *GetAccessGroupListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get access group list o k response has a 4xx status code
func (o *GetAccessGroupListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get access group list o k response has a 5xx status code
func (o *GetAccessGroupListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get access group list o k response a status code equal to that given
func (o *GetAccessGroupListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get access group list o k response
func (o *GetAccessGroupListOK) Code() int {
	return 200
}

func (o *GetAccessGroupListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accessgroup][%d] getAccessGroupListOK %s", 200, payload)
}

func (o *GetAccessGroupListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accessgroup][%d] getAccessGroupListOK %s", 200, payload)
}

func (o *GetAccessGroupListOK) GetPayload() *models.AccessGroupPaginationResponse {
	return o.Payload
}

func (o *GetAccessGroupListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AccessGroupPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAccessGroupListTooManyRequests creates a GetAccessGroupListTooManyRequests with default headers values
func NewGetAccessGroupListTooManyRequests() *GetAccessGroupListTooManyRequests {
	return &GetAccessGroupListTooManyRequests{}
}

/*
GetAccessGroupListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAccessGroupListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get access group list too many requests response has a 2xx status code
func (o *GetAccessGroupListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get access group list too many requests response has a 3xx status code
func (o *GetAccessGroupListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get access group list too many requests response has a 4xx status code
func (o *GetAccessGroupListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get access group list too many requests response has a 5xx status code
func (o *GetAccessGroupListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get access group list too many requests response a status code equal to that given
func (o *GetAccessGroupListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get access group list too many requests response
func (o *GetAccessGroupListTooManyRequests) Code() int {
	return 429
}

func (o *GetAccessGroupListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/accessgroup][%d] getAccessGroupListTooManyRequests", 429)
}

func (o *GetAccessGroupListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/accessgroup][%d] getAccessGroupListTooManyRequests", 429)
}

func (o *GetAccessGroupListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAccessGroupListDefault creates a GetAccessGroupListDefault with default headers values
func NewGetAccessGroupListDefault(code int) *GetAccessGroupListDefault {
	return &GetAccessGroupListDefault{
		_statusCode: code,
	}
}

/*
GetAccessGroupListDefault describes a response with status code -1, with default header values.

Error
*/
type GetAccessGroupListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get access group list default response has a 2xx status code
func (o *GetAccessGroupListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get access group list default response has a 3xx status code
func (o *GetAccessGroupListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get access group list default response has a 4xx status code
func (o *GetAccessGroupListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get access group list default response has a 5xx status code
func (o *GetAccessGroupListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get access group list default response a status code equal to that given
func (o *GetAccessGroupListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get access group list default response
func (o *GetAccessGroupListDefault) Code() int {
	return o._statusCode
}

func (o *GetAccessGroupListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accessgroup][%d] getAccessGroupList default %s", o._statusCode, payload)
}

func (o *GetAccessGroupListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/accessgroup][%d] getAccessGroupList default %s", o._statusCode, payload)
}

func (o *GetAccessGroupListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAccessGroupListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
