// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetAdminByIDJSONReader is a Reader for the GetAdminByIDJSON structure.
type GetAdminByIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAdminByIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAdminByIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAdminByIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAdminByIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAdminByIDJSONOK creates a GetAdminByIDJSONOK with default headers values
func NewGetAdminByIDJSONOK() *GetAdminByIDJSONOK {
	return &GetAdminByIDJSONOK{}
}

/*
GetAdminByIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAdminByIDJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get admin by Id Json o k response has a 2xx status code
func (o *GetAdminByIDJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get admin by Id Json o k response has a 3xx status code
func (o *GetAdminByIDJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get admin by Id Json o k response has a 4xx status code
func (o *GetAdminByIDJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get admin by Id Json o k response has a 5xx status code
func (o *GetAdminByIDJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get admin by Id Json o k response a status code equal to that given
func (o *GetAdminByIDJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get admin by Id Json o k response
func (o *GetAdminByIDJSONOK) Code() int {
	return 200
}

func (o *GetAdminByIDJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins/{id}?__json=][%d] getAdminByIdJsonOK %s", 200, payload)
}

func (o *GetAdminByIDJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins/{id}?__json=][%d] getAdminByIdJsonOK %s", 200, payload)
}

func (o *GetAdminByIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetAdminByIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAdminByIDJSONTooManyRequests creates a GetAdminByIDJSONTooManyRequests with default headers values
func NewGetAdminByIDJSONTooManyRequests() *GetAdminByIDJSONTooManyRequests {
	return &GetAdminByIDJSONTooManyRequests{}
}

/*
GetAdminByIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAdminByIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get admin by Id Json too many requests response has a 2xx status code
func (o *GetAdminByIDJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get admin by Id Json too many requests response has a 3xx status code
func (o *GetAdminByIDJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get admin by Id Json too many requests response has a 4xx status code
func (o *GetAdminByIDJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get admin by Id Json too many requests response has a 5xx status code
func (o *GetAdminByIDJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get admin by Id Json too many requests response a status code equal to that given
func (o *GetAdminByIDJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get admin by Id Json too many requests response
func (o *GetAdminByIDJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetAdminByIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/admins/{id}?__json=][%d] getAdminByIdJsonTooManyRequests", 429)
}

func (o *GetAdminByIDJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/admins/{id}?__json=][%d] getAdminByIdJsonTooManyRequests", 429)
}

func (o *GetAdminByIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAdminByIDJSONDefault creates a GetAdminByIDJSONDefault with default headers values
func NewGetAdminByIDJSONDefault(code int) *GetAdminByIDJSONDefault {
	return &GetAdminByIDJSONDefault{
		_statusCode: code,
	}
}

/*
GetAdminByIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetAdminByIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get admin by Id Json default response has a 2xx status code
func (o *GetAdminByIDJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get admin by Id Json default response has a 3xx status code
func (o *GetAdminByIDJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get admin by Id Json default response has a 4xx status code
func (o *GetAdminByIDJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get admin by Id Json default response has a 5xx status code
func (o *GetAdminByIDJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get admin by Id Json default response a status code equal to that given
func (o *GetAdminByIDJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get admin by Id Json default response
func (o *GetAdminByIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetAdminByIDJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins/{id}?__json=][%d] getAdminByIdJson default %s", o._statusCode, payload)
}

func (o *GetAdminByIDJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins/{id}?__json=][%d] getAdminByIdJson default %s", o._statusCode, payload)
}

func (o *GetAdminByIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAdminByIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
