// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetAdminListReader is a Reader for the GetAdminList structure.
type GetAdminListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAdminListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAdminListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAdminListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAdminListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAdminListOK creates a GetAdminListOK with default headers values
func NewGetAdminListOK() *GetAdminListOK {
	return &GetAdminListOK{}
}

/*
GetAdminListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAdminListOK struct {
	Payload *models.AdminPaginationResponse
}

// IsSuccess returns true when this get admin list o k response has a 2xx status code
func (o *GetAdminListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get admin list o k response has a 3xx status code
func (o *GetAdminListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get admin list o k response has a 4xx status code
func (o *GetAdminListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get admin list o k response has a 5xx status code
func (o *GetAdminListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get admin list o k response a status code equal to that given
func (o *GetAdminListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get admin list o k response
func (o *GetAdminListOK) Code() int {
	return 200
}

func (o *GetAdminListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins][%d] getAdminListOK %s", 200, payload)
}

func (o *GetAdminListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins][%d] getAdminListOK %s", 200, payload)
}

func (o *GetAdminListOK) GetPayload() *models.AdminPaginationResponse {
	return o.Payload
}

func (o *GetAdminListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AdminPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAdminListTooManyRequests creates a GetAdminListTooManyRequests with default headers values
func NewGetAdminListTooManyRequests() *GetAdminListTooManyRequests {
	return &GetAdminListTooManyRequests{}
}

/*
GetAdminListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAdminListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get admin list too many requests response has a 2xx status code
func (o *GetAdminListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get admin list too many requests response has a 3xx status code
func (o *GetAdminListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get admin list too many requests response has a 4xx status code
func (o *GetAdminListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get admin list too many requests response has a 5xx status code
func (o *GetAdminListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get admin list too many requests response a status code equal to that given
func (o *GetAdminListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get admin list too many requests response
func (o *GetAdminListTooManyRequests) Code() int {
	return 429
}

func (o *GetAdminListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/admins][%d] getAdminListTooManyRequests", 429)
}

func (o *GetAdminListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/admins][%d] getAdminListTooManyRequests", 429)
}

func (o *GetAdminListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAdminListDefault creates a GetAdminListDefault with default headers values
func NewGetAdminListDefault(code int) *GetAdminListDefault {
	return &GetAdminListDefault{
		_statusCode: code,
	}
}

/*
GetAdminListDefault describes a response with status code -1, with default header values.

Error
*/
type GetAdminListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get admin list default response has a 2xx status code
func (o *GetAdminListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get admin list default response has a 3xx status code
func (o *GetAdminListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get admin list default response has a 4xx status code
func (o *GetAdminListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get admin list default response has a 5xx status code
func (o *GetAdminListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get admin list default response a status code equal to that given
func (o *GetAdminListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get admin list default response
func (o *GetAdminListDefault) Code() int {
	return o._statusCode
}

func (o *GetAdminListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins][%d] getAdminList default %s", o._statusCode, payload)
}

func (o *GetAdminListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/admins][%d] getAdminList default %s", o._statusCode, payload)
}

func (o *GetAdminListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAdminListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
