// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetAppliesToFunctionListReader is a Reader for the GetAppliesToFunctionList structure.
type GetAppliesToFunctionListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetAppliesToFunctionListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetAppliesToFunctionListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetAppliesToFunctionListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetAppliesToFunctionListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetAppliesToFunctionListOK creates a GetAppliesToFunctionListOK with default headers values
func NewGetAppliesToFunctionListOK() *GetAppliesToFunctionListOK {
	return &GetAppliesToFunctionListOK{}
}

/*
GetAppliesToFunctionListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetAppliesToFunctionListOK struct {
	Payload *models.RestAppliesToFunctionPaginationResponse
}

// IsSuccess returns true when this get applies to function list o k response has a 2xx status code
func (o *GetAppliesToFunctionListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get applies to function list o k response has a 3xx status code
func (o *GetAppliesToFunctionListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get applies to function list o k response has a 4xx status code
func (o *GetAppliesToFunctionListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get applies to function list o k response has a 5xx status code
func (o *GetAppliesToFunctionListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get applies to function list o k response a status code equal to that given
func (o *GetAppliesToFunctionListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get applies to function list o k response
func (o *GetAppliesToFunctionListOK) Code() int {
	return 200
}

func (o *GetAppliesToFunctionListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/functions][%d] getAppliesToFunctionListOK %s", 200, payload)
}

func (o *GetAppliesToFunctionListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/functions][%d] getAppliesToFunctionListOK %s", 200, payload)
}

func (o *GetAppliesToFunctionListOK) GetPayload() *models.RestAppliesToFunctionPaginationResponse {
	return o.Payload
}

func (o *GetAppliesToFunctionListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.RestAppliesToFunctionPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetAppliesToFunctionListTooManyRequests creates a GetAppliesToFunctionListTooManyRequests with default headers values
func NewGetAppliesToFunctionListTooManyRequests() *GetAppliesToFunctionListTooManyRequests {
	return &GetAppliesToFunctionListTooManyRequests{}
}

/*
GetAppliesToFunctionListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetAppliesToFunctionListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get applies to function list too many requests response has a 2xx status code
func (o *GetAppliesToFunctionListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get applies to function list too many requests response has a 3xx status code
func (o *GetAppliesToFunctionListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get applies to function list too many requests response has a 4xx status code
func (o *GetAppliesToFunctionListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get applies to function list too many requests response has a 5xx status code
func (o *GetAppliesToFunctionListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get applies to function list too many requests response a status code equal to that given
func (o *GetAppliesToFunctionListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get applies to function list too many requests response
func (o *GetAppliesToFunctionListTooManyRequests) Code() int {
	return 429
}

func (o *GetAppliesToFunctionListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/functions][%d] getAppliesToFunctionListTooManyRequests", 429)
}

func (o *GetAppliesToFunctionListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/functions][%d] getAppliesToFunctionListTooManyRequests", 429)
}

func (o *GetAppliesToFunctionListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetAppliesToFunctionListDefault creates a GetAppliesToFunctionListDefault with default headers values
func NewGetAppliesToFunctionListDefault(code int) *GetAppliesToFunctionListDefault {
	return &GetAppliesToFunctionListDefault{
		_statusCode: code,
	}
}

/*
GetAppliesToFunctionListDefault describes a response with status code -1, with default header values.

Error
*/
type GetAppliesToFunctionListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get applies to function list default response has a 2xx status code
func (o *GetAppliesToFunctionListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get applies to function list default response has a 3xx status code
func (o *GetAppliesToFunctionListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get applies to function list default response has a 4xx status code
func (o *GetAppliesToFunctionListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get applies to function list default response has a 5xx status code
func (o *GetAppliesToFunctionListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get applies to function list default response a status code equal to that given
func (o *GetAppliesToFunctionListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get applies to function list default response
func (o *GetAppliesToFunctionListDefault) Code() int {
	return o._statusCode
}

func (o *GetAppliesToFunctionListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/functions][%d] getAppliesToFunctionList default %s", o._statusCode, payload)
}

func (o *GetAppliesToFunctionListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/functions][%d] getAppliesToFunctionList default %s", o._statusCode, payload)
}

func (o *GetAppliesToFunctionListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetAppliesToFunctionListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
