// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetCollectorInstallerReader is a Reader for the GetCollectorInstaller structure.
type GetCollectorInstallerReader struct {
	formats strfmt.Registry
	writer  io.Writer
}

// ReadResponse reads a server response into the received o.
func (o *GetCollectorInstallerReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetCollectorInstallerOK(o.writer)
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetCollectorInstallerTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetCollectorInstallerDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetCollectorInstallerOK creates a GetCollectorInstallerOK with default headers values
func NewGetCollectorInstallerOK(writer io.Writer) *GetCollectorInstallerOK {
	return &GetCollectorInstallerOK{

		Payload: writer,
	}
}

/*
GetCollectorInstallerOK describes a response with status code 200, with default header values.

successful operation
*/
type GetCollectorInstallerOK struct {
	Payload io.Writer
}

// IsSuccess returns true when this get collector installer o k response has a 2xx status code
func (o *GetCollectorInstallerOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get collector installer o k response has a 3xx status code
func (o *GetCollectorInstallerOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get collector installer o k response has a 4xx status code
func (o *GetCollectorInstallerOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get collector installer o k response has a 5xx status code
func (o *GetCollectorInstallerOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get collector installer o k response a status code equal to that given
func (o *GetCollectorInstallerOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get collector installer o k response
func (o *GetCollectorInstallerOK) Code() int {
	return 200
}

func (o *GetCollectorInstallerOK) Error() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/{collectorId}/installers/{osAndArch}][%d] getCollectorInstallerOK", 200)
}

func (o *GetCollectorInstallerOK) String() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/{collectorId}/installers/{osAndArch}][%d] getCollectorInstallerOK", 200)
}

func (o *GetCollectorInstallerOK) GetPayload() io.Writer {
	return o.Payload
}

func (o *GetCollectorInstallerOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCollectorInstallerTooManyRequests creates a GetCollectorInstallerTooManyRequests with default headers values
func NewGetCollectorInstallerTooManyRequests() *GetCollectorInstallerTooManyRequests {
	return &GetCollectorInstallerTooManyRequests{}
}

/*
GetCollectorInstallerTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetCollectorInstallerTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get collector installer too many requests response has a 2xx status code
func (o *GetCollectorInstallerTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get collector installer too many requests response has a 3xx status code
func (o *GetCollectorInstallerTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get collector installer too many requests response has a 4xx status code
func (o *GetCollectorInstallerTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get collector installer too many requests response has a 5xx status code
func (o *GetCollectorInstallerTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get collector installer too many requests response a status code equal to that given
func (o *GetCollectorInstallerTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get collector installer too many requests response
func (o *GetCollectorInstallerTooManyRequests) Code() int {
	return 429
}

func (o *GetCollectorInstallerTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/{collectorId}/installers/{osAndArch}][%d] getCollectorInstallerTooManyRequests", 429)
}

func (o *GetCollectorInstallerTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/collector/collectors/{collectorId}/installers/{osAndArch}][%d] getCollectorInstallerTooManyRequests", 429)
}

func (o *GetCollectorInstallerTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetCollectorInstallerDefault creates a GetCollectorInstallerDefault with default headers values
func NewGetCollectorInstallerDefault(code int) *GetCollectorInstallerDefault {
	return &GetCollectorInstallerDefault{
		_statusCode: code,
	}
}

/*
GetCollectorInstallerDefault describes a response with status code -1, with default header values.

Error
*/
type GetCollectorInstallerDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get collector installer default response has a 2xx status code
func (o *GetCollectorInstallerDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get collector installer default response has a 3xx status code
func (o *GetCollectorInstallerDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get collector installer default response has a 4xx status code
func (o *GetCollectorInstallerDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get collector installer default response has a 5xx status code
func (o *GetCollectorInstallerDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get collector installer default response a status code equal to that given
func (o *GetCollectorInstallerDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get collector installer default response
func (o *GetCollectorInstallerDefault) Code() int {
	return o._statusCode
}

func (o *GetCollectorInstallerDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/collector/collectors/{collectorId}/installers/{osAndArch}][%d] getCollectorInstaller default %s", o._statusCode, payload)
}

func (o *GetCollectorInstallerDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/collector/collectors/{collectorId}/installers/{osAndArch}][%d] getCollectorInstaller default %s", o._statusCode, payload)
}

func (o *GetCollectorInstallerDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetCollectorInstallerDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
