// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetConfigSourceListJSONReader is a Reader for the GetConfigSourceListJSON structure.
type GetConfigSourceListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetConfigSourceListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetConfigSourceListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetConfigSourceListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetConfigSourceListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetConfigSourceListJSONOK creates a GetConfigSourceListJSONOK with default headers values
func NewGetConfigSourceListJSONOK() *GetConfigSourceListJSONOK {
	return &GetConfigSourceListJSONOK{}
}

/*
GetConfigSourceListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetConfigSourceListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get config source list Json o k response has a 2xx status code
func (o *GetConfigSourceListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get config source list Json o k response has a 3xx status code
func (o *GetConfigSourceListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get config source list Json o k response has a 4xx status code
func (o *GetConfigSourceListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get config source list Json o k response has a 5xx status code
func (o *GetConfigSourceListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get config source list Json o k response a status code equal to that given
func (o *GetConfigSourceListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get config source list Json o k response
func (o *GetConfigSourceListJSONOK) Code() int {
	return 200
}

func (o *GetConfigSourceListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/configsources?__json=][%d] getConfigSourceListJsonOK %s", 200, payload)
}

func (o *GetConfigSourceListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/configsources?__json=][%d] getConfigSourceListJsonOK %s", 200, payload)
}

func (o *GetConfigSourceListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetConfigSourceListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetConfigSourceListJSONTooManyRequests creates a GetConfigSourceListJSONTooManyRequests with default headers values
func NewGetConfigSourceListJSONTooManyRequests() *GetConfigSourceListJSONTooManyRequests {
	return &GetConfigSourceListJSONTooManyRequests{}
}

/*
GetConfigSourceListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetConfigSourceListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get config source list Json too many requests response has a 2xx status code
func (o *GetConfigSourceListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get config source list Json too many requests response has a 3xx status code
func (o *GetConfigSourceListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get config source list Json too many requests response has a 4xx status code
func (o *GetConfigSourceListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get config source list Json too many requests response has a 5xx status code
func (o *GetConfigSourceListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get config source list Json too many requests response a status code equal to that given
func (o *GetConfigSourceListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get config source list Json too many requests response
func (o *GetConfigSourceListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetConfigSourceListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/configsources?__json=][%d] getConfigSourceListJsonTooManyRequests", 429)
}

func (o *GetConfigSourceListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/configsources?__json=][%d] getConfigSourceListJsonTooManyRequests", 429)
}

func (o *GetConfigSourceListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetConfigSourceListJSONDefault creates a GetConfigSourceListJSONDefault with default headers values
func NewGetConfigSourceListJSONDefault(code int) *GetConfigSourceListJSONDefault {
	return &GetConfigSourceListJSONDefault{
		_statusCode: code,
	}
}

/*
GetConfigSourceListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetConfigSourceListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get config source list Json default response has a 2xx status code
func (o *GetConfigSourceListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get config source list Json default response has a 3xx status code
func (o *GetConfigSourceListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get config source list Json default response has a 4xx status code
func (o *GetConfigSourceListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get config source list Json default response has a 5xx status code
func (o *GetConfigSourceListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get config source list Json default response a status code equal to that given
func (o *GetConfigSourceListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get config source list Json default response
func (o *GetConfigSourceListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetConfigSourceListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/configsources?__json=][%d] getConfigSourceListJson default %s", o._statusCode, payload)
}

func (o *GetConfigSourceListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/configsources?__json=][%d] getConfigSourceListJson default %s", o._statusCode, payload)
}

func (o *GetConfigSourceListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetConfigSourceListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
