// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDataSourceOverviewGraphByIDReader is a Reader for the GetDataSourceOverviewGraphByID structure.
type GetDataSourceOverviewGraphByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDataSourceOverviewGraphByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDataSourceOverviewGraphByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDataSourceOverviewGraphByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDataSourceOverviewGraphByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDataSourceOverviewGraphByIDOK creates a GetDataSourceOverviewGraphByIDOK with default headers values
func NewGetDataSourceOverviewGraphByIDOK() *GetDataSourceOverviewGraphByIDOK {
	return &GetDataSourceOverviewGraphByIDOK{}
}

/*
GetDataSourceOverviewGraphByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDataSourceOverviewGraphByIDOK struct {
	Payload *models.DataSourceOverviewGraph
}

// IsSuccess returns true when this get data source overview graph by Id o k response has a 2xx status code
func (o *GetDataSourceOverviewGraphByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get data source overview graph by Id o k response has a 3xx status code
func (o *GetDataSourceOverviewGraphByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get data source overview graph by Id o k response has a 4xx status code
func (o *GetDataSourceOverviewGraphByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get data source overview graph by Id o k response has a 5xx status code
func (o *GetDataSourceOverviewGraphByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get data source overview graph by Id o k response a status code equal to that given
func (o *GetDataSourceOverviewGraphByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get data source overview graph by Id o k response
func (o *GetDataSourceOverviewGraphByIDOK) Code() int {
	return 200
}

func (o *GetDataSourceOverviewGraphByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources/{dsId}/ographs/{id}][%d] getDataSourceOverviewGraphByIdOK %s", 200, payload)
}

func (o *GetDataSourceOverviewGraphByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources/{dsId}/ographs/{id}][%d] getDataSourceOverviewGraphByIdOK %s", 200, payload)
}

func (o *GetDataSourceOverviewGraphByIDOK) GetPayload() *models.DataSourceOverviewGraph {
	return o.Payload
}

func (o *GetDataSourceOverviewGraphByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DataSourceOverviewGraph)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDataSourceOverviewGraphByIDTooManyRequests creates a GetDataSourceOverviewGraphByIDTooManyRequests with default headers values
func NewGetDataSourceOverviewGraphByIDTooManyRequests() *GetDataSourceOverviewGraphByIDTooManyRequests {
	return &GetDataSourceOverviewGraphByIDTooManyRequests{}
}

/*
GetDataSourceOverviewGraphByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDataSourceOverviewGraphByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get data source overview graph by Id too many requests response has a 2xx status code
func (o *GetDataSourceOverviewGraphByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get data source overview graph by Id too many requests response has a 3xx status code
func (o *GetDataSourceOverviewGraphByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get data source overview graph by Id too many requests response has a 4xx status code
func (o *GetDataSourceOverviewGraphByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get data source overview graph by Id too many requests response has a 5xx status code
func (o *GetDataSourceOverviewGraphByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get data source overview graph by Id too many requests response a status code equal to that given
func (o *GetDataSourceOverviewGraphByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get data source overview graph by Id too many requests response
func (o *GetDataSourceOverviewGraphByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetDataSourceOverviewGraphByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/datasources/{dsId}/ographs/{id}][%d] getDataSourceOverviewGraphByIdTooManyRequests", 429)
}

func (o *GetDataSourceOverviewGraphByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/datasources/{dsId}/ographs/{id}][%d] getDataSourceOverviewGraphByIdTooManyRequests", 429)
}

func (o *GetDataSourceOverviewGraphByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDataSourceOverviewGraphByIDDefault creates a GetDataSourceOverviewGraphByIDDefault with default headers values
func NewGetDataSourceOverviewGraphByIDDefault(code int) *GetDataSourceOverviewGraphByIDDefault {
	return &GetDataSourceOverviewGraphByIDDefault{
		_statusCode: code,
	}
}

/*
GetDataSourceOverviewGraphByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetDataSourceOverviewGraphByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get data source overview graph by Id default response has a 2xx status code
func (o *GetDataSourceOverviewGraphByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get data source overview graph by Id default response has a 3xx status code
func (o *GetDataSourceOverviewGraphByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get data source overview graph by Id default response has a 4xx status code
func (o *GetDataSourceOverviewGraphByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get data source overview graph by Id default response has a 5xx status code
func (o *GetDataSourceOverviewGraphByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get data source overview graph by Id default response a status code equal to that given
func (o *GetDataSourceOverviewGraphByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get data source overview graph by Id default response
func (o *GetDataSourceOverviewGraphByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetDataSourceOverviewGraphByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources/{dsId}/ographs/{id}][%d] getDataSourceOverviewGraphById default %s", o._statusCode, payload)
}

func (o *GetDataSourceOverviewGraphByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources/{dsId}/ographs/{id}][%d] getDataSourceOverviewGraphById default %s", o._statusCode, payload)
}

func (o *GetDataSourceOverviewGraphByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDataSourceOverviewGraphByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
