// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDataSourceOverviewGraphListReader is a Reader for the GetDataSourceOverviewGraphList structure.
type GetDataSourceOverviewGraphListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDataSourceOverviewGraphListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDataSourceOverviewGraphListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDataSourceOverviewGraphListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDataSourceOverviewGraphListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDataSourceOverviewGraphListOK creates a GetDataSourceOverviewGraphListOK with default headers values
func NewGetDataSourceOverviewGraphListOK() *GetDataSourceOverviewGraphListOK {
	return &GetDataSourceOverviewGraphListOK{}
}

/*
GetDataSourceOverviewGraphListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDataSourceOverviewGraphListOK struct {
	Payload *models.DatasourceOverviewGraphPaginationResponse
}

// IsSuccess returns true when this get data source overview graph list o k response has a 2xx status code
func (o *GetDataSourceOverviewGraphListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get data source overview graph list o k response has a 3xx status code
func (o *GetDataSourceOverviewGraphListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get data source overview graph list o k response has a 4xx status code
func (o *GetDataSourceOverviewGraphListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get data source overview graph list o k response has a 5xx status code
func (o *GetDataSourceOverviewGraphListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get data source overview graph list o k response a status code equal to that given
func (o *GetDataSourceOverviewGraphListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get data source overview graph list o k response
func (o *GetDataSourceOverviewGraphListOK) Code() int {
	return 200
}

func (o *GetDataSourceOverviewGraphListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources/{dsId}/ographs][%d] getDataSourceOverviewGraphListOK %s", 200, payload)
}

func (o *GetDataSourceOverviewGraphListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources/{dsId}/ographs][%d] getDataSourceOverviewGraphListOK %s", 200, payload)
}

func (o *GetDataSourceOverviewGraphListOK) GetPayload() *models.DatasourceOverviewGraphPaginationResponse {
	return o.Payload
}

func (o *GetDataSourceOverviewGraphListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DatasourceOverviewGraphPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDataSourceOverviewGraphListTooManyRequests creates a GetDataSourceOverviewGraphListTooManyRequests with default headers values
func NewGetDataSourceOverviewGraphListTooManyRequests() *GetDataSourceOverviewGraphListTooManyRequests {
	return &GetDataSourceOverviewGraphListTooManyRequests{}
}

/*
GetDataSourceOverviewGraphListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDataSourceOverviewGraphListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get data source overview graph list too many requests response has a 2xx status code
func (o *GetDataSourceOverviewGraphListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get data source overview graph list too many requests response has a 3xx status code
func (o *GetDataSourceOverviewGraphListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get data source overview graph list too many requests response has a 4xx status code
func (o *GetDataSourceOverviewGraphListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get data source overview graph list too many requests response has a 5xx status code
func (o *GetDataSourceOverviewGraphListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get data source overview graph list too many requests response a status code equal to that given
func (o *GetDataSourceOverviewGraphListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get data source overview graph list too many requests response
func (o *GetDataSourceOverviewGraphListTooManyRequests) Code() int {
	return 429
}

func (o *GetDataSourceOverviewGraphListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/datasources/{dsId}/ographs][%d] getDataSourceOverviewGraphListTooManyRequests", 429)
}

func (o *GetDataSourceOverviewGraphListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/datasources/{dsId}/ographs][%d] getDataSourceOverviewGraphListTooManyRequests", 429)
}

func (o *GetDataSourceOverviewGraphListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDataSourceOverviewGraphListDefault creates a GetDataSourceOverviewGraphListDefault with default headers values
func NewGetDataSourceOverviewGraphListDefault(code int) *GetDataSourceOverviewGraphListDefault {
	return &GetDataSourceOverviewGraphListDefault{
		_statusCode: code,
	}
}

/*
GetDataSourceOverviewGraphListDefault describes a response with status code -1, with default header values.

Error
*/
type GetDataSourceOverviewGraphListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get data source overview graph list default response has a 2xx status code
func (o *GetDataSourceOverviewGraphListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get data source overview graph list default response has a 3xx status code
func (o *GetDataSourceOverviewGraphListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get data source overview graph list default response has a 4xx status code
func (o *GetDataSourceOverviewGraphListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get data source overview graph list default response has a 5xx status code
func (o *GetDataSourceOverviewGraphListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get data source overview graph list default response a status code equal to that given
func (o *GetDataSourceOverviewGraphListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get data source overview graph list default response
func (o *GetDataSourceOverviewGraphListDefault) Code() int {
	return o._statusCode
}

func (o *GetDataSourceOverviewGraphListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources/{dsId}/ographs][%d] getDataSourceOverviewGraphList default %s", o._statusCode, payload)
}

func (o *GetDataSourceOverviewGraphListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/datasources/{dsId}/ographs][%d] getDataSourceOverviewGraphList default %s", o._statusCode, payload)
}

func (o *GetDataSourceOverviewGraphListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDataSourceOverviewGraphListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
