// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDeviceGroupPropertyByNameReader is a Reader for the GetDeviceGroupPropertyByName structure.
type GetDeviceGroupPropertyByNameReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceGroupPropertyByNameReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceGroupPropertyByNameOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeviceGroupPropertyByNameTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceGroupPropertyByNameDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceGroupPropertyByNameOK creates a GetDeviceGroupPropertyByNameOK with default headers values
func NewGetDeviceGroupPropertyByNameOK() *GetDeviceGroupPropertyByNameOK {
	return &GetDeviceGroupPropertyByNameOK{}
}

/*
GetDeviceGroupPropertyByNameOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeviceGroupPropertyByNameOK struct {
	Payload *models.EntityProperty
}

// IsSuccess returns true when this get device group property by name o k response has a 2xx status code
func (o *GetDeviceGroupPropertyByNameOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get device group property by name o k response has a 3xx status code
func (o *GetDeviceGroupPropertyByNameOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device group property by name o k response has a 4xx status code
func (o *GetDeviceGroupPropertyByNameOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get device group property by name o k response has a 5xx status code
func (o *GetDeviceGroupPropertyByNameOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get device group property by name o k response a status code equal to that given
func (o *GetDeviceGroupPropertyByNameOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get device group property by name o k response
func (o *GetDeviceGroupPropertyByNameOK) Code() int {
	return 200
}

func (o *GetDeviceGroupPropertyByNameOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/groups/{gid}/properties/{name}][%d] getDeviceGroupPropertyByNameOK %s", 200, payload)
}

func (o *GetDeviceGroupPropertyByNameOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/groups/{gid}/properties/{name}][%d] getDeviceGroupPropertyByNameOK %s", 200, payload)
}

func (o *GetDeviceGroupPropertyByNameOK) GetPayload() *models.EntityProperty {
	return o.Payload
}

func (o *GetDeviceGroupPropertyByNameOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.EntityProperty)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceGroupPropertyByNameTooManyRequests creates a GetDeviceGroupPropertyByNameTooManyRequests with default headers values
func NewGetDeviceGroupPropertyByNameTooManyRequests() *GetDeviceGroupPropertyByNameTooManyRequests {
	return &GetDeviceGroupPropertyByNameTooManyRequests{}
}

/*
GetDeviceGroupPropertyByNameTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceGroupPropertyByNameTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get device group property by name too many requests response has a 2xx status code
func (o *GetDeviceGroupPropertyByNameTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get device group property by name too many requests response has a 3xx status code
func (o *GetDeviceGroupPropertyByNameTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device group property by name too many requests response has a 4xx status code
func (o *GetDeviceGroupPropertyByNameTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get device group property by name too many requests response has a 5xx status code
func (o *GetDeviceGroupPropertyByNameTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get device group property by name too many requests response a status code equal to that given
func (o *GetDeviceGroupPropertyByNameTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get device group property by name too many requests response
func (o *GetDeviceGroupPropertyByNameTooManyRequests) Code() int {
	return 429
}

func (o *GetDeviceGroupPropertyByNameTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/groups/{gid}/properties/{name}][%d] getDeviceGroupPropertyByNameTooManyRequests", 429)
}

func (o *GetDeviceGroupPropertyByNameTooManyRequests) String() string {
	return fmt.Sprintf("[GET /device/groups/{gid}/properties/{name}][%d] getDeviceGroupPropertyByNameTooManyRequests", 429)
}

func (o *GetDeviceGroupPropertyByNameTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeviceGroupPropertyByNameDefault creates a GetDeviceGroupPropertyByNameDefault with default headers values
func NewGetDeviceGroupPropertyByNameDefault(code int) *GetDeviceGroupPropertyByNameDefault {
	return &GetDeviceGroupPropertyByNameDefault{
		_statusCode: code,
	}
}

/*
GetDeviceGroupPropertyByNameDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeviceGroupPropertyByNameDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get device group property by name default response has a 2xx status code
func (o *GetDeviceGroupPropertyByNameDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get device group property by name default response has a 3xx status code
func (o *GetDeviceGroupPropertyByNameDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get device group property by name default response has a 4xx status code
func (o *GetDeviceGroupPropertyByNameDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get device group property by name default response has a 5xx status code
func (o *GetDeviceGroupPropertyByNameDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get device group property by name default response a status code equal to that given
func (o *GetDeviceGroupPropertyByNameDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get device group property by name default response
func (o *GetDeviceGroupPropertyByNameDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceGroupPropertyByNameDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/groups/{gid}/properties/{name}][%d] getDeviceGroupPropertyByName default %s", o._statusCode, payload)
}

func (o *GetDeviceGroupPropertyByNameDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/groups/{gid}/properties/{name}][%d] getDeviceGroupPropertyByName default %s", o._statusCode, payload)
}

func (o *GetDeviceGroupPropertyByNameDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeviceGroupPropertyByNameDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
