// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDeviceGroupSDTListReader is a Reader for the GetDeviceGroupSDTList structure.
type GetDeviceGroupSDTListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceGroupSDTListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceGroupSDTListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeviceGroupSDTListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceGroupSDTListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceGroupSDTListOK creates a GetDeviceGroupSDTListOK with default headers values
func NewGetDeviceGroupSDTListOK() *GetDeviceGroupSDTListOK {
	return &GetDeviceGroupSDTListOK{}
}

/*
GetDeviceGroupSDTListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeviceGroupSDTListOK struct {
	Payload *models.SDTPaginationResponse
}

// IsSuccess returns true when this get device group Sdt list o k response has a 2xx status code
func (o *GetDeviceGroupSDTListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get device group Sdt list o k response has a 3xx status code
func (o *GetDeviceGroupSDTListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device group Sdt list o k response has a 4xx status code
func (o *GetDeviceGroupSDTListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get device group Sdt list o k response has a 5xx status code
func (o *GetDeviceGroupSDTListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get device group Sdt list o k response a status code equal to that given
func (o *GetDeviceGroupSDTListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get device group Sdt list o k response
func (o *GetDeviceGroupSDTListOK) Code() int {
	return 200
}

func (o *GetDeviceGroupSDTListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/groups/{id}/sdts][%d] getDeviceGroupSdtListOK %s", 200, payload)
}

func (o *GetDeviceGroupSDTListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/groups/{id}/sdts][%d] getDeviceGroupSdtListOK %s", 200, payload)
}

func (o *GetDeviceGroupSDTListOK) GetPayload() *models.SDTPaginationResponse {
	return o.Payload
}

func (o *GetDeviceGroupSDTListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.SDTPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceGroupSDTListTooManyRequests creates a GetDeviceGroupSDTListTooManyRequests with default headers values
func NewGetDeviceGroupSDTListTooManyRequests() *GetDeviceGroupSDTListTooManyRequests {
	return &GetDeviceGroupSDTListTooManyRequests{}
}

/*
GetDeviceGroupSDTListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceGroupSDTListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get device group Sdt list too many requests response has a 2xx status code
func (o *GetDeviceGroupSDTListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get device group Sdt list too many requests response has a 3xx status code
func (o *GetDeviceGroupSDTListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device group Sdt list too many requests response has a 4xx status code
func (o *GetDeviceGroupSDTListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get device group Sdt list too many requests response has a 5xx status code
func (o *GetDeviceGroupSDTListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get device group Sdt list too many requests response a status code equal to that given
func (o *GetDeviceGroupSDTListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get device group Sdt list too many requests response
func (o *GetDeviceGroupSDTListTooManyRequests) Code() int {
	return 429
}

func (o *GetDeviceGroupSDTListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/groups/{id}/sdts][%d] getDeviceGroupSdtListTooManyRequests", 429)
}

func (o *GetDeviceGroupSDTListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /device/groups/{id}/sdts][%d] getDeviceGroupSdtListTooManyRequests", 429)
}

func (o *GetDeviceGroupSDTListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeviceGroupSDTListDefault creates a GetDeviceGroupSDTListDefault with default headers values
func NewGetDeviceGroupSDTListDefault(code int) *GetDeviceGroupSDTListDefault {
	return &GetDeviceGroupSDTListDefault{
		_statusCode: code,
	}
}

/*
GetDeviceGroupSDTListDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeviceGroupSDTListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get device group SDT list default response has a 2xx status code
func (o *GetDeviceGroupSDTListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get device group SDT list default response has a 3xx status code
func (o *GetDeviceGroupSDTListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get device group SDT list default response has a 4xx status code
func (o *GetDeviceGroupSDTListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get device group SDT list default response has a 5xx status code
func (o *GetDeviceGroupSDTListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get device group SDT list default response a status code equal to that given
func (o *GetDeviceGroupSDTListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get device group SDT list default response
func (o *GetDeviceGroupSDTListDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceGroupSDTListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/groups/{id}/sdts][%d] getDeviceGroupSDTList default %s", o._statusCode, payload)
}

func (o *GetDeviceGroupSDTListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/groups/{id}/sdts][%d] getDeviceGroupSDTList default %s", o._statusCode, payload)
}

func (o *GetDeviceGroupSDTListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeviceGroupSDTListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
