// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetDevicePropertyListJSONReader is a Reader for the GetDevicePropertyListJSON structure.
type GetDevicePropertyListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDevicePropertyListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDevicePropertyListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDevicePropertyListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDevicePropertyListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDevicePropertyListJSONOK creates a GetDevicePropertyListJSONOK with default headers values
func NewGetDevicePropertyListJSONOK() *GetDevicePropertyListJSONOK {
	return &GetDevicePropertyListJSONOK{}
}

/*
GetDevicePropertyListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDevicePropertyListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get device property list Json o k response has a 2xx status code
func (o *GetDevicePropertyListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get device property list Json o k response has a 3xx status code
func (o *GetDevicePropertyListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device property list Json o k response has a 4xx status code
func (o *GetDevicePropertyListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get device property list Json o k response has a 5xx status code
func (o *GetDevicePropertyListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get device property list Json o k response a status code equal to that given
func (o *GetDevicePropertyListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get device property list Json o k response
func (o *GetDevicePropertyListJSONOK) Code() int {
	return 200
}

func (o *GetDevicePropertyListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{deviceId}/properties?__json=][%d] getDevicePropertyListJsonOK %s", 200, payload)
}

func (o *GetDevicePropertyListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{deviceId}/properties?__json=][%d] getDevicePropertyListJsonOK %s", 200, payload)
}

func (o *GetDevicePropertyListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetDevicePropertyListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDevicePropertyListJSONTooManyRequests creates a GetDevicePropertyListJSONTooManyRequests with default headers values
func NewGetDevicePropertyListJSONTooManyRequests() *GetDevicePropertyListJSONTooManyRequests {
	return &GetDevicePropertyListJSONTooManyRequests{}
}

/*
GetDevicePropertyListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDevicePropertyListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get device property list Json too many requests response has a 2xx status code
func (o *GetDevicePropertyListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get device property list Json too many requests response has a 3xx status code
func (o *GetDevicePropertyListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device property list Json too many requests response has a 4xx status code
func (o *GetDevicePropertyListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get device property list Json too many requests response has a 5xx status code
func (o *GetDevicePropertyListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get device property list Json too many requests response a status code equal to that given
func (o *GetDevicePropertyListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get device property list Json too many requests response
func (o *GetDevicePropertyListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetDevicePropertyListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/properties?__json=][%d] getDevicePropertyListJsonTooManyRequests", 429)
}

func (o *GetDevicePropertyListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/properties?__json=][%d] getDevicePropertyListJsonTooManyRequests", 429)
}

func (o *GetDevicePropertyListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDevicePropertyListJSONDefault creates a GetDevicePropertyListJSONDefault with default headers values
func NewGetDevicePropertyListJSONDefault(code int) *GetDevicePropertyListJSONDefault {
	return &GetDevicePropertyListJSONDefault{
		_statusCode: code,
	}
}

/*
GetDevicePropertyListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetDevicePropertyListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get device property list Json default response has a 2xx status code
func (o *GetDevicePropertyListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get device property list Json default response has a 3xx status code
func (o *GetDevicePropertyListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get device property list Json default response has a 4xx status code
func (o *GetDevicePropertyListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get device property list Json default response has a 5xx status code
func (o *GetDevicePropertyListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get device property list Json default response a status code equal to that given
func (o *GetDevicePropertyListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get device property list Json default response
func (o *GetDevicePropertyListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetDevicePropertyListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{deviceId}/properties?__json=][%d] getDevicePropertyListJson default %s", o._statusCode, payload)
}

func (o *GetDevicePropertyListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{deviceId}/properties?__json=][%d] getDevicePropertyListJson default %s", o._statusCode, payload)
}

func (o *GetDevicePropertyListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDevicePropertyListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
