// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetEscalationChainListReader is a Reader for the GetEscalationChainList structure.
type GetEscalationChainListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetEscalationChainListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetEscalationChainListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetEscalationChainListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetEscalationChainListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetEscalationChainListOK creates a GetEscalationChainListOK with default headers values
func NewGetEscalationChainListOK() *GetEscalationChainListOK {
	return &GetEscalationChainListOK{}
}

/*
GetEscalationChainListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetEscalationChainListOK struct {
	Payload *models.EscalationChainPaginationResponse
}

// IsSuccess returns true when this get escalation chain list o k response has a 2xx status code
func (o *GetEscalationChainListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get escalation chain list o k response has a 3xx status code
func (o *GetEscalationChainListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get escalation chain list o k response has a 4xx status code
func (o *GetEscalationChainListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get escalation chain list o k response has a 5xx status code
func (o *GetEscalationChainListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get escalation chain list o k response a status code equal to that given
func (o *GetEscalationChainListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get escalation chain list o k response
func (o *GetEscalationChainListOK) Code() int {
	return 200
}

func (o *GetEscalationChainListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/alert/chains][%d] getEscalationChainListOK %s", 200, payload)
}

func (o *GetEscalationChainListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/alert/chains][%d] getEscalationChainListOK %s", 200, payload)
}

func (o *GetEscalationChainListOK) GetPayload() *models.EscalationChainPaginationResponse {
	return o.Payload
}

func (o *GetEscalationChainListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.EscalationChainPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetEscalationChainListTooManyRequests creates a GetEscalationChainListTooManyRequests with default headers values
func NewGetEscalationChainListTooManyRequests() *GetEscalationChainListTooManyRequests {
	return &GetEscalationChainListTooManyRequests{}
}

/*
GetEscalationChainListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetEscalationChainListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get escalation chain list too many requests response has a 2xx status code
func (o *GetEscalationChainListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get escalation chain list too many requests response has a 3xx status code
func (o *GetEscalationChainListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get escalation chain list too many requests response has a 4xx status code
func (o *GetEscalationChainListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get escalation chain list too many requests response has a 5xx status code
func (o *GetEscalationChainListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get escalation chain list too many requests response a status code equal to that given
func (o *GetEscalationChainListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get escalation chain list too many requests response
func (o *GetEscalationChainListTooManyRequests) Code() int {
	return 429
}

func (o *GetEscalationChainListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/alert/chains][%d] getEscalationChainListTooManyRequests", 429)
}

func (o *GetEscalationChainListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/alert/chains][%d] getEscalationChainListTooManyRequests", 429)
}

func (o *GetEscalationChainListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetEscalationChainListDefault creates a GetEscalationChainListDefault with default headers values
func NewGetEscalationChainListDefault(code int) *GetEscalationChainListDefault {
	return &GetEscalationChainListDefault{
		_statusCode: code,
	}
}

/*
GetEscalationChainListDefault describes a response with status code -1, with default header values.

Error
*/
type GetEscalationChainListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get escalation chain list default response has a 2xx status code
func (o *GetEscalationChainListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get escalation chain list default response has a 3xx status code
func (o *GetEscalationChainListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get escalation chain list default response has a 4xx status code
func (o *GetEscalationChainListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get escalation chain list default response has a 5xx status code
func (o *GetEscalationChainListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get escalation chain list default response a status code equal to that given
func (o *GetEscalationChainListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get escalation chain list default response
func (o *GetEscalationChainListDefault) Code() int {
	return o._statusCode
}

func (o *GetEscalationChainListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/alert/chains][%d] getEscalationChainList default %s", o._statusCode, payload)
}

func (o *GetEscalationChainListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/alert/chains][%d] getEscalationChainList default %s", o._statusCode, payload)
}

func (o *GetEscalationChainListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetEscalationChainListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
