// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetExternalAPIStatsReader is a Reader for the GetExternalAPIStats structure.
type GetExternalAPIStatsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetExternalAPIStatsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetExternalAPIStatsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetExternalAPIStatsTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetExternalAPIStatsDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetExternalAPIStatsOK creates a GetExternalAPIStatsOK with default headers values
func NewGetExternalAPIStatsOK() *GetExternalAPIStatsOK {
	return &GetExternalAPIStatsOK{}
}

/*
GetExternalAPIStatsOK describes a response with status code 200, with default header values.

successful operation
*/
type GetExternalAPIStatsOK struct {
	Payload *models.APIPerfMetrics
}

// IsSuccess returns true when this get external Api stats o k response has a 2xx status code
func (o *GetExternalAPIStatsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get external Api stats o k response has a 3xx status code
func (o *GetExternalAPIStatsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get external Api stats o k response has a 4xx status code
func (o *GetExternalAPIStatsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get external Api stats o k response has a 5xx status code
func (o *GetExternalAPIStatsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get external Api stats o k response a status code equal to that given
func (o *GetExternalAPIStatsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get external Api stats o k response
func (o *GetExternalAPIStatsOK) Code() int {
	return 200
}

func (o *GetExternalAPIStatsOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /apiStats/externalApis][%d] getExternalApiStatsOK %s", 200, payload)
}

func (o *GetExternalAPIStatsOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /apiStats/externalApis][%d] getExternalApiStatsOK %s", 200, payload)
}

func (o *GetExternalAPIStatsOK) GetPayload() *models.APIPerfMetrics {
	return o.Payload
}

func (o *GetExternalAPIStatsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.APIPerfMetrics)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetExternalAPIStatsTooManyRequests creates a GetExternalAPIStatsTooManyRequests with default headers values
func NewGetExternalAPIStatsTooManyRequests() *GetExternalAPIStatsTooManyRequests {
	return &GetExternalAPIStatsTooManyRequests{}
}

/*
GetExternalAPIStatsTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetExternalAPIStatsTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get external Api stats too many requests response has a 2xx status code
func (o *GetExternalAPIStatsTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get external Api stats too many requests response has a 3xx status code
func (o *GetExternalAPIStatsTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get external Api stats too many requests response has a 4xx status code
func (o *GetExternalAPIStatsTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get external Api stats too many requests response has a 5xx status code
func (o *GetExternalAPIStatsTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get external Api stats too many requests response a status code equal to that given
func (o *GetExternalAPIStatsTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get external Api stats too many requests response
func (o *GetExternalAPIStatsTooManyRequests) Code() int {
	return 429
}

func (o *GetExternalAPIStatsTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /apiStats/externalApis][%d] getExternalApiStatsTooManyRequests", 429)
}

func (o *GetExternalAPIStatsTooManyRequests) String() string {
	return fmt.Sprintf("[GET /apiStats/externalApis][%d] getExternalApiStatsTooManyRequests", 429)
}

func (o *GetExternalAPIStatsTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetExternalAPIStatsDefault creates a GetExternalAPIStatsDefault with default headers values
func NewGetExternalAPIStatsDefault(code int) *GetExternalAPIStatsDefault {
	return &GetExternalAPIStatsDefault{
		_statusCode: code,
	}
}

/*
GetExternalAPIStatsDefault describes a response with status code -1, with default header values.

Error
*/
type GetExternalAPIStatsDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get external Api stats default response has a 2xx status code
func (o *GetExternalAPIStatsDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get external Api stats default response has a 3xx status code
func (o *GetExternalAPIStatsDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get external Api stats default response has a 4xx status code
func (o *GetExternalAPIStatsDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get external Api stats default response has a 5xx status code
func (o *GetExternalAPIStatsDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get external Api stats default response a status code equal to that given
func (o *GetExternalAPIStatsDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get external Api stats default response
func (o *GetExternalAPIStatsDefault) Code() int {
	return o._statusCode
}

func (o *GetExternalAPIStatsDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /apiStats/externalApis][%d] getExternalApiStats default %s", o._statusCode, payload)
}

func (o *GetExternalAPIStatsDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /apiStats/externalApis][%d] getExternalApiStats default %s", o._statusCode, payload)
}

func (o *GetExternalAPIStatsDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetExternalAPIStatsDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
