// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetJobMonitorListReader is a Reader for the GetJobMonitorList structure.
type GetJobMonitorListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetJobMonitorListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetJobMonitorListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetJobMonitorListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetJobMonitorListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetJobMonitorListOK creates a GetJobMonitorListOK with default headers values
func NewGetJobMonitorListOK() *GetJobMonitorListOK {
	return &GetJobMonitorListOK{}
}

/*
GetJobMonitorListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetJobMonitorListOK struct {
	Payload *models.BatchJobPaginationResponse
}

// IsSuccess returns true when this get job monitor list o k response has a 2xx status code
func (o *GetJobMonitorListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get job monitor list o k response has a 3xx status code
func (o *GetJobMonitorListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get job monitor list o k response has a 4xx status code
func (o *GetJobMonitorListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get job monitor list o k response has a 5xx status code
func (o *GetJobMonitorListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get job monitor list o k response a status code equal to that given
func (o *GetJobMonitorListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get job monitor list o k response
func (o *GetJobMonitorListOK) Code() int {
	return 200
}

func (o *GetJobMonitorListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/batchjobs][%d] getJobMonitorListOK %s", 200, payload)
}

func (o *GetJobMonitorListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/batchjobs][%d] getJobMonitorListOK %s", 200, payload)
}

func (o *GetJobMonitorListOK) GetPayload() *models.BatchJobPaginationResponse {
	return o.Payload
}

func (o *GetJobMonitorListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.BatchJobPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetJobMonitorListTooManyRequests creates a GetJobMonitorListTooManyRequests with default headers values
func NewGetJobMonitorListTooManyRequests() *GetJobMonitorListTooManyRequests {
	return &GetJobMonitorListTooManyRequests{}
}

/*
GetJobMonitorListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetJobMonitorListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get job monitor list too many requests response has a 2xx status code
func (o *GetJobMonitorListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get job monitor list too many requests response has a 3xx status code
func (o *GetJobMonitorListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get job monitor list too many requests response has a 4xx status code
func (o *GetJobMonitorListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get job monitor list too many requests response has a 5xx status code
func (o *GetJobMonitorListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get job monitor list too many requests response a status code equal to that given
func (o *GetJobMonitorListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get job monitor list too many requests response
func (o *GetJobMonitorListTooManyRequests) Code() int {
	return 429
}

func (o *GetJobMonitorListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/batchjobs][%d] getJobMonitorListTooManyRequests", 429)
}

func (o *GetJobMonitorListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/batchjobs][%d] getJobMonitorListTooManyRequests", 429)
}

func (o *GetJobMonitorListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetJobMonitorListDefault creates a GetJobMonitorListDefault with default headers values
func NewGetJobMonitorListDefault(code int) *GetJobMonitorListDefault {
	return &GetJobMonitorListDefault{
		_statusCode: code,
	}
}

/*
GetJobMonitorListDefault describes a response with status code -1, with default header values.

Error
*/
type GetJobMonitorListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get job monitor list default response has a 2xx status code
func (o *GetJobMonitorListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get job monitor list default response has a 3xx status code
func (o *GetJobMonitorListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get job monitor list default response has a 4xx status code
func (o *GetJobMonitorListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get job monitor list default response has a 5xx status code
func (o *GetJobMonitorListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get job monitor list default response a status code equal to that given
func (o *GetJobMonitorListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get job monitor list default response
func (o *GetJobMonitorListDefault) Code() int {
	return o._statusCode
}

func (o *GetJobMonitorListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/batchjobs][%d] getJobMonitorList default %s", o._statusCode, payload)
}

func (o *GetJobMonitorListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/batchjobs][%d] getJobMonitorList default %s", o._statusCode, payload)
}

func (o *GetJobMonitorListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetJobMonitorListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
