// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetLogSourceListJSONParams creates a new GetLogSourceListJSONParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetLogSourceListJSONParams() *GetLogSourceListJSONParams {
	return &GetLogSourceListJSONParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetLogSourceListJSONParamsWithTimeout creates a new GetLogSourceListJSONParams object
// with the ability to set a timeout on a request.
func NewGetLogSourceListJSONParamsWithTimeout(timeout time.Duration) *GetLogSourceListJSONParams {
	return &GetLogSourceListJSONParams{
		timeout: timeout,
	}
}

// NewGetLogSourceListJSONParamsWithContext creates a new GetLogSourceListJSONParams object
// with the ability to set a context for a request.
func NewGetLogSourceListJSONParamsWithContext(ctx context.Context) *GetLogSourceListJSONParams {
	return &GetLogSourceListJSONParams{
		Context: ctx,
	}
}

// NewGetLogSourceListJSONParamsWithHTTPClient creates a new GetLogSourceListJSONParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetLogSourceListJSONParamsWithHTTPClient(client *http.Client) *GetLogSourceListJSONParams {
	return &GetLogSourceListJSONParams{
		HTTPClient: client,
	}
}

/*
GetLogSourceListJSONParams contains all the parameters to send to the API endpoint

	for the get log source list Json operation.

	Typically these are written to a http.Request.
*/
type GetLogSourceListJSONParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Format.
	//
	// Default: "json"
	Format *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get log source list Json params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetLogSourceListJSONParams) WithDefaults() *GetLogSourceListJSONParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get log source list Json params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetLogSourceListJSONParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")

		formatDefault = string("json")
	)

	val := GetLogSourceListJSONParams{
		UserAgent: &userAgentDefault,
		Format:    &formatDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the get log source list Json params
func (o *GetLogSourceListJSONParams) WithTimeout(timeout time.Duration) *GetLogSourceListJSONParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get log source list Json params
func (o *GetLogSourceListJSONParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get log source list Json params
func (o *GetLogSourceListJSONParams) WithContext(ctx context.Context) *GetLogSourceListJSONParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get log source list Json params
func (o *GetLogSourceListJSONParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get log source list Json params
func (o *GetLogSourceListJSONParams) WithHTTPClient(client *http.Client) *GetLogSourceListJSONParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get log source list Json params
func (o *GetLogSourceListJSONParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the get log source list Json params
func (o *GetLogSourceListJSONParams) WithUserAgent(userAgent *string) *GetLogSourceListJSONParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get log source list Json params
func (o *GetLogSourceListJSONParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithFormat adds the format to the get log source list Json params
func (o *GetLogSourceListJSONParams) WithFormat(format *string) *GetLogSourceListJSONParams {
	o.SetFormat(format)
	return o
}

// SetFormat adds the format to the get log source list Json params
func (o *GetLogSourceListJSONParams) SetFormat(format *string) {
	o.Format = format
}

// WriteToRequest writes these params to a swagger request
func (o *GetLogSourceListJSONParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}

	if o.Format != nil {

		// query param format
		var qrFormat string

		if o.Format != nil {
			qrFormat = *o.Format
		}
		qFormat := qrFormat
		if qFormat != "" {

			if err := r.SetQueryParam("format", qFormat); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
