// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetLogSourceListJSONReader is a Reader for the GetLogSourceListJSON structure.
type GetLogSourceListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetLogSourceListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetLogSourceListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetLogSourceListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetLogSourceListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetLogSourceListJSONOK creates a GetLogSourceListJSONOK with default headers values
func NewGetLogSourceListJSONOK() *GetLogSourceListJSONOK {
	return &GetLogSourceListJSONOK{}
}

/*
GetLogSourceListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetLogSourceListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get log source list Json o k response has a 2xx status code
func (o *GetLogSourceListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get log source list Json o k response has a 3xx status code
func (o *GetLogSourceListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get log source list Json o k response has a 4xx status code
func (o *GetLogSourceListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get log source list Json o k response has a 5xx status code
func (o *GetLogSourceListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get log source list Json o k response a status code equal to that given
func (o *GetLogSourceListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get log source list Json o k response
func (o *GetLogSourceListJSONOK) Code() int {
	return 200
}

func (o *GetLogSourceListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources?__json=][%d] getLogSourceListJsonOK %s", 200, payload)
}

func (o *GetLogSourceListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources?__json=][%d] getLogSourceListJsonOK %s", 200, payload)
}

func (o *GetLogSourceListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetLogSourceListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLogSourceListJSONTooManyRequests creates a GetLogSourceListJSONTooManyRequests with default headers values
func NewGetLogSourceListJSONTooManyRequests() *GetLogSourceListJSONTooManyRequests {
	return &GetLogSourceListJSONTooManyRequests{}
}

/*
GetLogSourceListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetLogSourceListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get log source list Json too many requests response has a 2xx status code
func (o *GetLogSourceListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get log source list Json too many requests response has a 3xx status code
func (o *GetLogSourceListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get log source list Json too many requests response has a 4xx status code
func (o *GetLogSourceListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get log source list Json too many requests response has a 5xx status code
func (o *GetLogSourceListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get log source list Json too many requests response a status code equal to that given
func (o *GetLogSourceListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get log source list Json too many requests response
func (o *GetLogSourceListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetLogSourceListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/logsources?__json=][%d] getLogSourceListJsonTooManyRequests", 429)
}

func (o *GetLogSourceListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/logsources?__json=][%d] getLogSourceListJsonTooManyRequests", 429)
}

func (o *GetLogSourceListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetLogSourceListJSONDefault creates a GetLogSourceListJSONDefault with default headers values
func NewGetLogSourceListJSONDefault(code int) *GetLogSourceListJSONDefault {
	return &GetLogSourceListJSONDefault{
		_statusCode: code,
	}
}

/*
GetLogSourceListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetLogSourceListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get log source list Json default response has a 2xx status code
func (o *GetLogSourceListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get log source list Json default response has a 3xx status code
func (o *GetLogSourceListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get log source list Json default response has a 4xx status code
func (o *GetLogSourceListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get log source list Json default response has a 5xx status code
func (o *GetLogSourceListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get log source list Json default response a status code equal to that given
func (o *GetLogSourceListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get log source list Json default response
func (o *GetLogSourceListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetLogSourceListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources?__json=][%d] getLogSourceListJson default %s", o._statusCode, payload)
}

func (o *GetLogSourceListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logsources?__json=][%d] getLogSourceListJson default %s", o._statusCode, payload)
}

func (o *GetLogSourceListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetLogSourceListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
