// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetLogSourceListParams creates a new GetLogSourceListParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetLogSourceListParams() *GetLogSourceListParams {
	return &GetLogSourceListParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetLogSourceListParamsWithTimeout creates a new GetLogSourceListParams object
// with the ability to set a timeout on a request.
func NewGetLogSourceListParamsWithTimeout(timeout time.Duration) *GetLogSourceListParams {
	return &GetLogSourceListParams{
		timeout: timeout,
	}
}

// NewGetLogSourceListParamsWithContext creates a new GetLogSourceListParams object
// with the ability to set a context for a request.
func NewGetLogSourceListParamsWithContext(ctx context.Context) *GetLogSourceListParams {
	return &GetLogSourceListParams{
		Context: ctx,
	}
}

// NewGetLogSourceListParamsWithHTTPClient creates a new GetLogSourceListParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetLogSourceListParamsWithHTTPClient(client *http.Client) *GetLogSourceListParams {
	return &GetLogSourceListParams{
		HTTPClient: client,
	}
}

/*
GetLogSourceListParams contains all the parameters to send to the API endpoint

	for the get log source list operation.

	Typically these are written to a http.Request.
*/
type GetLogSourceListParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Format.
	//
	// Default: "json"
	Format *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get log source list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetLogSourceListParams) WithDefaults() *GetLogSourceListParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get log source list params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetLogSourceListParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")

		formatDefault = string("json")
	)

	val := GetLogSourceListParams{
		UserAgent: &userAgentDefault,
		Format:    &formatDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the get log source list params
func (o *GetLogSourceListParams) WithTimeout(timeout time.Duration) *GetLogSourceListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get log source list params
func (o *GetLogSourceListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get log source list params
func (o *GetLogSourceListParams) WithContext(ctx context.Context) *GetLogSourceListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get log source list params
func (o *GetLogSourceListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get log source list params
func (o *GetLogSourceListParams) WithHTTPClient(client *http.Client) *GetLogSourceListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get log source list params
func (o *GetLogSourceListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the get log source list params
func (o *GetLogSourceListParams) WithUserAgent(userAgent *string) *GetLogSourceListParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get log source list params
func (o *GetLogSourceListParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithFormat adds the format to the get log source list params
func (o *GetLogSourceListParams) WithFormat(format *string) *GetLogSourceListParams {
	o.SetFormat(format)
	return o
}

// SetFormat adds the format to the get log source list params
func (o *GetLogSourceListParams) SetFormat(format *string) {
	o.Format = format
}

// WriteToRequest writes these params to a swagger request
func (o *GetLogSourceListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}

	if o.Format != nil {

		// query param format
		var qrFormat string

		if o.Format != nil {
			qrFormat = *o.Format
		}
		qFormat := qrFormat
		if qFormat != "" {

			if err := r.SetQueryParam("format", qFormat); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
