// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetNetflowPortListJSONReader is a Reader for the GetNetflowPortListJSON structure.
type GetNetflowPortListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetNetflowPortListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetNetflowPortListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetNetflowPortListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetNetflowPortListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetNetflowPortListJSONOK creates a GetNetflowPortListJSONOK with default headers values
func NewGetNetflowPortListJSONOK() *GetNetflowPortListJSONOK {
	return &GetNetflowPortListJSONOK{}
}

/*
GetNetflowPortListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetNetflowPortListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get netflow port list Json o k response has a 2xx status code
func (o *GetNetflowPortListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get netflow port list Json o k response has a 3xx status code
func (o *GetNetflowPortListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get netflow port list Json o k response has a 4xx status code
func (o *GetNetflowPortListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get netflow port list Json o k response has a 5xx status code
func (o *GetNetflowPortListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get netflow port list Json o k response a status code equal to that given
func (o *GetNetflowPortListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get netflow port list Json o k response
func (o *GetNetflowPortListJSONOK) Code() int {
	return 200
}

func (o *GetNetflowPortListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/ports?__json=][%d] getNetflowPortListJsonOK %s", 200, payload)
}

func (o *GetNetflowPortListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/ports?__json=][%d] getNetflowPortListJsonOK %s", 200, payload)
}

func (o *GetNetflowPortListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetNetflowPortListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetNetflowPortListJSONTooManyRequests creates a GetNetflowPortListJSONTooManyRequests with default headers values
func NewGetNetflowPortListJSONTooManyRequests() *GetNetflowPortListJSONTooManyRequests {
	return &GetNetflowPortListJSONTooManyRequests{}
}

/*
GetNetflowPortListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetNetflowPortListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get netflow port list Json too many requests response has a 2xx status code
func (o *GetNetflowPortListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get netflow port list Json too many requests response has a 3xx status code
func (o *GetNetflowPortListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get netflow port list Json too many requests response has a 4xx status code
func (o *GetNetflowPortListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get netflow port list Json too many requests response has a 5xx status code
func (o *GetNetflowPortListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get netflow port list Json too many requests response a status code equal to that given
func (o *GetNetflowPortListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get netflow port list Json too many requests response
func (o *GetNetflowPortListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetNetflowPortListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}/ports?__json=][%d] getNetflowPortListJsonTooManyRequests", 429)
}

func (o *GetNetflowPortListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /device/devices/{id}/ports?__json=][%d] getNetflowPortListJsonTooManyRequests", 429)
}

func (o *GetNetflowPortListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetNetflowPortListJSONDefault creates a GetNetflowPortListJSONDefault with default headers values
func NewGetNetflowPortListJSONDefault(code int) *GetNetflowPortListJSONDefault {
	return &GetNetflowPortListJSONDefault{
		_statusCode: code,
	}
}

/*
GetNetflowPortListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetNetflowPortListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get netflow port list Json default response has a 2xx status code
func (o *GetNetflowPortListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get netflow port list Json default response has a 3xx status code
func (o *GetNetflowPortListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get netflow port list Json default response has a 4xx status code
func (o *GetNetflowPortListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get netflow port list Json default response has a 5xx status code
func (o *GetNetflowPortListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get netflow port list Json default response a status code equal to that given
func (o *GetNetflowPortListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get netflow port list Json default response
func (o *GetNetflowPortListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetNetflowPortListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/ports?__json=][%d] getNetflowPortListJson default %s", o._statusCode, payload)
}

func (o *GetNetflowPortListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/ports?__json=][%d] getNetflowPortListJson default %s", o._statusCode, payload)
}

func (o *GetNetflowPortListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetNetflowPortListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
