// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetNetscanByIDJSONReader is a Reader for the GetNetscanByIDJSON structure.
type GetNetscanByIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetNetscanByIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetNetscanByIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetNetscanByIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetNetscanByIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetNetscanByIDJSONOK creates a GetNetscanByIDJSONOK with default headers values
func NewGetNetscanByIDJSONOK() *GetNetscanByIDJSONOK {
	return &GetNetscanByIDJSONOK{}
}

/*
GetNetscanByIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetNetscanByIDJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get netscan by Id Json o k response has a 2xx status code
func (o *GetNetscanByIDJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get netscan by Id Json o k response has a 3xx status code
func (o *GetNetscanByIDJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get netscan by Id Json o k response has a 4xx status code
func (o *GetNetscanByIDJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get netscan by Id Json o k response has a 5xx status code
func (o *GetNetscanByIDJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get netscan by Id Json o k response a status code equal to that given
func (o *GetNetscanByIDJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get netscan by Id Json o k response
func (o *GetNetscanByIDJSONOK) Code() int {
	return 200
}

func (o *GetNetscanByIDJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/netscans/{id}?__json=][%d] getNetscanByIdJsonOK %s", 200, payload)
}

func (o *GetNetscanByIDJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/netscans/{id}?__json=][%d] getNetscanByIdJsonOK %s", 200, payload)
}

func (o *GetNetscanByIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetNetscanByIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetNetscanByIDJSONTooManyRequests creates a GetNetscanByIDJSONTooManyRequests with default headers values
func NewGetNetscanByIDJSONTooManyRequests() *GetNetscanByIDJSONTooManyRequests {
	return &GetNetscanByIDJSONTooManyRequests{}
}

/*
GetNetscanByIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetNetscanByIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get netscan by Id Json too many requests response has a 2xx status code
func (o *GetNetscanByIDJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get netscan by Id Json too many requests response has a 3xx status code
func (o *GetNetscanByIDJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get netscan by Id Json too many requests response has a 4xx status code
func (o *GetNetscanByIDJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get netscan by Id Json too many requests response has a 5xx status code
func (o *GetNetscanByIDJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get netscan by Id Json too many requests response a status code equal to that given
func (o *GetNetscanByIDJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get netscan by Id Json too many requests response
func (o *GetNetscanByIDJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetNetscanByIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/netscans/{id}?__json=][%d] getNetscanByIdJsonTooManyRequests", 429)
}

func (o *GetNetscanByIDJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/netscans/{id}?__json=][%d] getNetscanByIdJsonTooManyRequests", 429)
}

func (o *GetNetscanByIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetNetscanByIDJSONDefault creates a GetNetscanByIDJSONDefault with default headers values
func NewGetNetscanByIDJSONDefault(code int) *GetNetscanByIDJSONDefault {
	return &GetNetscanByIDJSONDefault{
		_statusCode: code,
	}
}

/*
GetNetscanByIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetNetscanByIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get netscan by Id Json default response has a 2xx status code
func (o *GetNetscanByIDJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get netscan by Id Json default response has a 3xx status code
func (o *GetNetscanByIDJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get netscan by Id Json default response has a 4xx status code
func (o *GetNetscanByIDJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get netscan by Id Json default response has a 5xx status code
func (o *GetNetscanByIDJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get netscan by Id Json default response a status code equal to that given
func (o *GetNetscanByIDJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get netscan by Id Json default response
func (o *GetNetscanByIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetNetscanByIDJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/netscans/{id}?__json=][%d] getNetscanByIdJson default %s", o._statusCode, payload)
}

func (o *GetNetscanByIDJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/netscans/{id}?__json=][%d] getNetscanByIdJson default %s", o._statusCode, payload)
}

func (o *GetNetscanByIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetNetscanByIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
