// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetOIDListJSONReader is a Reader for the GetOIDListJSON structure.
type GetOIDListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetOIDListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetOIDListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetOIDListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetOIDListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetOIDListJSONOK creates a GetOIDListJSONOK with default headers values
func NewGetOIDListJSONOK() *GetOIDListJSONOK {
	return &GetOIDListJSONOK{}
}

/*
GetOIDListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetOIDListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get o Id list Json o k response has a 2xx status code
func (o *GetOIDListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get o Id list Json o k response has a 3xx status code
func (o *GetOIDListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get o Id list Json o k response has a 4xx status code
func (o *GetOIDListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get o Id list Json o k response has a 5xx status code
func (o *GetOIDListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get o Id list Json o k response a status code equal to that given
func (o *GetOIDListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get o Id list Json o k response
func (o *GetOIDListJSONOK) Code() int {
	return 200
}

func (o *GetOIDListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/oids?__json=][%d] getOIdListJsonOK %s", 200, payload)
}

func (o *GetOIDListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/oids?__json=][%d] getOIdListJsonOK %s", 200, payload)
}

func (o *GetOIDListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetOIDListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetOIDListJSONTooManyRequests creates a GetOIDListJSONTooManyRequests with default headers values
func NewGetOIDListJSONTooManyRequests() *GetOIDListJSONTooManyRequests {
	return &GetOIDListJSONTooManyRequests{}
}

/*
GetOIDListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetOIDListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get o Id list Json too many requests response has a 2xx status code
func (o *GetOIDListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get o Id list Json too many requests response has a 3xx status code
func (o *GetOIDListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get o Id list Json too many requests response has a 4xx status code
func (o *GetOIDListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get o Id list Json too many requests response has a 5xx status code
func (o *GetOIDListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get o Id list Json too many requests response a status code equal to that given
func (o *GetOIDListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get o Id list Json too many requests response
func (o *GetOIDListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetOIDListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/oids?__json=][%d] getOIdListJsonTooManyRequests", 429)
}

func (o *GetOIDListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/oids?__json=][%d] getOIdListJsonTooManyRequests", 429)
}

func (o *GetOIDListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetOIDListJSONDefault creates a GetOIDListJSONDefault with default headers values
func NewGetOIDListJSONDefault(code int) *GetOIDListJSONDefault {
	return &GetOIDListJSONDefault{
		_statusCode: code,
	}
}

/*
GetOIDListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetOIDListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get o ID list Json default response has a 2xx status code
func (o *GetOIDListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get o ID list Json default response has a 3xx status code
func (o *GetOIDListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get o ID list Json default response has a 4xx status code
func (o *GetOIDListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get o ID list Json default response has a 5xx status code
func (o *GetOIDListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get o ID list Json default response a status code equal to that given
func (o *GetOIDListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get o ID list Json default response
func (o *GetOIDListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetOIDListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/oids?__json=][%d] getOIDListJson default %s", o._statusCode, payload)
}

func (o *GetOIDListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/oids?__json=][%d] getOIDListJson default %s", o._statusCode, payload)
}

func (o *GetOIDListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetOIDListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
