// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetReportByIDJSONReader is a Reader for the GetReportByIDJSON structure.
type GetReportByIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetReportByIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetReportByIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetReportByIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetReportByIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetReportByIDJSONOK creates a GetReportByIDJSONOK with default headers values
func NewGetReportByIDJSONOK() *GetReportByIDJSONOK {
	return &GetReportByIDJSONOK{}
}

/*
GetReportByIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetReportByIDJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get report by Id Json o k response has a 2xx status code
func (o *GetReportByIDJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get report by Id Json o k response has a 3xx status code
func (o *GetReportByIDJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get report by Id Json o k response has a 4xx status code
func (o *GetReportByIDJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get report by Id Json o k response has a 5xx status code
func (o *GetReportByIDJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get report by Id Json o k response a status code equal to that given
func (o *GetReportByIDJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get report by Id Json o k response
func (o *GetReportByIDJSONOK) Code() int {
	return 200
}

func (o *GetReportByIDJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/reports/{id}?__json=][%d] getReportByIdJsonOK %s", 200, payload)
}

func (o *GetReportByIDJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/reports/{id}?__json=][%d] getReportByIdJsonOK %s", 200, payload)
}

func (o *GetReportByIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetReportByIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetReportByIDJSONTooManyRequests creates a GetReportByIDJSONTooManyRequests with default headers values
func NewGetReportByIDJSONTooManyRequests() *GetReportByIDJSONTooManyRequests {
	return &GetReportByIDJSONTooManyRequests{}
}

/*
GetReportByIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetReportByIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get report by Id Json too many requests response has a 2xx status code
func (o *GetReportByIDJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get report by Id Json too many requests response has a 3xx status code
func (o *GetReportByIDJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get report by Id Json too many requests response has a 4xx status code
func (o *GetReportByIDJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get report by Id Json too many requests response has a 5xx status code
func (o *GetReportByIDJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get report by Id Json too many requests response a status code equal to that given
func (o *GetReportByIDJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get report by Id Json too many requests response
func (o *GetReportByIDJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetReportByIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /report/reports/{id}?__json=][%d] getReportByIdJsonTooManyRequests", 429)
}

func (o *GetReportByIDJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /report/reports/{id}?__json=][%d] getReportByIdJsonTooManyRequests", 429)
}

func (o *GetReportByIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetReportByIDJSONDefault creates a GetReportByIDJSONDefault with default headers values
func NewGetReportByIDJSONDefault(code int) *GetReportByIDJSONDefault {
	return &GetReportByIDJSONDefault{
		_statusCode: code,
	}
}

/*
GetReportByIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetReportByIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get report by Id Json default response has a 2xx status code
func (o *GetReportByIDJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get report by Id Json default response has a 3xx status code
func (o *GetReportByIDJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get report by Id Json default response has a 4xx status code
func (o *GetReportByIDJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get report by Id Json default response has a 5xx status code
func (o *GetReportByIDJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get report by Id Json default response a status code equal to that given
func (o *GetReportByIDJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get report by Id Json default response
func (o *GetReportByIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetReportByIDJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/reports/{id}?__json=][%d] getReportByIdJson default %s", o._statusCode, payload)
}

func (o *GetReportByIDJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /report/reports/{id}?__json=][%d] getReportByIdJson default %s", o._statusCode, payload)
}

func (o *GetReportByIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetReportByIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
