// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetSDTListJSONReader is a Reader for the GetSDTListJSON structure.
type GetSDTListJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetSDTListJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetSDTListJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetSDTListJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetSDTListJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetSDTListJSONOK creates a GetSDTListJSONOK with default headers values
func NewGetSDTListJSONOK() *GetSDTListJSONOK {
	return &GetSDTListJSONOK{}
}

/*
GetSDTListJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetSDTListJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get Sdt list Json o k response has a 2xx status code
func (o *GetSDTListJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get Sdt list Json o k response has a 3xx status code
func (o *GetSDTListJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get Sdt list Json o k response has a 4xx status code
func (o *GetSDTListJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get Sdt list Json o k response has a 5xx status code
func (o *GetSDTListJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get Sdt list Json o k response a status code equal to that given
func (o *GetSDTListJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get Sdt list Json o k response
func (o *GetSDTListJSONOK) Code() int {
	return 200
}

func (o *GetSDTListJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /sdt/sdts?__json=][%d] getSdtListJsonOK %s", 200, payload)
}

func (o *GetSDTListJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /sdt/sdts?__json=][%d] getSdtListJsonOK %s", 200, payload)
}

func (o *GetSDTListJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetSDTListJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetSDTListJSONTooManyRequests creates a GetSDTListJSONTooManyRequests with default headers values
func NewGetSDTListJSONTooManyRequests() *GetSDTListJSONTooManyRequests {
	return &GetSDTListJSONTooManyRequests{}
}

/*
GetSDTListJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetSDTListJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get Sdt list Json too many requests response has a 2xx status code
func (o *GetSDTListJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get Sdt list Json too many requests response has a 3xx status code
func (o *GetSDTListJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get Sdt list Json too many requests response has a 4xx status code
func (o *GetSDTListJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get Sdt list Json too many requests response has a 5xx status code
func (o *GetSDTListJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get Sdt list Json too many requests response a status code equal to that given
func (o *GetSDTListJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get Sdt list Json too many requests response
func (o *GetSDTListJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetSDTListJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /sdt/sdts?__json=][%d] getSdtListJsonTooManyRequests", 429)
}

func (o *GetSDTListJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /sdt/sdts?__json=][%d] getSdtListJsonTooManyRequests", 429)
}

func (o *GetSDTListJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetSDTListJSONDefault creates a GetSDTListJSONDefault with default headers values
func NewGetSDTListJSONDefault(code int) *GetSDTListJSONDefault {
	return &GetSDTListJSONDefault{
		_statusCode: code,
	}
}

/*
GetSDTListJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetSDTListJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get SDT list Json default response has a 2xx status code
func (o *GetSDTListJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get SDT list Json default response has a 3xx status code
func (o *GetSDTListJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get SDT list Json default response has a 4xx status code
func (o *GetSDTListJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get SDT list Json default response has a 5xx status code
func (o *GetSDTListJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get SDT list Json default response a status code equal to that given
func (o *GetSDTListJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get SDT list Json default response
func (o *GetSDTListJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetSDTListJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /sdt/sdts?__json=][%d] getSDTListJson default %s", o._statusCode, payload)
}

func (o *GetSDTListJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /sdt/sdts?__json=][%d] getSDTListJson default %s", o._statusCode, payload)
}

func (o *GetSDTListJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetSDTListJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
