// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetSiteMonitorCheckPointListReader is a Reader for the GetSiteMonitorCheckPointList structure.
type GetSiteMonitorCheckPointListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetSiteMonitorCheckPointListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetSiteMonitorCheckPointListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetSiteMonitorCheckPointListTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetSiteMonitorCheckPointListDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetSiteMonitorCheckPointListOK creates a GetSiteMonitorCheckPointListOK with default headers values
func NewGetSiteMonitorCheckPointListOK() *GetSiteMonitorCheckPointListOK {
	return &GetSiteMonitorCheckPointListOK{}
}

/*
GetSiteMonitorCheckPointListOK describes a response with status code 200, with default header values.

successful operation
*/
type GetSiteMonitorCheckPointListOK struct {
	Payload *models.SiteMonitorCheckPointPaginationResponse
}

// IsSuccess returns true when this get site monitor check point list o k response has a 2xx status code
func (o *GetSiteMonitorCheckPointListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get site monitor check point list o k response has a 3xx status code
func (o *GetSiteMonitorCheckPointListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get site monitor check point list o k response has a 4xx status code
func (o *GetSiteMonitorCheckPointListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get site monitor check point list o k response has a 5xx status code
func (o *GetSiteMonitorCheckPointListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get site monitor check point list o k response a status code equal to that given
func (o *GetSiteMonitorCheckPointListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get site monitor check point list o k response
func (o *GetSiteMonitorCheckPointListOK) Code() int {
	return 200
}

func (o *GetSiteMonitorCheckPointListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/smcheckpoints][%d] getSiteMonitorCheckPointListOK %s", 200, payload)
}

func (o *GetSiteMonitorCheckPointListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/smcheckpoints][%d] getSiteMonitorCheckPointListOK %s", 200, payload)
}

func (o *GetSiteMonitorCheckPointListOK) GetPayload() *models.SiteMonitorCheckPointPaginationResponse {
	return o.Payload
}

func (o *GetSiteMonitorCheckPointListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.SiteMonitorCheckPointPaginationResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetSiteMonitorCheckPointListTooManyRequests creates a GetSiteMonitorCheckPointListTooManyRequests with default headers values
func NewGetSiteMonitorCheckPointListTooManyRequests() *GetSiteMonitorCheckPointListTooManyRequests {
	return &GetSiteMonitorCheckPointListTooManyRequests{}
}

/*
GetSiteMonitorCheckPointListTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetSiteMonitorCheckPointListTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get site monitor check point list too many requests response has a 2xx status code
func (o *GetSiteMonitorCheckPointListTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get site monitor check point list too many requests response has a 3xx status code
func (o *GetSiteMonitorCheckPointListTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get site monitor check point list too many requests response has a 4xx status code
func (o *GetSiteMonitorCheckPointListTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get site monitor check point list too many requests response has a 5xx status code
func (o *GetSiteMonitorCheckPointListTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get site monitor check point list too many requests response a status code equal to that given
func (o *GetSiteMonitorCheckPointListTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get site monitor check point list too many requests response
func (o *GetSiteMonitorCheckPointListTooManyRequests) Code() int {
	return 429
}

func (o *GetSiteMonitorCheckPointListTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /website/smcheckpoints][%d] getSiteMonitorCheckPointListTooManyRequests", 429)
}

func (o *GetSiteMonitorCheckPointListTooManyRequests) String() string {
	return fmt.Sprintf("[GET /website/smcheckpoints][%d] getSiteMonitorCheckPointListTooManyRequests", 429)
}

func (o *GetSiteMonitorCheckPointListTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetSiteMonitorCheckPointListDefault creates a GetSiteMonitorCheckPointListDefault with default headers values
func NewGetSiteMonitorCheckPointListDefault(code int) *GetSiteMonitorCheckPointListDefault {
	return &GetSiteMonitorCheckPointListDefault{
		_statusCode: code,
	}
}

/*
GetSiteMonitorCheckPointListDefault describes a response with status code -1, with default header values.

Error
*/
type GetSiteMonitorCheckPointListDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get site monitor check point list default response has a 2xx status code
func (o *GetSiteMonitorCheckPointListDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get site monitor check point list default response has a 3xx status code
func (o *GetSiteMonitorCheckPointListDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get site monitor check point list default response has a 4xx status code
func (o *GetSiteMonitorCheckPointListDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get site monitor check point list default response has a 5xx status code
func (o *GetSiteMonitorCheckPointListDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get site monitor check point list default response a status code equal to that given
func (o *GetSiteMonitorCheckPointListDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get site monitor check point list default response
func (o *GetSiteMonitorCheckPointListDefault) Code() int {
	return o._statusCode
}

func (o *GetSiteMonitorCheckPointListDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/smcheckpoints][%d] getSiteMonitorCheckPointList default %s", o._statusCode, payload)
}

func (o *GetSiteMonitorCheckPointListDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /website/smcheckpoints][%d] getSiteMonitorCheckPointList default %s", o._statusCode, payload)
}

func (o *GetSiteMonitorCheckPointListDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetSiteMonitorCheckPointListDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
