// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetTopTalkersGraphJSONReader is a Reader for the GetTopTalkersGraphJSON structure.
type GetTopTalkersGraphJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetTopTalkersGraphJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetTopTalkersGraphJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetTopTalkersGraphJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetTopTalkersGraphJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetTopTalkersGraphJSONOK creates a GetTopTalkersGraphJSONOK with default headers values
func NewGetTopTalkersGraphJSONOK() *GetTopTalkersGraphJSONOK {
	return &GetTopTalkersGraphJSONOK{}
}

/*
GetTopTalkersGraphJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetTopTalkersGraphJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get top talkers graph Json o k response has a 2xx status code
func (o *GetTopTalkersGraphJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get top talkers graph Json o k response has a 3xx status code
func (o *GetTopTalkersGraphJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get top talkers graph Json o k response has a 4xx status code
func (o *GetTopTalkersGraphJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get top talkers graph Json o k response has a 5xx status code
func (o *GetTopTalkersGraphJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get top talkers graph Json o k response a status code equal to that given
func (o *GetTopTalkersGraphJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get top talkers graph Json o k response
func (o *GetTopTalkersGraphJSONOK) Code() int {
	return 200
}

func (o *GetTopTalkersGraphJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/topTalkersGraph?__json=][%d] getTopTalkersGraphJsonOK %s", 200, payload)
}

func (o *GetTopTalkersGraphJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/topTalkersGraph?__json=][%d] getTopTalkersGraphJsonOK %s", 200, payload)
}

func (o *GetTopTalkersGraphJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetTopTalkersGraphJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetTopTalkersGraphJSONTooManyRequests creates a GetTopTalkersGraphJSONTooManyRequests with default headers values
func NewGetTopTalkersGraphJSONTooManyRequests() *GetTopTalkersGraphJSONTooManyRequests {
	return &GetTopTalkersGraphJSONTooManyRequests{}
}

/*
GetTopTalkersGraphJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetTopTalkersGraphJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get top talkers graph Json too many requests response has a 2xx status code
func (o *GetTopTalkersGraphJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get top talkers graph Json too many requests response has a 3xx status code
func (o *GetTopTalkersGraphJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get top talkers graph Json too many requests response has a 4xx status code
func (o *GetTopTalkersGraphJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get top talkers graph Json too many requests response has a 5xx status code
func (o *GetTopTalkersGraphJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get top talkers graph Json too many requests response a status code equal to that given
func (o *GetTopTalkersGraphJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get top talkers graph Json too many requests response
func (o *GetTopTalkersGraphJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetTopTalkersGraphJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{id}/topTalkersGraph?__json=][%d] getTopTalkersGraphJsonTooManyRequests", 429)
}

func (o *GetTopTalkersGraphJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /device/devices/{id}/topTalkersGraph?__json=][%d] getTopTalkersGraphJsonTooManyRequests", 429)
}

func (o *GetTopTalkersGraphJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetTopTalkersGraphJSONDefault creates a GetTopTalkersGraphJSONDefault with default headers values
func NewGetTopTalkersGraphJSONDefault(code int) *GetTopTalkersGraphJSONDefault {
	return &GetTopTalkersGraphJSONDefault{
		_statusCode: code,
	}
}

/*
GetTopTalkersGraphJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetTopTalkersGraphJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get top talkers graph Json default response has a 2xx status code
func (o *GetTopTalkersGraphJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get top talkers graph Json default response has a 3xx status code
func (o *GetTopTalkersGraphJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get top talkers graph Json default response has a 4xx status code
func (o *GetTopTalkersGraphJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get top talkers graph Json default response has a 5xx status code
func (o *GetTopTalkersGraphJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get top talkers graph Json default response a status code equal to that given
func (o *GetTopTalkersGraphJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get top talkers graph Json default response
func (o *GetTopTalkersGraphJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetTopTalkersGraphJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/topTalkersGraph?__json=][%d] getTopTalkersGraphJson default %s", o._statusCode, payload)
}

func (o *GetTopTalkersGraphJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /device/devices/{id}/topTalkersGraph?__json=][%d] getTopTalkersGraphJson default %s", o._statusCode, payload)
}

func (o *GetTopTalkersGraphJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetTopTalkersGraphJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
