// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetV4MetadataReader is a Reader for the GetV4Metadata structure.
type GetV4MetadataReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetV4MetadataReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetV4MetadataOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetV4MetadataTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetV4MetadataDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetV4MetadataOK creates a GetV4MetadataOK with default headers values
func NewGetV4MetadataOK() *GetV4MetadataOK {
	return &GetV4MetadataOK{}
}

/*
GetV4MetadataOK describes a response with status code 200, with default header values.

successful operation
*/
type GetV4MetadataOK struct {
	Payload *models.Response
}

// IsSuccess returns true when this get v4 metadata o k response has a 2xx status code
func (o *GetV4MetadataOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get v4 metadata o k response has a 3xx status code
func (o *GetV4MetadataOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get v4 metadata o k response has a 4xx status code
func (o *GetV4MetadataOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get v4 metadata o k response has a 5xx status code
func (o *GetV4MetadataOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get v4 metadata o k response a status code equal to that given
func (o *GetV4MetadataOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get v4 metadata o k response
func (o *GetV4MetadataOK) Code() int {
	return 200
}

func (o *GetV4MetadataOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logicmodules/metadata][%d] getV4MetadataOK %s", 200, payload)
}

func (o *GetV4MetadataOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logicmodules/metadata][%d] getV4MetadataOK %s", 200, payload)
}

func (o *GetV4MetadataOK) GetPayload() *models.Response {
	return o.Payload
}

func (o *GetV4MetadataOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Response)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetV4MetadataTooManyRequests creates a GetV4MetadataTooManyRequests with default headers values
func NewGetV4MetadataTooManyRequests() *GetV4MetadataTooManyRequests {
	return &GetV4MetadataTooManyRequests{}
}

/*
GetV4MetadataTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetV4MetadataTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get v4 metadata too many requests response has a 2xx status code
func (o *GetV4MetadataTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get v4 metadata too many requests response has a 3xx status code
func (o *GetV4MetadataTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get v4 metadata too many requests response has a 4xx status code
func (o *GetV4MetadataTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get v4 metadata too many requests response has a 5xx status code
func (o *GetV4MetadataTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get v4 metadata too many requests response a status code equal to that given
func (o *GetV4MetadataTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get v4 metadata too many requests response
func (o *GetV4MetadataTooManyRequests) Code() int {
	return 429
}

func (o *GetV4MetadataTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /setting/logicmodules/metadata][%d] getV4MetadataTooManyRequests", 429)
}

func (o *GetV4MetadataTooManyRequests) String() string {
	return fmt.Sprintf("[GET /setting/logicmodules/metadata][%d] getV4MetadataTooManyRequests", 429)
}

func (o *GetV4MetadataTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetV4MetadataDefault creates a GetV4MetadataDefault with default headers values
func NewGetV4MetadataDefault(code int) *GetV4MetadataDefault {
	return &GetV4MetadataDefault{
		_statusCode: code,
	}
}

/*
GetV4MetadataDefault describes a response with status code -1, with default header values.

Error
*/
type GetV4MetadataDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get v4 metadata default response has a 2xx status code
func (o *GetV4MetadataDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get v4 metadata default response has a 3xx status code
func (o *GetV4MetadataDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get v4 metadata default response has a 4xx status code
func (o *GetV4MetadataDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get v4 metadata default response has a 5xx status code
func (o *GetV4MetadataDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get v4 metadata default response a status code equal to that given
func (o *GetV4MetadataDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get v4 metadata default response
func (o *GetV4MetadataDefault) Code() int {
	return o._statusCode
}

func (o *GetV4MetadataDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logicmodules/metadata][%d] getV4Metadata default %s", o._statusCode, payload)
}

func (o *GetV4MetadataDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /setting/logicmodules/metadata][%d] getV4Metadata default %s", o._statusCode, payload)
}

func (o *GetV4MetadataDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetV4MetadataDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
