// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetWidgetByIDJSONReader is a Reader for the GetWidgetByIDJSON structure.
type GetWidgetByIDJSONReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetWidgetByIDJSONReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetWidgetByIDJSONOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetWidgetByIDJSONTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetWidgetByIDJSONDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetWidgetByIDJSONOK creates a GetWidgetByIDJSONOK with default headers values
func NewGetWidgetByIDJSONOK() *GetWidgetByIDJSONOK {
	return &GetWidgetByIDJSONOK{}
}

/*
GetWidgetByIDJSONOK describes a response with status code 200, with default header values.

successful operation
*/
type GetWidgetByIDJSONOK struct {
	Payload interface{}
}

// IsSuccess returns true when this get widget by Id Json o k response has a 2xx status code
func (o *GetWidgetByIDJSONOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get widget by Id Json o k response has a 3xx status code
func (o *GetWidgetByIDJSONOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get widget by Id Json o k response has a 4xx status code
func (o *GetWidgetByIDJSONOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get widget by Id Json o k response has a 5xx status code
func (o *GetWidgetByIDJSONOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get widget by Id Json o k response a status code equal to that given
func (o *GetWidgetByIDJSONOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get widget by Id Json o k response
func (o *GetWidgetByIDJSONOK) Code() int {
	return 200
}

func (o *GetWidgetByIDJSONOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/widgets/{id}?__json=][%d] getWidgetByIdJsonOK %s", 200, payload)
}

func (o *GetWidgetByIDJSONOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/widgets/{id}?__json=][%d] getWidgetByIdJsonOK %s", 200, payload)
}

func (o *GetWidgetByIDJSONOK) GetPayload() interface{} {
	return o.Payload
}

func (o *GetWidgetByIDJSONOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetWidgetByIDJSONTooManyRequests creates a GetWidgetByIDJSONTooManyRequests with default headers values
func NewGetWidgetByIDJSONTooManyRequests() *GetWidgetByIDJSONTooManyRequests {
	return &GetWidgetByIDJSONTooManyRequests{}
}

/*
GetWidgetByIDJSONTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetWidgetByIDJSONTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get widget by Id Json too many requests response has a 2xx status code
func (o *GetWidgetByIDJSONTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get widget by Id Json too many requests response has a 3xx status code
func (o *GetWidgetByIDJSONTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get widget by Id Json too many requests response has a 4xx status code
func (o *GetWidgetByIDJSONTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get widget by Id Json too many requests response has a 5xx status code
func (o *GetWidgetByIDJSONTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get widget by Id Json too many requests response a status code equal to that given
func (o *GetWidgetByIDJSONTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get widget by Id Json too many requests response
func (o *GetWidgetByIDJSONTooManyRequests) Code() int {
	return 429
}

func (o *GetWidgetByIDJSONTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /dashboard/widgets/{id}?__json=][%d] getWidgetByIdJsonTooManyRequests", 429)
}

func (o *GetWidgetByIDJSONTooManyRequests) String() string {
	return fmt.Sprintf("[GET /dashboard/widgets/{id}?__json=][%d] getWidgetByIdJsonTooManyRequests", 429)
}

func (o *GetWidgetByIDJSONTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetWidgetByIDJSONDefault creates a GetWidgetByIDJSONDefault with default headers values
func NewGetWidgetByIDJSONDefault(code int) *GetWidgetByIDJSONDefault {
	return &GetWidgetByIDJSONDefault{
		_statusCode: code,
	}
}

/*
GetWidgetByIDJSONDefault describes a response with status code -1, with default header values.

Error
*/
type GetWidgetByIDJSONDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get widget by Id Json default response has a 2xx status code
func (o *GetWidgetByIDJSONDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get widget by Id Json default response has a 3xx status code
func (o *GetWidgetByIDJSONDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get widget by Id Json default response has a 4xx status code
func (o *GetWidgetByIDJSONDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get widget by Id Json default response has a 5xx status code
func (o *GetWidgetByIDJSONDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get widget by Id Json default response a status code equal to that given
func (o *GetWidgetByIDJSONDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get widget by Id Json default response
func (o *GetWidgetByIDJSONDefault) Code() int {
	return o._statusCode
}

func (o *GetWidgetByIDJSONDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/widgets/{id}?__json=][%d] getWidgetByIdJson default %s", o._statusCode, payload)
}

func (o *GetWidgetByIDJSONDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/widgets/{id}?__json=][%d] getWidgetByIdJson default %s", o._statusCode, payload)
}

func (o *GetWidgetByIDJSONDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetWidgetByIDJSONDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
