// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// GetWidgetDataByIDReader is a Reader for the GetWidgetDataByID structure.
type GetWidgetDataByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetWidgetDataByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetWidgetDataByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetWidgetDataByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetWidgetDataByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetWidgetDataByIDOK creates a GetWidgetDataByIDOK with default headers values
func NewGetWidgetDataByIDOK() *GetWidgetDataByIDOK {
	return &GetWidgetDataByIDOK{}
}

/*
GetWidgetDataByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetWidgetDataByIDOK struct {
	Payload models.WidgetData
}

// IsSuccess returns true when this get widget data by Id o k response has a 2xx status code
func (o *GetWidgetDataByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get widget data by Id o k response has a 3xx status code
func (o *GetWidgetDataByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get widget data by Id o k response has a 4xx status code
func (o *GetWidgetDataByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get widget data by Id o k response has a 5xx status code
func (o *GetWidgetDataByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get widget data by Id o k response a status code equal to that given
func (o *GetWidgetDataByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get widget data by Id o k response
func (o *GetWidgetDataByIDOK) Code() int {
	return 200
}

func (o *GetWidgetDataByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/widgets/{id}/data][%d] getWidgetDataByIdOK %s", 200, payload)
}

func (o *GetWidgetDataByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/widgets/{id}/data][%d] getWidgetDataByIdOK %s", 200, payload)
}

func (o *GetWidgetDataByIDOK) GetPayload() models.WidgetData {
	return o.Payload
}

func (o *GetWidgetDataByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload as interface type
	payload, err := models.UnmarshalWidgetData(response.Body(), consumer)
	if err != nil {
		return err
	}
	o.Payload = payload

	return nil
}

// NewGetWidgetDataByIDTooManyRequests creates a GetWidgetDataByIDTooManyRequests with default headers values
func NewGetWidgetDataByIDTooManyRequests() *GetWidgetDataByIDTooManyRequests {
	return &GetWidgetDataByIDTooManyRequests{}
}

/*
GetWidgetDataByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetWidgetDataByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this get widget data by Id too many requests response has a 2xx status code
func (o *GetWidgetDataByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get widget data by Id too many requests response has a 3xx status code
func (o *GetWidgetDataByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get widget data by Id too many requests response has a 4xx status code
func (o *GetWidgetDataByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get widget data by Id too many requests response has a 5xx status code
func (o *GetWidgetDataByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get widget data by Id too many requests response a status code equal to that given
func (o *GetWidgetDataByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get widget data by Id too many requests response
func (o *GetWidgetDataByIDTooManyRequests) Code() int {
	return 429
}

func (o *GetWidgetDataByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /dashboard/widgets/{id}/data][%d] getWidgetDataByIdTooManyRequests", 429)
}

func (o *GetWidgetDataByIDTooManyRequests) String() string {
	return fmt.Sprintf("[GET /dashboard/widgets/{id}/data][%d] getWidgetDataByIdTooManyRequests", 429)
}

func (o *GetWidgetDataByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetWidgetDataByIDDefault creates a GetWidgetDataByIDDefault with default headers values
func NewGetWidgetDataByIDDefault(code int) *GetWidgetDataByIDDefault {
	return &GetWidgetDataByIDDefault{
		_statusCode: code,
	}
}

/*
GetWidgetDataByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetWidgetDataByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this get widget data by Id default response has a 2xx status code
func (o *GetWidgetDataByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get widget data by Id default response has a 3xx status code
func (o *GetWidgetDataByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get widget data by Id default response has a 4xx status code
func (o *GetWidgetDataByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get widget data by Id default response has a 5xx status code
func (o *GetWidgetDataByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get widget data by Id default response a status code equal to that given
func (o *GetWidgetDataByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get widget data by Id default response
func (o *GetWidgetDataByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetWidgetDataByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/widgets/{id}/data][%d] getWidgetDataById default %s", o._statusCode, payload)
}

func (o *GetWidgetDataByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /dashboard/widgets/{id}/data][%d] getWidgetDataById default %s", o._statusCode, payload)
}

func (o *GetWidgetDataByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetWidgetDataByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
