// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewImportBatchJobParams creates a new ImportBatchJobParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewImportBatchJobParams() *ImportBatchJobParams {
	return &ImportBatchJobParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewImportBatchJobParamsWithTimeout creates a new ImportBatchJobParams object
// with the ability to set a timeout on a request.
func NewImportBatchJobParamsWithTimeout(timeout time.Duration) *ImportBatchJobParams {
	return &ImportBatchJobParams{
		timeout: timeout,
	}
}

// NewImportBatchJobParamsWithContext creates a new ImportBatchJobParams object
// with the ability to set a context for a request.
func NewImportBatchJobParamsWithContext(ctx context.Context) *ImportBatchJobParams {
	return &ImportBatchJobParams{
		Context: ctx,
	}
}

// NewImportBatchJobParamsWithHTTPClient creates a new ImportBatchJobParams object
// with the ability to set a custom HTTPClient for a request.
func NewImportBatchJobParamsWithHTTPClient(client *http.Client) *ImportBatchJobParams {
	return &ImportBatchJobParams{
		HTTPClient: client,
	}
}

/*
ImportBatchJobParams contains all the parameters to send to the API endpoint

	for the import batch job operation.

	Typically these are written to a http.Request.
*/
type ImportBatchJobParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// File.
	File runtime.NamedReadCloser

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the import batch job params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ImportBatchJobParams) WithDefaults() *ImportBatchJobParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the import batch job params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ImportBatchJobParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := ImportBatchJobParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the import batch job params
func (o *ImportBatchJobParams) WithTimeout(timeout time.Duration) *ImportBatchJobParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the import batch job params
func (o *ImportBatchJobParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the import batch job params
func (o *ImportBatchJobParams) WithContext(ctx context.Context) *ImportBatchJobParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the import batch job params
func (o *ImportBatchJobParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the import batch job params
func (o *ImportBatchJobParams) WithHTTPClient(client *http.Client) *ImportBatchJobParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the import batch job params
func (o *ImportBatchJobParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the import batch job params
func (o *ImportBatchJobParams) WithUserAgent(userAgent *string) *ImportBatchJobParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the import batch job params
func (o *ImportBatchJobParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithFile adds the file to the import batch job params
func (o *ImportBatchJobParams) WithFile(file runtime.NamedReadCloser) *ImportBatchJobParams {
	o.SetFile(file)
	return o
}

// SetFile adds the file to the import batch job params
func (o *ImportBatchJobParams) SetFile(file runtime.NamedReadCloser) {
	o.File = file
}

// WriteToRequest writes these params to a swagger request
func (o *ImportBatchJobParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	// form file param file
	if err := r.SetFileParam("file", o.File); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
