// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// ImportBatchJobReader is a Reader for the ImportBatchJob structure.
type ImportBatchJobReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ImportBatchJobReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewImportBatchJobOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewImportBatchJobTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewImportBatchJobDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewImportBatchJobOK creates a ImportBatchJobOK with default headers values
func NewImportBatchJobOK() *ImportBatchJobOK {
	return &ImportBatchJobOK{}
}

/*
ImportBatchJobOK describes a response with status code 200, with default header values.

successful operation
*/
type ImportBatchJobOK struct {
	Payload interface{}
}

// IsSuccess returns true when this import batch job o k response has a 2xx status code
func (o *ImportBatchJobOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this import batch job o k response has a 3xx status code
func (o *ImportBatchJobOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this import batch job o k response has a 4xx status code
func (o *ImportBatchJobOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this import batch job o k response has a 5xx status code
func (o *ImportBatchJobOK) IsServerError() bool {
	return false
}

// IsCode returns true when this import batch job o k response a status code equal to that given
func (o *ImportBatchJobOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the import batch job o k response
func (o *ImportBatchJobOK) Code() int {
	return 200
}

func (o *ImportBatchJobOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/batchjobs/importxml][%d] importBatchJobOK %s", 200, payload)
}

func (o *ImportBatchJobOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/batchjobs/importxml][%d] importBatchJobOK %s", 200, payload)
}

func (o *ImportBatchJobOK) GetPayload() interface{} {
	return o.Payload
}

func (o *ImportBatchJobOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewImportBatchJobTooManyRequests creates a ImportBatchJobTooManyRequests with default headers values
func NewImportBatchJobTooManyRequests() *ImportBatchJobTooManyRequests {
	return &ImportBatchJobTooManyRequests{}
}

/*
ImportBatchJobTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type ImportBatchJobTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this import batch job too many requests response has a 2xx status code
func (o *ImportBatchJobTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this import batch job too many requests response has a 3xx status code
func (o *ImportBatchJobTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this import batch job too many requests response has a 4xx status code
func (o *ImportBatchJobTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this import batch job too many requests response has a 5xx status code
func (o *ImportBatchJobTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this import batch job too many requests response a status code equal to that given
func (o *ImportBatchJobTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the import batch job too many requests response
func (o *ImportBatchJobTooManyRequests) Code() int {
	return 429
}

func (o *ImportBatchJobTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/batchjobs/importxml][%d] importBatchJobTooManyRequests", 429)
}

func (o *ImportBatchJobTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/batchjobs/importxml][%d] importBatchJobTooManyRequests", 429)
}

func (o *ImportBatchJobTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewImportBatchJobDefault creates a ImportBatchJobDefault with default headers values
func NewImportBatchJobDefault(code int) *ImportBatchJobDefault {
	return &ImportBatchJobDefault{
		_statusCode: code,
	}
}

/*
ImportBatchJobDefault describes a response with status code -1, with default header values.

Error
*/
type ImportBatchJobDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this import batch job default response has a 2xx status code
func (o *ImportBatchJobDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this import batch job default response has a 3xx status code
func (o *ImportBatchJobDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this import batch job default response has a 4xx status code
func (o *ImportBatchJobDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this import batch job default response has a 5xx status code
func (o *ImportBatchJobDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this import batch job default response a status code equal to that given
func (o *ImportBatchJobDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the import batch job default response
func (o *ImportBatchJobDefault) Code() int {
	return o._statusCode
}

func (o *ImportBatchJobDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/batchjobs/importxml][%d] importBatchJob default %s", o._statusCode, payload)
}

func (o *ImportBatchJobDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/batchjobs/importxml][%d] importBatchJob default %s", o._statusCode, payload)
}

func (o *ImportBatchJobDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ImportBatchJobDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
