// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// ImportConfigSourceReader is a Reader for the ImportConfigSource structure.
type ImportConfigSourceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ImportConfigSourceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewImportConfigSourceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewImportConfigSourceTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewImportConfigSourceDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewImportConfigSourceOK creates a ImportConfigSourceOK with default headers values
func NewImportConfigSourceOK() *ImportConfigSourceOK {
	return &ImportConfigSourceOK{}
}

/*
ImportConfigSourceOK describes a response with status code 200, with default header values.

successful operation
*/
type ImportConfigSourceOK struct {
	Payload interface{}
}

// IsSuccess returns true when this import config source o k response has a 2xx status code
func (o *ImportConfigSourceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this import config source o k response has a 3xx status code
func (o *ImportConfigSourceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this import config source o k response has a 4xx status code
func (o *ImportConfigSourceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this import config source o k response has a 5xx status code
func (o *ImportConfigSourceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this import config source o k response a status code equal to that given
func (o *ImportConfigSourceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the import config source o k response
func (o *ImportConfigSourceOK) Code() int {
	return 200
}

func (o *ImportConfigSourceOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/configsources/importxml][%d] importConfigSourceOK %s", 200, payload)
}

func (o *ImportConfigSourceOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/configsources/importxml][%d] importConfigSourceOK %s", 200, payload)
}

func (o *ImportConfigSourceOK) GetPayload() interface{} {
	return o.Payload
}

func (o *ImportConfigSourceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewImportConfigSourceTooManyRequests creates a ImportConfigSourceTooManyRequests with default headers values
func NewImportConfigSourceTooManyRequests() *ImportConfigSourceTooManyRequests {
	return &ImportConfigSourceTooManyRequests{}
}

/*
ImportConfigSourceTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type ImportConfigSourceTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this import config source too many requests response has a 2xx status code
func (o *ImportConfigSourceTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this import config source too many requests response has a 3xx status code
func (o *ImportConfigSourceTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this import config source too many requests response has a 4xx status code
func (o *ImportConfigSourceTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this import config source too many requests response has a 5xx status code
func (o *ImportConfigSourceTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this import config source too many requests response a status code equal to that given
func (o *ImportConfigSourceTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the import config source too many requests response
func (o *ImportConfigSourceTooManyRequests) Code() int {
	return 429
}

func (o *ImportConfigSourceTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /setting/configsources/importxml][%d] importConfigSourceTooManyRequests", 429)
}

func (o *ImportConfigSourceTooManyRequests) String() string {
	return fmt.Sprintf("[POST /setting/configsources/importxml][%d] importConfigSourceTooManyRequests", 429)
}

func (o *ImportConfigSourceTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewImportConfigSourceDefault creates a ImportConfigSourceDefault with default headers values
func NewImportConfigSourceDefault(code int) *ImportConfigSourceDefault {
	return &ImportConfigSourceDefault{
		_statusCode: code,
	}
}

/*
ImportConfigSourceDefault describes a response with status code -1, with default header values.

Error
*/
type ImportConfigSourceDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this import config source default response has a 2xx status code
func (o *ImportConfigSourceDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this import config source default response has a 3xx status code
func (o *ImportConfigSourceDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this import config source default response has a 4xx status code
func (o *ImportConfigSourceDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this import config source default response has a 5xx status code
func (o *ImportConfigSourceDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this import config source default response a status code equal to that given
func (o *ImportConfigSourceDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the import config source default response
func (o *ImportConfigSourceDefault) Code() int {
	return o._statusCode
}

func (o *ImportConfigSourceDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/configsources/importxml][%d] importConfigSource default %s", o._statusCode, payload)
}

func (o *ImportConfigSourceDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /setting/configsources/importxml][%d] importConfigSource default %s", o._statusCode, payload)
}

func (o *ImportConfigSourceDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ImportConfigSourceDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
