// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewPartitionActionParams creates a new PartitionActionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPartitionActionParams() *PartitionActionParams {
	return &PartitionActionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPartitionActionParamsWithTimeout creates a new PartitionActionParams object
// with the ability to set a timeout on a request.
func NewPartitionActionParamsWithTimeout(timeout time.Duration) *PartitionActionParams {
	return &PartitionActionParams{
		timeout: timeout,
	}
}

// NewPartitionActionParamsWithContext creates a new PartitionActionParams object
// with the ability to set a context for a request.
func NewPartitionActionParamsWithContext(ctx context.Context) *PartitionActionParams {
	return &PartitionActionParams{
		Context: ctx,
	}
}

// NewPartitionActionParamsWithHTTPClient creates a new PartitionActionParams object
// with the ability to set a custom HTTPClient for a request.
func NewPartitionActionParamsWithHTTPClient(client *http.Client) *PartitionActionParams {
	return &PartitionActionParams{
		HTTPClient: client,
	}
}

/*
PartitionActionParams contains all the parameters to send to the API endpoint

	for the partition action operation.

	Typically these are written to a http.Request.
*/
type PartitionActionParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Action.
	Action string

	// ID.
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the partition action params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PartitionActionParams) WithDefaults() *PartitionActionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the partition action params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PartitionActionParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := PartitionActionParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the partition action params
func (o *PartitionActionParams) WithTimeout(timeout time.Duration) *PartitionActionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the partition action params
func (o *PartitionActionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the partition action params
func (o *PartitionActionParams) WithContext(ctx context.Context) *PartitionActionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the partition action params
func (o *PartitionActionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the partition action params
func (o *PartitionActionParams) WithHTTPClient(client *http.Client) *PartitionActionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the partition action params
func (o *PartitionActionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the partition action params
func (o *PartitionActionParams) WithUserAgent(userAgent *string) *PartitionActionParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the partition action params
func (o *PartitionActionParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithAction adds the action to the partition action params
func (o *PartitionActionParams) WithAction(action string) *PartitionActionParams {
	o.SetAction(action)
	return o
}

// SetAction adds the action to the partition action params
func (o *PartitionActionParams) SetAction(action string) {
	o.Action = action
}

// WithID adds the id to the partition action params
func (o *PartitionActionParams) WithID(id string) *PartitionActionParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the partition action params
func (o *PartitionActionParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *PartitionActionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}

	// path param action
	if err := r.SetPathParam("action", o.Action); err != nil {
		return err
	}

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
