// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// PartitionActionReader is a Reader for the PartitionAction structure.
type PartitionActionReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PartitionActionReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPartitionActionOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPartitionActionTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPartitionActionDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPartitionActionOK creates a PartitionActionOK with default headers values
func NewPartitionActionOK() *PartitionActionOK {
	return &PartitionActionOK{}
}

/*
PartitionActionOK describes a response with status code 200, with default header values.

successful operation
*/
type PartitionActionOK struct {
	Payload *models.LogPartition
}

// IsSuccess returns true when this partition action o k response has a 2xx status code
func (o *PartitionActionOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this partition action o k response has a 3xx status code
func (o *PartitionActionOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this partition action o k response has a 4xx status code
func (o *PartitionActionOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this partition action o k response has a 5xx status code
func (o *PartitionActionOK) IsServerError() bool {
	return false
}

// IsCode returns true when this partition action o k response a status code equal to that given
func (o *PartitionActionOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the partition action o k response
func (o *PartitionActionOK) Code() int {
	return 200
}

func (o *PartitionActionOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /log/partitions/{id}/{action}][%d] partitionActionOK %s", 200, payload)
}

func (o *PartitionActionOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /log/partitions/{id}/{action}][%d] partitionActionOK %s", 200, payload)
}

func (o *PartitionActionOK) GetPayload() *models.LogPartition {
	return o.Payload
}

func (o *PartitionActionOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.LogPartition)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPartitionActionTooManyRequests creates a PartitionActionTooManyRequests with default headers values
func NewPartitionActionTooManyRequests() *PartitionActionTooManyRequests {
	return &PartitionActionTooManyRequests{}
}

/*
PartitionActionTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PartitionActionTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this partition action too many requests response has a 2xx status code
func (o *PartitionActionTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this partition action too many requests response has a 3xx status code
func (o *PartitionActionTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this partition action too many requests response has a 4xx status code
func (o *PartitionActionTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this partition action too many requests response has a 5xx status code
func (o *PartitionActionTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this partition action too many requests response a status code equal to that given
func (o *PartitionActionTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the partition action too many requests response
func (o *PartitionActionTooManyRequests) Code() int {
	return 429
}

func (o *PartitionActionTooManyRequests) Error() string {
	return fmt.Sprintf("[POST /log/partitions/{id}/{action}][%d] partitionActionTooManyRequests", 429)
}

func (o *PartitionActionTooManyRequests) String() string {
	return fmt.Sprintf("[POST /log/partitions/{id}/{action}][%d] partitionActionTooManyRequests", 429)
}

func (o *PartitionActionTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPartitionActionDefault creates a PartitionActionDefault with default headers values
func NewPartitionActionDefault(code int) *PartitionActionDefault {
	return &PartitionActionDefault{
		_statusCode: code,
	}
}

/*
PartitionActionDefault describes a response with status code -1, with default header values.

Error
*/
type PartitionActionDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this partition action default response has a 2xx status code
func (o *PartitionActionDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this partition action default response has a 3xx status code
func (o *PartitionActionDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this partition action default response has a 4xx status code
func (o *PartitionActionDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this partition action default response has a 5xx status code
func (o *PartitionActionDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this partition action default response a status code equal to that given
func (o *PartitionActionDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the partition action default response
func (o *PartitionActionDefault) Code() int {
	return o._statusCode
}

func (o *PartitionActionDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /log/partitions/{id}/{action}][%d] partitionAction default %s", o._statusCode, payload)
}

func (o *PartitionActionDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[POST /log/partitions/{id}/{action}][%d] partitionAction default %s", o._statusCode, payload)
}

func (o *PartitionActionDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PartitionActionDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
