// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewPatchDefaultDashboardParams creates a new PatchDefaultDashboardParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPatchDefaultDashboardParams() *PatchDefaultDashboardParams {
	return &PatchDefaultDashboardParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPatchDefaultDashboardParamsWithTimeout creates a new PatchDefaultDashboardParams object
// with the ability to set a timeout on a request.
func NewPatchDefaultDashboardParamsWithTimeout(timeout time.Duration) *PatchDefaultDashboardParams {
	return &PatchDefaultDashboardParams{
		timeout: timeout,
	}
}

// NewPatchDefaultDashboardParamsWithContext creates a new PatchDefaultDashboardParams object
// with the ability to set a context for a request.
func NewPatchDefaultDashboardParamsWithContext(ctx context.Context) *PatchDefaultDashboardParams {
	return &PatchDefaultDashboardParams{
		Context: ctx,
	}
}

// NewPatchDefaultDashboardParamsWithHTTPClient creates a new PatchDefaultDashboardParams object
// with the ability to set a custom HTTPClient for a request.
func NewPatchDefaultDashboardParamsWithHTTPClient(client *http.Client) *PatchDefaultDashboardParams {
	return &PatchDefaultDashboardParams{
		HTTPClient: client,
	}
}

/*
PatchDefaultDashboardParams contains all the parameters to send to the API endpoint

	for the patch default dashboard operation.

	Typically these are written to a http.Request.
*/
type PatchDefaultDashboardParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.RestUserCustomizedDataV3

	// ID.
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the patch default dashboard params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PatchDefaultDashboardParams) WithDefaults() *PatchDefaultDashboardParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the patch default dashboard params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PatchDefaultDashboardParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := PatchDefaultDashboardParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the patch default dashboard params
func (o *PatchDefaultDashboardParams) WithTimeout(timeout time.Duration) *PatchDefaultDashboardParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the patch default dashboard params
func (o *PatchDefaultDashboardParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the patch default dashboard params
func (o *PatchDefaultDashboardParams) WithContext(ctx context.Context) *PatchDefaultDashboardParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the patch default dashboard params
func (o *PatchDefaultDashboardParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the patch default dashboard params
func (o *PatchDefaultDashboardParams) WithHTTPClient(client *http.Client) *PatchDefaultDashboardParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the patch default dashboard params
func (o *PatchDefaultDashboardParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the patch default dashboard params
func (o *PatchDefaultDashboardParams) WithUserAgent(userAgent *string) *PatchDefaultDashboardParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the patch default dashboard params
func (o *PatchDefaultDashboardParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the patch default dashboard params
func (o *PatchDefaultDashboardParams) WithBody(body *models.RestUserCustomizedDataV3) *PatchDefaultDashboardParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the patch default dashboard params
func (o *PatchDefaultDashboardParams) SetBody(body *models.RestUserCustomizedDataV3) {
	o.Body = body
}

// WithID adds the id to the patch default dashboard params
func (o *PatchDefaultDashboardParams) WithID(id string) *PatchDefaultDashboardParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the patch default dashboard params
func (o *PatchDefaultDashboardParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *PatchDefaultDashboardParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
