// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// PatchJobMonitorReader is a Reader for the PatchJobMonitor structure.
type PatchJobMonitorReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchJobMonitorReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchJobMonitorOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchJobMonitorTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchJobMonitorDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchJobMonitorOK creates a PatchJobMonitorOK with default headers values
func NewPatchJobMonitorOK() *PatchJobMonitorOK {
	return &PatchJobMonitorOK{}
}

/*
PatchJobMonitorOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchJobMonitorOK struct {
	Payload *models.BatchJob
}

// IsSuccess returns true when this patch job monitor o k response has a 2xx status code
func (o *PatchJobMonitorOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this patch job monitor o k response has a 3xx status code
func (o *PatchJobMonitorOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch job monitor o k response has a 4xx status code
func (o *PatchJobMonitorOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this patch job monitor o k response has a 5xx status code
func (o *PatchJobMonitorOK) IsServerError() bool {
	return false
}

// IsCode returns true when this patch job monitor o k response a status code equal to that given
func (o *PatchJobMonitorOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the patch job monitor o k response
func (o *PatchJobMonitorOK) Code() int {
	return 200
}

func (o *PatchJobMonitorOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/batchjobs/{id}][%d] patchJobMonitorOK %s", 200, payload)
}

func (o *PatchJobMonitorOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/batchjobs/{id}][%d] patchJobMonitorOK %s", 200, payload)
}

func (o *PatchJobMonitorOK) GetPayload() *models.BatchJob {
	return o.Payload
}

func (o *PatchJobMonitorOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.BatchJob)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPatchJobMonitorTooManyRequests creates a PatchJobMonitorTooManyRequests with default headers values
func NewPatchJobMonitorTooManyRequests() *PatchJobMonitorTooManyRequests {
	return &PatchJobMonitorTooManyRequests{}
}

/*
PatchJobMonitorTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchJobMonitorTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this patch job monitor too many requests response has a 2xx status code
func (o *PatchJobMonitorTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this patch job monitor too many requests response has a 3xx status code
func (o *PatchJobMonitorTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch job monitor too many requests response has a 4xx status code
func (o *PatchJobMonitorTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this patch job monitor too many requests response has a 5xx status code
func (o *PatchJobMonitorTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this patch job monitor too many requests response a status code equal to that given
func (o *PatchJobMonitorTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the patch job monitor too many requests response
func (o *PatchJobMonitorTooManyRequests) Code() int {
	return 429
}

func (o *PatchJobMonitorTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /setting/batchjobs/{id}][%d] patchJobMonitorTooManyRequests", 429)
}

func (o *PatchJobMonitorTooManyRequests) String() string {
	return fmt.Sprintf("[PATCH /setting/batchjobs/{id}][%d] patchJobMonitorTooManyRequests", 429)
}

func (o *PatchJobMonitorTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchJobMonitorDefault creates a PatchJobMonitorDefault with default headers values
func NewPatchJobMonitorDefault(code int) *PatchJobMonitorDefault {
	return &PatchJobMonitorDefault{
		_statusCode: code,
	}
}

/*
PatchJobMonitorDefault describes a response with status code -1, with default header values.

Error
*/
type PatchJobMonitorDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this patch job monitor default response has a 2xx status code
func (o *PatchJobMonitorDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this patch job monitor default response has a 3xx status code
func (o *PatchJobMonitorDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this patch job monitor default response has a 4xx status code
func (o *PatchJobMonitorDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this patch job monitor default response has a 5xx status code
func (o *PatchJobMonitorDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this patch job monitor default response a status code equal to that given
func (o *PatchJobMonitorDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the patch job monitor default response
func (o *PatchJobMonitorDefault) Code() int {
	return o._statusCode
}

func (o *PatchJobMonitorDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/batchjobs/{id}][%d] patchJobMonitor default %s", o._statusCode, payload)
}

func (o *PatchJobMonitorDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/batchjobs/{id}][%d] patchJobMonitor default %s", o._statusCode, payload)
}

func (o *PatchJobMonitorDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchJobMonitorDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
