// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// PatchLogSourceReader is a Reader for the PatchLogSource structure.
type PatchLogSourceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchLogSourceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchLogSourceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchLogSourceTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchLogSourceDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchLogSourceOK creates a PatchLogSourceOK with default headers values
func NewPatchLogSourceOK() *PatchLogSourceOK {
	return &PatchLogSourceOK{}
}

/*
PatchLogSourceOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchLogSourceOK struct {
	Payload *models.LogSource
}

// IsSuccess returns true when this patch log source o k response has a 2xx status code
func (o *PatchLogSourceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this patch log source o k response has a 3xx status code
func (o *PatchLogSourceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch log source o k response has a 4xx status code
func (o *PatchLogSourceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this patch log source o k response has a 5xx status code
func (o *PatchLogSourceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this patch log source o k response a status code equal to that given
func (o *PatchLogSourceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the patch log source o k response
func (o *PatchLogSourceOK) Code() int {
	return 200
}

func (o *PatchLogSourceOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/logsources/{id}][%d] patchLogSourceOK %s", 200, payload)
}

func (o *PatchLogSourceOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/logsources/{id}][%d] patchLogSourceOK %s", 200, payload)
}

func (o *PatchLogSourceOK) GetPayload() *models.LogSource {
	return o.Payload
}

func (o *PatchLogSourceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.LogSource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPatchLogSourceTooManyRequests creates a PatchLogSourceTooManyRequests with default headers values
func NewPatchLogSourceTooManyRequests() *PatchLogSourceTooManyRequests {
	return &PatchLogSourceTooManyRequests{}
}

/*
PatchLogSourceTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchLogSourceTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this patch log source too many requests response has a 2xx status code
func (o *PatchLogSourceTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this patch log source too many requests response has a 3xx status code
func (o *PatchLogSourceTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch log source too many requests response has a 4xx status code
func (o *PatchLogSourceTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this patch log source too many requests response has a 5xx status code
func (o *PatchLogSourceTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this patch log source too many requests response a status code equal to that given
func (o *PatchLogSourceTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the patch log source too many requests response
func (o *PatchLogSourceTooManyRequests) Code() int {
	return 429
}

func (o *PatchLogSourceTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /setting/logsources/{id}][%d] patchLogSourceTooManyRequests", 429)
}

func (o *PatchLogSourceTooManyRequests) String() string {
	return fmt.Sprintf("[PATCH /setting/logsources/{id}][%d] patchLogSourceTooManyRequests", 429)
}

func (o *PatchLogSourceTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchLogSourceDefault creates a PatchLogSourceDefault with default headers values
func NewPatchLogSourceDefault(code int) *PatchLogSourceDefault {
	return &PatchLogSourceDefault{
		_statusCode: code,
	}
}

/*
PatchLogSourceDefault describes a response with status code -1, with default header values.

Error
*/
type PatchLogSourceDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this patch log source default response has a 2xx status code
func (o *PatchLogSourceDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this patch log source default response has a 3xx status code
func (o *PatchLogSourceDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this patch log source default response has a 4xx status code
func (o *PatchLogSourceDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this patch log source default response has a 5xx status code
func (o *PatchLogSourceDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this patch log source default response a status code equal to that given
func (o *PatchLogSourceDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the patch log source default response
func (o *PatchLogSourceDefault) Code() int {
	return o._statusCode
}

func (o *PatchLogSourceDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/logsources/{id}][%d] patchLogSource default %s", o._statusCode, payload)
}

func (o *PatchLogSourceDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/logsources/{id}][%d] patchLogSource default %s", o._statusCode, payload)
}

func (o *PatchLogSourceDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchLogSourceDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
