// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// PatchNetscanReader is a Reader for the PatchNetscan structure.
type PatchNetscanReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchNetscanReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchNetscanOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchNetscanTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchNetscanDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchNetscanOK creates a PatchNetscanOK with default headers values
func NewPatchNetscanOK() *PatchNetscanOK {
	return &PatchNetscanOK{}
}

/*
PatchNetscanOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchNetscanOK struct {
	Payload models.Netscan
}

// IsSuccess returns true when this patch netscan o k response has a 2xx status code
func (o *PatchNetscanOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this patch netscan o k response has a 3xx status code
func (o *PatchNetscanOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch netscan o k response has a 4xx status code
func (o *PatchNetscanOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this patch netscan o k response has a 5xx status code
func (o *PatchNetscanOK) IsServerError() bool {
	return false
}

// IsCode returns true when this patch netscan o k response a status code equal to that given
func (o *PatchNetscanOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the patch netscan o k response
func (o *PatchNetscanOK) Code() int {
	return 200
}

func (o *PatchNetscanOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/netscans/{id}][%d] patchNetscanOK %s", 200, payload)
}

func (o *PatchNetscanOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/netscans/{id}][%d] patchNetscanOK %s", 200, payload)
}

func (o *PatchNetscanOK) GetPayload() models.Netscan {
	return o.Payload
}

func (o *PatchNetscanOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload as interface type
	payload, err := models.UnmarshalNetscan(response.Body(), consumer)
	if err != nil {
		return err
	}
	o.Payload = payload

	return nil
}

// NewPatchNetscanTooManyRequests creates a PatchNetscanTooManyRequests with default headers values
func NewPatchNetscanTooManyRequests() *PatchNetscanTooManyRequests {
	return &PatchNetscanTooManyRequests{}
}

/*
PatchNetscanTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchNetscanTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this patch netscan too many requests response has a 2xx status code
func (o *PatchNetscanTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this patch netscan too many requests response has a 3xx status code
func (o *PatchNetscanTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch netscan too many requests response has a 4xx status code
func (o *PatchNetscanTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this patch netscan too many requests response has a 5xx status code
func (o *PatchNetscanTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this patch netscan too many requests response a status code equal to that given
func (o *PatchNetscanTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the patch netscan too many requests response
func (o *PatchNetscanTooManyRequests) Code() int {
	return 429
}

func (o *PatchNetscanTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /setting/netscans/{id}][%d] patchNetscanTooManyRequests", 429)
}

func (o *PatchNetscanTooManyRequests) String() string {
	return fmt.Sprintf("[PATCH /setting/netscans/{id}][%d] patchNetscanTooManyRequests", 429)
}

func (o *PatchNetscanTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchNetscanDefault creates a PatchNetscanDefault with default headers values
func NewPatchNetscanDefault(code int) *PatchNetscanDefault {
	return &PatchNetscanDefault{
		_statusCode: code,
	}
}

/*
PatchNetscanDefault describes a response with status code -1, with default header values.

Error
*/
type PatchNetscanDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this patch netscan default response has a 2xx status code
func (o *PatchNetscanDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this patch netscan default response has a 3xx status code
func (o *PatchNetscanDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this patch netscan default response has a 4xx status code
func (o *PatchNetscanDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this patch netscan default response has a 5xx status code
func (o *PatchNetscanDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this patch netscan default response a status code equal to that given
func (o *PatchNetscanDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the patch netscan default response
func (o *PatchNetscanDefault) Code() int {
	return o._statusCode
}

func (o *PatchNetscanDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/netscans/{id}][%d] patchNetscan default %s", o._statusCode, payload)
}

func (o *PatchNetscanDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/netscans/{id}][%d] patchNetscan default %s", o._statusCode, payload)
}

func (o *PatchNetscanDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchNetscanDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
