// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// PatchOpsNoteByIDReader is a Reader for the PatchOpsNoteByID structure.
type PatchOpsNoteByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchOpsNoteByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchOpsNoteByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchOpsNoteByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchOpsNoteByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchOpsNoteByIDOK creates a PatchOpsNoteByIDOK with default headers values
func NewPatchOpsNoteByIDOK() *PatchOpsNoteByIDOK {
	return &PatchOpsNoteByIDOK{}
}

/*
PatchOpsNoteByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchOpsNoteByIDOK struct {
	Payload *models.OpsNote
}

// IsSuccess returns true when this patch ops note by Id o k response has a 2xx status code
func (o *PatchOpsNoteByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this patch ops note by Id o k response has a 3xx status code
func (o *PatchOpsNoteByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch ops note by Id o k response has a 4xx status code
func (o *PatchOpsNoteByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this patch ops note by Id o k response has a 5xx status code
func (o *PatchOpsNoteByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this patch ops note by Id o k response a status code equal to that given
func (o *PatchOpsNoteByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the patch ops note by Id o k response
func (o *PatchOpsNoteByIDOK) Code() int {
	return 200
}

func (o *PatchOpsNoteByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/opsnotes/{id}][%d] patchOpsNoteByIdOK %s", 200, payload)
}

func (o *PatchOpsNoteByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/opsnotes/{id}][%d] patchOpsNoteByIdOK %s", 200, payload)
}

func (o *PatchOpsNoteByIDOK) GetPayload() *models.OpsNote {
	return o.Payload
}

func (o *PatchOpsNoteByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.OpsNote)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPatchOpsNoteByIDTooManyRequests creates a PatchOpsNoteByIDTooManyRequests with default headers values
func NewPatchOpsNoteByIDTooManyRequests() *PatchOpsNoteByIDTooManyRequests {
	return &PatchOpsNoteByIDTooManyRequests{}
}

/*
PatchOpsNoteByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchOpsNoteByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this patch ops note by Id too many requests response has a 2xx status code
func (o *PatchOpsNoteByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this patch ops note by Id too many requests response has a 3xx status code
func (o *PatchOpsNoteByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch ops note by Id too many requests response has a 4xx status code
func (o *PatchOpsNoteByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this patch ops note by Id too many requests response has a 5xx status code
func (o *PatchOpsNoteByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this patch ops note by Id too many requests response a status code equal to that given
func (o *PatchOpsNoteByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the patch ops note by Id too many requests response
func (o *PatchOpsNoteByIDTooManyRequests) Code() int {
	return 429
}

func (o *PatchOpsNoteByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /setting/opsnotes/{id}][%d] patchOpsNoteByIdTooManyRequests", 429)
}

func (o *PatchOpsNoteByIDTooManyRequests) String() string {
	return fmt.Sprintf("[PATCH /setting/opsnotes/{id}][%d] patchOpsNoteByIdTooManyRequests", 429)
}

func (o *PatchOpsNoteByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchOpsNoteByIDDefault creates a PatchOpsNoteByIDDefault with default headers values
func NewPatchOpsNoteByIDDefault(code int) *PatchOpsNoteByIDDefault {
	return &PatchOpsNoteByIDDefault{
		_statusCode: code,
	}
}

/*
PatchOpsNoteByIDDefault describes a response with status code -1, with default header values.

Error
*/
type PatchOpsNoteByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this patch ops note by Id default response has a 2xx status code
func (o *PatchOpsNoteByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this patch ops note by Id default response has a 3xx status code
func (o *PatchOpsNoteByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this patch ops note by Id default response has a 4xx status code
func (o *PatchOpsNoteByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this patch ops note by Id default response has a 5xx status code
func (o *PatchOpsNoteByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this patch ops note by Id default response a status code equal to that given
func (o *PatchOpsNoteByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the patch ops note by Id default response
func (o *PatchOpsNoteByIDDefault) Code() int {
	return o._statusCode
}

func (o *PatchOpsNoteByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/opsnotes/{id}][%d] patchOpsNoteById default %s", o._statusCode, payload)
}

func (o *PatchOpsNoteByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /setting/opsnotes/{id}][%d] patchOpsNoteById default %s", o._statusCode, payload)
}

func (o *PatchOpsNoteByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchOpsNoteByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
