// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// PatchWebsiteGroupByIDReader is a Reader for the PatchWebsiteGroupByID structure.
type PatchWebsiteGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchWebsiteGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchWebsiteGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchWebsiteGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchWebsiteGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchWebsiteGroupByIDOK creates a PatchWebsiteGroupByIDOK with default headers values
func NewPatchWebsiteGroupByIDOK() *PatchWebsiteGroupByIDOK {
	return &PatchWebsiteGroupByIDOK{}
}

/*
PatchWebsiteGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchWebsiteGroupByIDOK struct {
	Payload *models.WebsiteGroup
}

// IsSuccess returns true when this patch website group by Id o k response has a 2xx status code
func (o *PatchWebsiteGroupByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this patch website group by Id o k response has a 3xx status code
func (o *PatchWebsiteGroupByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch website group by Id o k response has a 4xx status code
func (o *PatchWebsiteGroupByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this patch website group by Id o k response has a 5xx status code
func (o *PatchWebsiteGroupByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this patch website group by Id o k response a status code equal to that given
func (o *PatchWebsiteGroupByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the patch website group by Id o k response
func (o *PatchWebsiteGroupByIDOK) Code() int {
	return 200
}

func (o *PatchWebsiteGroupByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /website/groups/{id}][%d] patchWebsiteGroupByIdOK %s", 200, payload)
}

func (o *PatchWebsiteGroupByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /website/groups/{id}][%d] patchWebsiteGroupByIdOK %s", 200, payload)
}

func (o *PatchWebsiteGroupByIDOK) GetPayload() *models.WebsiteGroup {
	return o.Payload
}

func (o *PatchWebsiteGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.WebsiteGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPatchWebsiteGroupByIDTooManyRequests creates a PatchWebsiteGroupByIDTooManyRequests with default headers values
func NewPatchWebsiteGroupByIDTooManyRequests() *PatchWebsiteGroupByIDTooManyRequests {
	return &PatchWebsiteGroupByIDTooManyRequests{}
}

/*
PatchWebsiteGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchWebsiteGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this patch website group by Id too many requests response has a 2xx status code
func (o *PatchWebsiteGroupByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this patch website group by Id too many requests response has a 3xx status code
func (o *PatchWebsiteGroupByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this patch website group by Id too many requests response has a 4xx status code
func (o *PatchWebsiteGroupByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this patch website group by Id too many requests response has a 5xx status code
func (o *PatchWebsiteGroupByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this patch website group by Id too many requests response a status code equal to that given
func (o *PatchWebsiteGroupByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the patch website group by Id too many requests response
func (o *PatchWebsiteGroupByIDTooManyRequests) Code() int {
	return 429
}

func (o *PatchWebsiteGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /website/groups/{id}][%d] patchWebsiteGroupByIdTooManyRequests", 429)
}

func (o *PatchWebsiteGroupByIDTooManyRequests) String() string {
	return fmt.Sprintf("[PATCH /website/groups/{id}][%d] patchWebsiteGroupByIdTooManyRequests", 429)
}

func (o *PatchWebsiteGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchWebsiteGroupByIDDefault creates a PatchWebsiteGroupByIDDefault with default headers values
func NewPatchWebsiteGroupByIDDefault(code int) *PatchWebsiteGroupByIDDefault {
	return &PatchWebsiteGroupByIDDefault{
		_statusCode: code,
	}
}

/*
PatchWebsiteGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type PatchWebsiteGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this patch website group by Id default response has a 2xx status code
func (o *PatchWebsiteGroupByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this patch website group by Id default response has a 3xx status code
func (o *PatchWebsiteGroupByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this patch website group by Id default response has a 4xx status code
func (o *PatchWebsiteGroupByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this patch website group by Id default response has a 5xx status code
func (o *PatchWebsiteGroupByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this patch website group by Id default response a status code equal to that given
func (o *PatchWebsiteGroupByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the patch website group by Id default response
func (o *PatchWebsiteGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *PatchWebsiteGroupByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /website/groups/{id}][%d] patchWebsiteGroupById default %s", o._statusCode, payload)
}

func (o *PatchWebsiteGroupByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PATCH /website/groups/{id}][%d] patchWebsiteGroupById default %s", o._statusCode, payload)
}

func (o *PatchWebsiteGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchWebsiteGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
