// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateAccessGroupReader is a Reader for the UpdateAccessGroup structure.
type UpdateAccessGroupReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateAccessGroupReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateAccessGroupOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateAccessGroupTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateAccessGroupDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateAccessGroupOK creates a UpdateAccessGroupOK with default headers values
func NewUpdateAccessGroupOK() *UpdateAccessGroupOK {
	return &UpdateAccessGroupOK{}
}

/*
UpdateAccessGroupOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateAccessGroupOK struct {
	Payload *models.AccessGroup
}

// IsSuccess returns true when this update access group o k response has a 2xx status code
func (o *UpdateAccessGroupOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update access group o k response has a 3xx status code
func (o *UpdateAccessGroupOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update access group o k response has a 4xx status code
func (o *UpdateAccessGroupOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update access group o k response has a 5xx status code
func (o *UpdateAccessGroupOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update access group o k response a status code equal to that given
func (o *UpdateAccessGroupOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update access group o k response
func (o *UpdateAccessGroupOK) Code() int {
	return 200
}

func (o *UpdateAccessGroupOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/accessgroup/{id}][%d] updateAccessGroupOK %s", 200, payload)
}

func (o *UpdateAccessGroupOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/accessgroup/{id}][%d] updateAccessGroupOK %s", 200, payload)
}

func (o *UpdateAccessGroupOK) GetPayload() *models.AccessGroup {
	return o.Payload
}

func (o *UpdateAccessGroupOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AccessGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateAccessGroupTooManyRequests creates a UpdateAccessGroupTooManyRequests with default headers values
func NewUpdateAccessGroupTooManyRequests() *UpdateAccessGroupTooManyRequests {
	return &UpdateAccessGroupTooManyRequests{}
}

/*
UpdateAccessGroupTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateAccessGroupTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update access group too many requests response has a 2xx status code
func (o *UpdateAccessGroupTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update access group too many requests response has a 3xx status code
func (o *UpdateAccessGroupTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update access group too many requests response has a 4xx status code
func (o *UpdateAccessGroupTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update access group too many requests response has a 5xx status code
func (o *UpdateAccessGroupTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update access group too many requests response a status code equal to that given
func (o *UpdateAccessGroupTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update access group too many requests response
func (o *UpdateAccessGroupTooManyRequests) Code() int {
	return 429
}

func (o *UpdateAccessGroupTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/accessgroup/{id}][%d] updateAccessGroupTooManyRequests", 429)
}

func (o *UpdateAccessGroupTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /setting/accessgroup/{id}][%d] updateAccessGroupTooManyRequests", 429)
}

func (o *UpdateAccessGroupTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateAccessGroupDefault creates a UpdateAccessGroupDefault with default headers values
func NewUpdateAccessGroupDefault(code int) *UpdateAccessGroupDefault {
	return &UpdateAccessGroupDefault{
		_statusCode: code,
	}
}

/*
UpdateAccessGroupDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateAccessGroupDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update access group default response has a 2xx status code
func (o *UpdateAccessGroupDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update access group default response has a 3xx status code
func (o *UpdateAccessGroupDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update access group default response has a 4xx status code
func (o *UpdateAccessGroupDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update access group default response has a 5xx status code
func (o *UpdateAccessGroupDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update access group default response a status code equal to that given
func (o *UpdateAccessGroupDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update access group default response
func (o *UpdateAccessGroupDefault) Code() int {
	return o._statusCode
}

func (o *UpdateAccessGroupDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/accessgroup/{id}][%d] updateAccessGroup default %s", o._statusCode, payload)
}

func (o *UpdateAccessGroupDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/accessgroup/{id}][%d] updateAccessGroup default %s", o._statusCode, payload)
}

func (o *UpdateAccessGroupDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateAccessGroupDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
