// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateCollectorByIDReader is a Reader for the UpdateCollectorByID structure.
type UpdateCollectorByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateCollectorByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateCollectorByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateCollectorByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateCollectorByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateCollectorByIDOK creates a UpdateCollectorByIDOK with default headers values
func NewUpdateCollectorByIDOK() *UpdateCollectorByIDOK {
	return &UpdateCollectorByIDOK{}
}

/*
UpdateCollectorByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateCollectorByIDOK struct {
	Payload *models.Collector
}

// IsSuccess returns true when this update collector by Id o k response has a 2xx status code
func (o *UpdateCollectorByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update collector by Id o k response has a 3xx status code
func (o *UpdateCollectorByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update collector by Id o k response has a 4xx status code
func (o *UpdateCollectorByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update collector by Id o k response has a 5xx status code
func (o *UpdateCollectorByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update collector by Id o k response a status code equal to that given
func (o *UpdateCollectorByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update collector by Id o k response
func (o *UpdateCollectorByIDOK) Code() int {
	return 200
}

func (o *UpdateCollectorByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/collector/collectors/{id}][%d] updateCollectorByIdOK %s", 200, payload)
}

func (o *UpdateCollectorByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/collector/collectors/{id}][%d] updateCollectorByIdOK %s", 200, payload)
}

func (o *UpdateCollectorByIDOK) GetPayload() *models.Collector {
	return o.Payload
}

func (o *UpdateCollectorByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Collector)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateCollectorByIDTooManyRequests creates a UpdateCollectorByIDTooManyRequests with default headers values
func NewUpdateCollectorByIDTooManyRequests() *UpdateCollectorByIDTooManyRequests {
	return &UpdateCollectorByIDTooManyRequests{}
}

/*
UpdateCollectorByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateCollectorByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update collector by Id too many requests response has a 2xx status code
func (o *UpdateCollectorByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update collector by Id too many requests response has a 3xx status code
func (o *UpdateCollectorByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update collector by Id too many requests response has a 4xx status code
func (o *UpdateCollectorByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update collector by Id too many requests response has a 5xx status code
func (o *UpdateCollectorByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update collector by Id too many requests response a status code equal to that given
func (o *UpdateCollectorByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update collector by Id too many requests response
func (o *UpdateCollectorByIDTooManyRequests) Code() int {
	return 429
}

func (o *UpdateCollectorByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/collector/collectors/{id}][%d] updateCollectorByIdTooManyRequests", 429)
}

func (o *UpdateCollectorByIDTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /setting/collector/collectors/{id}][%d] updateCollectorByIdTooManyRequests", 429)
}

func (o *UpdateCollectorByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateCollectorByIDDefault creates a UpdateCollectorByIDDefault with default headers values
func NewUpdateCollectorByIDDefault(code int) *UpdateCollectorByIDDefault {
	return &UpdateCollectorByIDDefault{
		_statusCode: code,
	}
}

/*
UpdateCollectorByIDDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateCollectorByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update collector by Id default response has a 2xx status code
func (o *UpdateCollectorByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update collector by Id default response has a 3xx status code
func (o *UpdateCollectorByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update collector by Id default response has a 4xx status code
func (o *UpdateCollectorByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update collector by Id default response has a 5xx status code
func (o *UpdateCollectorByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update collector by Id default response a status code equal to that given
func (o *UpdateCollectorByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update collector by Id default response
func (o *UpdateCollectorByIDDefault) Code() int {
	return o._statusCode
}

func (o *UpdateCollectorByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/collector/collectors/{id}][%d] updateCollectorById default %s", o._statusCode, payload)
}

func (o *UpdateCollectorByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/collector/collectors/{id}][%d] updateCollectorById default %s", o._statusCode, payload)
}

func (o *UpdateCollectorByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateCollectorByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
