// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateConfigSourceByIDReader is a Reader for the UpdateConfigSourceByID structure.
type UpdateConfigSourceByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateConfigSourceByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateConfigSourceByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateConfigSourceByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateConfigSourceByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateConfigSourceByIDOK creates a UpdateConfigSourceByIDOK with default headers values
func NewUpdateConfigSourceByIDOK() *UpdateConfigSourceByIDOK {
	return &UpdateConfigSourceByIDOK{}
}

/*
UpdateConfigSourceByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateConfigSourceByIDOK struct {
	Payload *models.ConfigSource
}

// IsSuccess returns true when this update config source by Id o k response has a 2xx status code
func (o *UpdateConfigSourceByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update config source by Id o k response has a 3xx status code
func (o *UpdateConfigSourceByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update config source by Id o k response has a 4xx status code
func (o *UpdateConfigSourceByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update config source by Id o k response has a 5xx status code
func (o *UpdateConfigSourceByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update config source by Id o k response a status code equal to that given
func (o *UpdateConfigSourceByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update config source by Id o k response
func (o *UpdateConfigSourceByIDOK) Code() int {
	return 200
}

func (o *UpdateConfigSourceByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/configsources/{id}][%d] updateConfigSourceByIdOK %s", 200, payload)
}

func (o *UpdateConfigSourceByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/configsources/{id}][%d] updateConfigSourceByIdOK %s", 200, payload)
}

func (o *UpdateConfigSourceByIDOK) GetPayload() *models.ConfigSource {
	return o.Payload
}

func (o *UpdateConfigSourceByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ConfigSource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateConfigSourceByIDTooManyRequests creates a UpdateConfigSourceByIDTooManyRequests with default headers values
func NewUpdateConfigSourceByIDTooManyRequests() *UpdateConfigSourceByIDTooManyRequests {
	return &UpdateConfigSourceByIDTooManyRequests{}
}

/*
UpdateConfigSourceByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateConfigSourceByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update config source by Id too many requests response has a 2xx status code
func (o *UpdateConfigSourceByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update config source by Id too many requests response has a 3xx status code
func (o *UpdateConfigSourceByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update config source by Id too many requests response has a 4xx status code
func (o *UpdateConfigSourceByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update config source by Id too many requests response has a 5xx status code
func (o *UpdateConfigSourceByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update config source by Id too many requests response a status code equal to that given
func (o *UpdateConfigSourceByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update config source by Id too many requests response
func (o *UpdateConfigSourceByIDTooManyRequests) Code() int {
	return 429
}

func (o *UpdateConfigSourceByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/configsources/{id}][%d] updateConfigSourceByIdTooManyRequests", 429)
}

func (o *UpdateConfigSourceByIDTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /setting/configsources/{id}][%d] updateConfigSourceByIdTooManyRequests", 429)
}

func (o *UpdateConfigSourceByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateConfigSourceByIDDefault creates a UpdateConfigSourceByIDDefault with default headers values
func NewUpdateConfigSourceByIDDefault(code int) *UpdateConfigSourceByIDDefault {
	return &UpdateConfigSourceByIDDefault{
		_statusCode: code,
	}
}

/*
UpdateConfigSourceByIDDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateConfigSourceByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update config source by Id default response has a 2xx status code
func (o *UpdateConfigSourceByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update config source by Id default response has a 3xx status code
func (o *UpdateConfigSourceByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update config source by Id default response has a 4xx status code
func (o *UpdateConfigSourceByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update config source by Id default response has a 5xx status code
func (o *UpdateConfigSourceByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update config source by Id default response a status code equal to that given
func (o *UpdateConfigSourceByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update config source by Id default response
func (o *UpdateConfigSourceByIDDefault) Code() int {
	return o._statusCode
}

func (o *UpdateConfigSourceByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/configsources/{id}][%d] updateConfigSourceById default %s", o._statusCode, payload)
}

func (o *UpdateConfigSourceByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/configsources/{id}][%d] updateConfigSourceById default %s", o._statusCode, payload)
}

func (o *UpdateConfigSourceByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateConfigSourceByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
