// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateDefaultDashboardReader is a Reader for the UpdateDefaultDashboard structure.
type UpdateDefaultDashboardReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateDefaultDashboardReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateDefaultDashboardOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateDefaultDashboardTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateDefaultDashboardDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateDefaultDashboardOK creates a UpdateDefaultDashboardOK with default headers values
func NewUpdateDefaultDashboardOK() *UpdateDefaultDashboardOK {
	return &UpdateDefaultDashboardOK{}
}

/*
UpdateDefaultDashboardOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateDefaultDashboardOK struct {
	Payload interface{}
}

// IsSuccess returns true when this update default dashboard o k response has a 2xx status code
func (o *UpdateDefaultDashboardOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update default dashboard o k response has a 3xx status code
func (o *UpdateDefaultDashboardOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update default dashboard o k response has a 4xx status code
func (o *UpdateDefaultDashboardOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update default dashboard o k response has a 5xx status code
func (o *UpdateDefaultDashboardOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update default dashboard o k response a status code equal to that given
func (o *UpdateDefaultDashboardOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update default dashboard o k response
func (o *UpdateDefaultDashboardOK) Code() int {
	return 200
}

func (o *UpdateDefaultDashboardOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/userdata/{id}][%d] updateDefaultDashboardOK %s", 200, payload)
}

func (o *UpdateDefaultDashboardOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/userdata/{id}][%d] updateDefaultDashboardOK %s", 200, payload)
}

func (o *UpdateDefaultDashboardOK) GetPayload() interface{} {
	return o.Payload
}

func (o *UpdateDefaultDashboardOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateDefaultDashboardTooManyRequests creates a UpdateDefaultDashboardTooManyRequests with default headers values
func NewUpdateDefaultDashboardTooManyRequests() *UpdateDefaultDashboardTooManyRequests {
	return &UpdateDefaultDashboardTooManyRequests{}
}

/*
UpdateDefaultDashboardTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateDefaultDashboardTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update default dashboard too many requests response has a 2xx status code
func (o *UpdateDefaultDashboardTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update default dashboard too many requests response has a 3xx status code
func (o *UpdateDefaultDashboardTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update default dashboard too many requests response has a 4xx status code
func (o *UpdateDefaultDashboardTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update default dashboard too many requests response has a 5xx status code
func (o *UpdateDefaultDashboardTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update default dashboard too many requests response a status code equal to that given
func (o *UpdateDefaultDashboardTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update default dashboard too many requests response
func (o *UpdateDefaultDashboardTooManyRequests) Code() int {
	return 429
}

func (o *UpdateDefaultDashboardTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/userdata/{id}][%d] updateDefaultDashboardTooManyRequests", 429)
}

func (o *UpdateDefaultDashboardTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /setting/userdata/{id}][%d] updateDefaultDashboardTooManyRequests", 429)
}

func (o *UpdateDefaultDashboardTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateDefaultDashboardDefault creates a UpdateDefaultDashboardDefault with default headers values
func NewUpdateDefaultDashboardDefault(code int) *UpdateDefaultDashboardDefault {
	return &UpdateDefaultDashboardDefault{
		_statusCode: code,
	}
}

/*
UpdateDefaultDashboardDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateDefaultDashboardDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update default dashboard default response has a 2xx status code
func (o *UpdateDefaultDashboardDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update default dashboard default response has a 3xx status code
func (o *UpdateDefaultDashboardDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update default dashboard default response has a 4xx status code
func (o *UpdateDefaultDashboardDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update default dashboard default response has a 5xx status code
func (o *UpdateDefaultDashboardDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update default dashboard default response a status code equal to that given
func (o *UpdateDefaultDashboardDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update default dashboard default response
func (o *UpdateDefaultDashboardDefault) Code() int {
	return o._statusCode
}

func (o *UpdateDefaultDashboardDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/userdata/{id}][%d] updateDefaultDashboard default %s", o._statusCode, payload)
}

func (o *UpdateDefaultDashboardDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/userdata/{id}][%d] updateDefaultDashboard default %s", o._statusCode, payload)
}

func (o *UpdateDefaultDashboardDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateDefaultDashboardDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
