// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateDeviceReader is a Reader for the UpdateDevice structure.
type UpdateDeviceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateDeviceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateDeviceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateDeviceTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateDeviceDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateDeviceOK creates a UpdateDeviceOK with default headers values
func NewUpdateDeviceOK() *UpdateDeviceOK {
	return &UpdateDeviceOK{}
}

/*
UpdateDeviceOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateDeviceOK struct {
	Payload *models.Device
}

// IsSuccess returns true when this update device o k response has a 2xx status code
func (o *UpdateDeviceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update device o k response has a 3xx status code
func (o *UpdateDeviceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update device o k response has a 4xx status code
func (o *UpdateDeviceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update device o k response has a 5xx status code
func (o *UpdateDeviceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update device o k response a status code equal to that given
func (o *UpdateDeviceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update device o k response
func (o *UpdateDeviceOK) Code() int {
	return 200
}

func (o *UpdateDeviceOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /device/devices/{id}][%d] updateDeviceOK %s", 200, payload)
}

func (o *UpdateDeviceOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /device/devices/{id}][%d] updateDeviceOK %s", 200, payload)
}

func (o *UpdateDeviceOK) GetPayload() *models.Device {
	return o.Payload
}

func (o *UpdateDeviceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Device)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateDeviceTooManyRequests creates a UpdateDeviceTooManyRequests with default headers values
func NewUpdateDeviceTooManyRequests() *UpdateDeviceTooManyRequests {
	return &UpdateDeviceTooManyRequests{}
}

/*
UpdateDeviceTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateDeviceTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update device too many requests response has a 2xx status code
func (o *UpdateDeviceTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update device too many requests response has a 3xx status code
func (o *UpdateDeviceTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update device too many requests response has a 4xx status code
func (o *UpdateDeviceTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update device too many requests response has a 5xx status code
func (o *UpdateDeviceTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update device too many requests response a status code equal to that given
func (o *UpdateDeviceTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update device too many requests response
func (o *UpdateDeviceTooManyRequests) Code() int {
	return 429
}

func (o *UpdateDeviceTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /device/devices/{id}][%d] updateDeviceTooManyRequests", 429)
}

func (o *UpdateDeviceTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /device/devices/{id}][%d] updateDeviceTooManyRequests", 429)
}

func (o *UpdateDeviceTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateDeviceDefault creates a UpdateDeviceDefault with default headers values
func NewUpdateDeviceDefault(code int) *UpdateDeviceDefault {
	return &UpdateDeviceDefault{
		_statusCode: code,
	}
}

/*
UpdateDeviceDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateDeviceDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update device default response has a 2xx status code
func (o *UpdateDeviceDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update device default response has a 3xx status code
func (o *UpdateDeviceDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update device default response has a 4xx status code
func (o *UpdateDeviceDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update device default response has a 5xx status code
func (o *UpdateDeviceDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update device default response a status code equal to that given
func (o *UpdateDeviceDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update device default response
func (o *UpdateDeviceDefault) Code() int {
	return o._statusCode
}

func (o *UpdateDeviceDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /device/devices/{id}][%d] updateDevice default %s", o._statusCode, payload)
}

func (o *UpdateDeviceDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /device/devices/{id}][%d] updateDevice default %s", o._statusCode, payload)
}

func (o *UpdateDeviceDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateDeviceDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
