// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateLogPartitionReader is a Reader for the UpdateLogPartition structure.
type UpdateLogPartitionReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateLogPartitionReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateLogPartitionOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateLogPartitionTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateLogPartitionDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateLogPartitionOK creates a UpdateLogPartitionOK with default headers values
func NewUpdateLogPartitionOK() *UpdateLogPartitionOK {
	return &UpdateLogPartitionOK{}
}

/*
UpdateLogPartitionOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateLogPartitionOK struct {
	Payload *models.LogPartition
}

// IsSuccess returns true when this update log partition o k response has a 2xx status code
func (o *UpdateLogPartitionOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update log partition o k response has a 3xx status code
func (o *UpdateLogPartitionOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update log partition o k response has a 4xx status code
func (o *UpdateLogPartitionOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update log partition o k response has a 5xx status code
func (o *UpdateLogPartitionOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update log partition o k response a status code equal to that given
func (o *UpdateLogPartitionOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update log partition o k response
func (o *UpdateLogPartitionOK) Code() int {
	return 200
}

func (o *UpdateLogPartitionOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /log/partitions][%d] updateLogPartitionOK %s", 200, payload)
}

func (o *UpdateLogPartitionOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /log/partitions][%d] updateLogPartitionOK %s", 200, payload)
}

func (o *UpdateLogPartitionOK) GetPayload() *models.LogPartition {
	return o.Payload
}

func (o *UpdateLogPartitionOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.LogPartition)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateLogPartitionTooManyRequests creates a UpdateLogPartitionTooManyRequests with default headers values
func NewUpdateLogPartitionTooManyRequests() *UpdateLogPartitionTooManyRequests {
	return &UpdateLogPartitionTooManyRequests{}
}

/*
UpdateLogPartitionTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateLogPartitionTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update log partition too many requests response has a 2xx status code
func (o *UpdateLogPartitionTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update log partition too many requests response has a 3xx status code
func (o *UpdateLogPartitionTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update log partition too many requests response has a 4xx status code
func (o *UpdateLogPartitionTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update log partition too many requests response has a 5xx status code
func (o *UpdateLogPartitionTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update log partition too many requests response a status code equal to that given
func (o *UpdateLogPartitionTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update log partition too many requests response
func (o *UpdateLogPartitionTooManyRequests) Code() int {
	return 429
}

func (o *UpdateLogPartitionTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /log/partitions][%d] updateLogPartitionTooManyRequests", 429)
}

func (o *UpdateLogPartitionTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /log/partitions][%d] updateLogPartitionTooManyRequests", 429)
}

func (o *UpdateLogPartitionTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateLogPartitionDefault creates a UpdateLogPartitionDefault with default headers values
func NewUpdateLogPartitionDefault(code int) *UpdateLogPartitionDefault {
	return &UpdateLogPartitionDefault{
		_statusCode: code,
	}
}

/*
UpdateLogPartitionDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateLogPartitionDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update log partition default response has a 2xx status code
func (o *UpdateLogPartitionDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update log partition default response has a 3xx status code
func (o *UpdateLogPartitionDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update log partition default response has a 4xx status code
func (o *UpdateLogPartitionDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update log partition default response has a 5xx status code
func (o *UpdateLogPartitionDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update log partition default response a status code equal to that given
func (o *UpdateLogPartitionDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update log partition default response
func (o *UpdateLogPartitionDefault) Code() int {
	return o._statusCode
}

func (o *UpdateLogPartitionDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /log/partitions][%d] updateLogPartition default %s", o._statusCode, payload)
}

func (o *UpdateLogPartitionDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /log/partitions][%d] updateLogPartition default %s", o._statusCode, payload)
}

func (o *UpdateLogPartitionDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateLogPartitionDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
