// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewUpdateOIDParams creates a new UpdateOIDParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateOIDParams() *UpdateOIDParams {
	return &UpdateOIDParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateOIDParamsWithTimeout creates a new UpdateOIDParams object
// with the ability to set a timeout on a request.
func NewUpdateOIDParamsWithTimeout(timeout time.Duration) *UpdateOIDParams {
	return &UpdateOIDParams{
		timeout: timeout,
	}
}

// NewUpdateOIDParamsWithContext creates a new UpdateOIDParams object
// with the ability to set a context for a request.
func NewUpdateOIDParamsWithContext(ctx context.Context) *UpdateOIDParams {
	return &UpdateOIDParams{
		Context: ctx,
	}
}

// NewUpdateOIDParamsWithHTTPClient creates a new UpdateOIDParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateOIDParamsWithHTTPClient(client *http.Client) *UpdateOIDParams {
	return &UpdateOIDParams{
		HTTPClient: client,
	}
}

/*
UpdateOIDParams contains all the parameters to send to the API endpoint

	for the update o ID operation.

	Typically these are written to a http.Request.
*/
type UpdateOIDParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.RestOidV3

	// ID.
	//
	// Format: int32
	ID int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update o ID params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateOIDParams) WithDefaults() *UpdateOIDParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update o ID params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateOIDParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := UpdateOIDParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the update o ID params
func (o *UpdateOIDParams) WithTimeout(timeout time.Duration) *UpdateOIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update o ID params
func (o *UpdateOIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update o ID params
func (o *UpdateOIDParams) WithContext(ctx context.Context) *UpdateOIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update o ID params
func (o *UpdateOIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update o ID params
func (o *UpdateOIDParams) WithHTTPClient(client *http.Client) *UpdateOIDParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update o ID params
func (o *UpdateOIDParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the update o ID params
func (o *UpdateOIDParams) WithUserAgent(userAgent *string) *UpdateOIDParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the update o ID params
func (o *UpdateOIDParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the update o ID params
func (o *UpdateOIDParams) WithBody(body *models.RestOidV3) *UpdateOIDParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update o ID params
func (o *UpdateOIDParams) SetBody(body *models.RestOidV3) {
	o.Body = body
}

// WithID adds the id to the update o ID params
func (o *UpdateOIDParams) WithID(id int32) *UpdateOIDParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the update o ID params
func (o *UpdateOIDParams) SetID(id int32) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateOIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt32(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
