// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateOIDReader is a Reader for the UpdateOID structure.
type UpdateOIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateOIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateOIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateOIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateOIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateOIDOK creates a UpdateOIDOK with default headers values
func NewUpdateOIDOK() *UpdateOIDOK {
	return &UpdateOIDOK{}
}

/*
UpdateOIDOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateOIDOK struct {
	Payload *models.RestOidV3
}

// IsSuccess returns true when this update o Id o k response has a 2xx status code
func (o *UpdateOIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update o Id o k response has a 3xx status code
func (o *UpdateOIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update o Id o k response has a 4xx status code
func (o *UpdateOIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update o Id o k response has a 5xx status code
func (o *UpdateOIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update o Id o k response a status code equal to that given
func (o *UpdateOIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update o Id o k response
func (o *UpdateOIDOK) Code() int {
	return 200
}

func (o *UpdateOIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/oids/{id}][%d] updateOIdOK %s", 200, payload)
}

func (o *UpdateOIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/oids/{id}][%d] updateOIdOK %s", 200, payload)
}

func (o *UpdateOIDOK) GetPayload() *models.RestOidV3 {
	return o.Payload
}

func (o *UpdateOIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.RestOidV3)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateOIDTooManyRequests creates a UpdateOIDTooManyRequests with default headers values
func NewUpdateOIDTooManyRequests() *UpdateOIDTooManyRequests {
	return &UpdateOIDTooManyRequests{}
}

/*
UpdateOIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateOIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update o Id too many requests response has a 2xx status code
func (o *UpdateOIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update o Id too many requests response has a 3xx status code
func (o *UpdateOIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update o Id too many requests response has a 4xx status code
func (o *UpdateOIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update o Id too many requests response has a 5xx status code
func (o *UpdateOIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update o Id too many requests response a status code equal to that given
func (o *UpdateOIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update o Id too many requests response
func (o *UpdateOIDTooManyRequests) Code() int {
	return 429
}

func (o *UpdateOIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/oids/{id}][%d] updateOIdTooManyRequests", 429)
}

func (o *UpdateOIDTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /setting/oids/{id}][%d] updateOIdTooManyRequests", 429)
}

func (o *UpdateOIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateOIDDefault creates a UpdateOIDDefault with default headers values
func NewUpdateOIDDefault(code int) *UpdateOIDDefault {
	return &UpdateOIDDefault{
		_statusCode: code,
	}
}

/*
UpdateOIDDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateOIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update o ID default response has a 2xx status code
func (o *UpdateOIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update o ID default response has a 3xx status code
func (o *UpdateOIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update o ID default response has a 4xx status code
func (o *UpdateOIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update o ID default response has a 5xx status code
func (o *UpdateOIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update o ID default response a status code equal to that given
func (o *UpdateOIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update o ID default response
func (o *UpdateOIDDefault) Code() int {
	return o._statusCode
}

func (o *UpdateOIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/oids/{id}][%d] updateOID default %s", o._statusCode, payload)
}

func (o *UpdateOIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/oids/{id}][%d] updateOID default %s", o._statusCode, payload)
}

func (o *UpdateOIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateOIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
