// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewUpdatePropertyRuleParams creates a new UpdatePropertyRuleParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdatePropertyRuleParams() *UpdatePropertyRuleParams {
	return &UpdatePropertyRuleParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdatePropertyRuleParamsWithTimeout creates a new UpdatePropertyRuleParams object
// with the ability to set a timeout on a request.
func NewUpdatePropertyRuleParamsWithTimeout(timeout time.Duration) *UpdatePropertyRuleParams {
	return &UpdatePropertyRuleParams{
		timeout: timeout,
	}
}

// NewUpdatePropertyRuleParamsWithContext creates a new UpdatePropertyRuleParams object
// with the ability to set a context for a request.
func NewUpdatePropertyRuleParamsWithContext(ctx context.Context) *UpdatePropertyRuleParams {
	return &UpdatePropertyRuleParams{
		Context: ctx,
	}
}

// NewUpdatePropertyRuleParamsWithHTTPClient creates a new UpdatePropertyRuleParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdatePropertyRuleParamsWithHTTPClient(client *http.Client) *UpdatePropertyRuleParams {
	return &UpdatePropertyRuleParams{
		HTTPClient: client,
	}
}

/*
UpdatePropertyRuleParams contains all the parameters to send to the API endpoint

	for the update property rule operation.

	Typically these are written to a http.Request.
*/
type UpdatePropertyRuleParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.PropertyRule

	// ID.
	//
	// Format: int32
	ID int32

	// Reason.
	Reason *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update property rule params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdatePropertyRuleParams) WithDefaults() *UpdatePropertyRuleParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update property rule params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdatePropertyRuleParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := UpdatePropertyRuleParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the update property rule params
func (o *UpdatePropertyRuleParams) WithTimeout(timeout time.Duration) *UpdatePropertyRuleParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update property rule params
func (o *UpdatePropertyRuleParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update property rule params
func (o *UpdatePropertyRuleParams) WithContext(ctx context.Context) *UpdatePropertyRuleParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update property rule params
func (o *UpdatePropertyRuleParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update property rule params
func (o *UpdatePropertyRuleParams) WithHTTPClient(client *http.Client) *UpdatePropertyRuleParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update property rule params
func (o *UpdatePropertyRuleParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the update property rule params
func (o *UpdatePropertyRuleParams) WithUserAgent(userAgent *string) *UpdatePropertyRuleParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the update property rule params
func (o *UpdatePropertyRuleParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the update property rule params
func (o *UpdatePropertyRuleParams) WithBody(body *models.PropertyRule) *UpdatePropertyRuleParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update property rule params
func (o *UpdatePropertyRuleParams) SetBody(body *models.PropertyRule) {
	o.Body = body
}

// WithID adds the id to the update property rule params
func (o *UpdatePropertyRuleParams) WithID(id int32) *UpdatePropertyRuleParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the update property rule params
func (o *UpdatePropertyRuleParams) SetID(id int32) {
	o.ID = id
}

// WithReason adds the reason to the update property rule params
func (o *UpdatePropertyRuleParams) WithReason(reason *string) *UpdatePropertyRuleParams {
	o.SetReason(reason)
	return o
}

// SetReason adds the reason to the update property rule params
func (o *UpdatePropertyRuleParams) SetReason(reason *string) {
	o.Reason = reason
}

// WriteToRequest writes these params to a swagger request
func (o *UpdatePropertyRuleParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt32(o.ID)); err != nil {
		return err
	}

	if o.Reason != nil {

		// query param reason
		var qrReason string

		if o.Reason != nil {
			qrReason = *o.Reason
		}
		qReason := qrReason
		if qReason != "" {

			if err := r.SetQueryParam("reason", qReason); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
