// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdatePropertyRuleReader is a Reader for the UpdatePropertyRule structure.
type UpdatePropertyRuleReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdatePropertyRuleReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdatePropertyRuleOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdatePropertyRuleTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdatePropertyRuleDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdatePropertyRuleOK creates a UpdatePropertyRuleOK with default headers values
func NewUpdatePropertyRuleOK() *UpdatePropertyRuleOK {
	return &UpdatePropertyRuleOK{}
}

/*
UpdatePropertyRuleOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdatePropertyRuleOK struct {
	Payload *models.PropertyRule
}

// IsSuccess returns true when this update property rule o k response has a 2xx status code
func (o *UpdatePropertyRuleOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update property rule o k response has a 3xx status code
func (o *UpdatePropertyRuleOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update property rule o k response has a 4xx status code
func (o *UpdatePropertyRuleOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update property rule o k response has a 5xx status code
func (o *UpdatePropertyRuleOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update property rule o k response a status code equal to that given
func (o *UpdatePropertyRuleOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update property rule o k response
func (o *UpdatePropertyRuleOK) Code() int {
	return 200
}

func (o *UpdatePropertyRuleOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/propertyrules/{id}][%d] updatePropertyRuleOK %s", 200, payload)
}

func (o *UpdatePropertyRuleOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/propertyrules/{id}][%d] updatePropertyRuleOK %s", 200, payload)
}

func (o *UpdatePropertyRuleOK) GetPayload() *models.PropertyRule {
	return o.Payload
}

func (o *UpdatePropertyRuleOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.PropertyRule)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdatePropertyRuleTooManyRequests creates a UpdatePropertyRuleTooManyRequests with default headers values
func NewUpdatePropertyRuleTooManyRequests() *UpdatePropertyRuleTooManyRequests {
	return &UpdatePropertyRuleTooManyRequests{}
}

/*
UpdatePropertyRuleTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdatePropertyRuleTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update property rule too many requests response has a 2xx status code
func (o *UpdatePropertyRuleTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update property rule too many requests response has a 3xx status code
func (o *UpdatePropertyRuleTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update property rule too many requests response has a 4xx status code
func (o *UpdatePropertyRuleTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update property rule too many requests response has a 5xx status code
func (o *UpdatePropertyRuleTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update property rule too many requests response a status code equal to that given
func (o *UpdatePropertyRuleTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update property rule too many requests response
func (o *UpdatePropertyRuleTooManyRequests) Code() int {
	return 429
}

func (o *UpdatePropertyRuleTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/propertyrules/{id}][%d] updatePropertyRuleTooManyRequests", 429)
}

func (o *UpdatePropertyRuleTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /setting/propertyrules/{id}][%d] updatePropertyRuleTooManyRequests", 429)
}

func (o *UpdatePropertyRuleTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdatePropertyRuleDefault creates a UpdatePropertyRuleDefault with default headers values
func NewUpdatePropertyRuleDefault(code int) *UpdatePropertyRuleDefault {
	return &UpdatePropertyRuleDefault{
		_statusCode: code,
	}
}

/*
UpdatePropertyRuleDefault describes a response with status code -1, with default header values.

Error
*/
type UpdatePropertyRuleDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update property rule default response has a 2xx status code
func (o *UpdatePropertyRuleDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update property rule default response has a 3xx status code
func (o *UpdatePropertyRuleDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update property rule default response has a 4xx status code
func (o *UpdatePropertyRuleDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update property rule default response has a 5xx status code
func (o *UpdatePropertyRuleDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update property rule default response a status code equal to that given
func (o *UpdatePropertyRuleDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update property rule default response
func (o *UpdatePropertyRuleDefault) Code() int {
	return o._statusCode
}

func (o *UpdatePropertyRuleDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/propertyrules/{id}][%d] updatePropertyRule default %s", o._statusCode, payload)
}

func (o *UpdatePropertyRuleDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/propertyrules/{id}][%d] updatePropertyRule default %s", o._statusCode, payload)
}

func (o *UpdatePropertyRuleDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdatePropertyRuleDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
