// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateReportByIDReader is a Reader for the UpdateReportByID structure.
type UpdateReportByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateReportByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateReportByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateReportByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateReportByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateReportByIDOK creates a UpdateReportByIDOK with default headers values
func NewUpdateReportByIDOK() *UpdateReportByIDOK {
	return &UpdateReportByIDOK{}
}

/*
UpdateReportByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateReportByIDOK struct {
	Payload models.ReportBase
}

// IsSuccess returns true when this update report by Id o k response has a 2xx status code
func (o *UpdateReportByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update report by Id o k response has a 3xx status code
func (o *UpdateReportByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update report by Id o k response has a 4xx status code
func (o *UpdateReportByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update report by Id o k response has a 5xx status code
func (o *UpdateReportByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update report by Id o k response a status code equal to that given
func (o *UpdateReportByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update report by Id o k response
func (o *UpdateReportByIDOK) Code() int {
	return 200
}

func (o *UpdateReportByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /report/reports/{id}][%d] updateReportByIdOK %s", 200, payload)
}

func (o *UpdateReportByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /report/reports/{id}][%d] updateReportByIdOK %s", 200, payload)
}

func (o *UpdateReportByIDOK) GetPayload() models.ReportBase {
	return o.Payload
}

func (o *UpdateReportByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload as interface type
	payload, err := models.UnmarshalReportBase(response.Body(), consumer)
	if err != nil {
		return err
	}
	o.Payload = payload

	return nil
}

// NewUpdateReportByIDTooManyRequests creates a UpdateReportByIDTooManyRequests with default headers values
func NewUpdateReportByIDTooManyRequests() *UpdateReportByIDTooManyRequests {
	return &UpdateReportByIDTooManyRequests{}
}

/*
UpdateReportByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateReportByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update report by Id too many requests response has a 2xx status code
func (o *UpdateReportByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update report by Id too many requests response has a 3xx status code
func (o *UpdateReportByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update report by Id too many requests response has a 4xx status code
func (o *UpdateReportByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update report by Id too many requests response has a 5xx status code
func (o *UpdateReportByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update report by Id too many requests response a status code equal to that given
func (o *UpdateReportByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update report by Id too many requests response
func (o *UpdateReportByIDTooManyRequests) Code() int {
	return 429
}

func (o *UpdateReportByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /report/reports/{id}][%d] updateReportByIdTooManyRequests", 429)
}

func (o *UpdateReportByIDTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /report/reports/{id}][%d] updateReportByIdTooManyRequests", 429)
}

func (o *UpdateReportByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateReportByIDDefault creates a UpdateReportByIDDefault with default headers values
func NewUpdateReportByIDDefault(code int) *UpdateReportByIDDefault {
	return &UpdateReportByIDDefault{
		_statusCode: code,
	}
}

/*
UpdateReportByIDDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateReportByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update report by Id default response has a 2xx status code
func (o *UpdateReportByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update report by Id default response has a 3xx status code
func (o *UpdateReportByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update report by Id default response has a 4xx status code
func (o *UpdateReportByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update report by Id default response has a 5xx status code
func (o *UpdateReportByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update report by Id default response a status code equal to that given
func (o *UpdateReportByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update report by Id default response
func (o *UpdateReportByIDDefault) Code() int {
	return o._statusCode
}

func (o *UpdateReportByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /report/reports/{id}][%d] updateReportById default %s", o._statusCode, payload)
}

func (o *UpdateReportByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /report/reports/{id}][%d] updateReportById default %s", o._statusCode, payload)
}

func (o *UpdateReportByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateReportByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
