// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateTopologySourceReader is a Reader for the UpdateTopologySource structure.
type UpdateTopologySourceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateTopologySourceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateTopologySourceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateTopologySourceTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateTopologySourceDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateTopologySourceOK creates a UpdateTopologySourceOK with default headers values
func NewUpdateTopologySourceOK() *UpdateTopologySourceOK {
	return &UpdateTopologySourceOK{}
}

/*
UpdateTopologySourceOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateTopologySourceOK struct {
	Payload *models.TopologySource
}

// IsSuccess returns true when this update topology source o k response has a 2xx status code
func (o *UpdateTopologySourceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update topology source o k response has a 3xx status code
func (o *UpdateTopologySourceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update topology source o k response has a 4xx status code
func (o *UpdateTopologySourceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update topology source o k response has a 5xx status code
func (o *UpdateTopologySourceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update topology source o k response a status code equal to that given
func (o *UpdateTopologySourceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update topology source o k response
func (o *UpdateTopologySourceOK) Code() int {
	return 200
}

func (o *UpdateTopologySourceOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/topologysources/{id}][%d] updateTopologySourceOK %s", 200, payload)
}

func (o *UpdateTopologySourceOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/topologysources/{id}][%d] updateTopologySourceOK %s", 200, payload)
}

func (o *UpdateTopologySourceOK) GetPayload() *models.TopologySource {
	return o.Payload
}

func (o *UpdateTopologySourceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.TopologySource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateTopologySourceTooManyRequests creates a UpdateTopologySourceTooManyRequests with default headers values
func NewUpdateTopologySourceTooManyRequests() *UpdateTopologySourceTooManyRequests {
	return &UpdateTopologySourceTooManyRequests{}
}

/*
UpdateTopologySourceTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateTopologySourceTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update topology source too many requests response has a 2xx status code
func (o *UpdateTopologySourceTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update topology source too many requests response has a 3xx status code
func (o *UpdateTopologySourceTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update topology source too many requests response has a 4xx status code
func (o *UpdateTopologySourceTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update topology source too many requests response has a 5xx status code
func (o *UpdateTopologySourceTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update topology source too many requests response a status code equal to that given
func (o *UpdateTopologySourceTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update topology source too many requests response
func (o *UpdateTopologySourceTooManyRequests) Code() int {
	return 429
}

func (o *UpdateTopologySourceTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /setting/topologysources/{id}][%d] updateTopologySourceTooManyRequests", 429)
}

func (o *UpdateTopologySourceTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /setting/topologysources/{id}][%d] updateTopologySourceTooManyRequests", 429)
}

func (o *UpdateTopologySourceTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateTopologySourceDefault creates a UpdateTopologySourceDefault with default headers values
func NewUpdateTopologySourceDefault(code int) *UpdateTopologySourceDefault {
	return &UpdateTopologySourceDefault{
		_statusCode: code,
	}
}

/*
UpdateTopologySourceDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateTopologySourceDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update topology source default response has a 2xx status code
func (o *UpdateTopologySourceDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update topology source default response has a 3xx status code
func (o *UpdateTopologySourceDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update topology source default response has a 4xx status code
func (o *UpdateTopologySourceDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update topology source default response has a 5xx status code
func (o *UpdateTopologySourceDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update topology source default response a status code equal to that given
func (o *UpdateTopologySourceDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update topology source default response
func (o *UpdateTopologySourceDefault) Code() int {
	return o._statusCode
}

func (o *UpdateTopologySourceDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/topologysources/{id}][%d] updateTopologySource default %s", o._statusCode, payload)
}

func (o *UpdateTopologySourceDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /setting/topologysources/{id}][%d] updateTopologySource default %s", o._statusCode, payload)
}

func (o *UpdateTopologySourceDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateTopologySourceDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
