// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// UpdateWebsiteByIDReader is a Reader for the UpdateWebsiteByID structure.
type UpdateWebsiteByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateWebsiteByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateWebsiteByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewUpdateWebsiteByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateWebsiteByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateWebsiteByIDOK creates a UpdateWebsiteByIDOK with default headers values
func NewUpdateWebsiteByIDOK() *UpdateWebsiteByIDOK {
	return &UpdateWebsiteByIDOK{}
}

/*
UpdateWebsiteByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type UpdateWebsiteByIDOK struct {
	Payload models.Website
}

// IsSuccess returns true when this update website by Id o k response has a 2xx status code
func (o *UpdateWebsiteByIDOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update website by Id o k response has a 3xx status code
func (o *UpdateWebsiteByIDOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update website by Id o k response has a 4xx status code
func (o *UpdateWebsiteByIDOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update website by Id o k response has a 5xx status code
func (o *UpdateWebsiteByIDOK) IsServerError() bool {
	return false
}

// IsCode returns true when this update website by Id o k response a status code equal to that given
func (o *UpdateWebsiteByIDOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update website by Id o k response
func (o *UpdateWebsiteByIDOK) Code() int {
	return 200
}

func (o *UpdateWebsiteByIDOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /website/websites/{id}][%d] updateWebsiteByIdOK %s", 200, payload)
}

func (o *UpdateWebsiteByIDOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /website/websites/{id}][%d] updateWebsiteByIdOK %s", 200, payload)
}

func (o *UpdateWebsiteByIDOK) GetPayload() models.Website {
	return o.Payload
}

func (o *UpdateWebsiteByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload as interface type
	payload, err := models.UnmarshalWebsite(response.Body(), consumer)
	if err != nil {
		return err
	}
	o.Payload = payload

	return nil
}

// NewUpdateWebsiteByIDTooManyRequests creates a UpdateWebsiteByIDTooManyRequests with default headers values
func NewUpdateWebsiteByIDTooManyRequests() *UpdateWebsiteByIDTooManyRequests {
	return &UpdateWebsiteByIDTooManyRequests{}
}

/*
UpdateWebsiteByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateWebsiteByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

// IsSuccess returns true when this update website by Id too many requests response has a 2xx status code
func (o *UpdateWebsiteByIDTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update website by Id too many requests response has a 3xx status code
func (o *UpdateWebsiteByIDTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update website by Id too many requests response has a 4xx status code
func (o *UpdateWebsiteByIDTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update website by Id too many requests response has a 5xx status code
func (o *UpdateWebsiteByIDTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update website by Id too many requests response a status code equal to that given
func (o *UpdateWebsiteByIDTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update website by Id too many requests response
func (o *UpdateWebsiteByIDTooManyRequests) Code() int {
	return 429
}

func (o *UpdateWebsiteByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[PUT /website/websites/{id}][%d] updateWebsiteByIdTooManyRequests", 429)
}

func (o *UpdateWebsiteByIDTooManyRequests) String() string {
	return fmt.Sprintf("[PUT /website/websites/{id}][%d] updateWebsiteByIdTooManyRequests", 429)
}

func (o *UpdateWebsiteByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewUpdateWebsiteByIDDefault creates a UpdateWebsiteByIDDefault with default headers values
func NewUpdateWebsiteByIDDefault(code int) *UpdateWebsiteByIDDefault {
	return &UpdateWebsiteByIDDefault{
		_statusCode: code,
	}
}

/*
UpdateWebsiteByIDDefault describes a response with status code -1, with default header values.

Error
*/
type UpdateWebsiteByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// IsSuccess returns true when this update website by Id default response has a 2xx status code
func (o *UpdateWebsiteByIDDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update website by Id default response has a 3xx status code
func (o *UpdateWebsiteByIDDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update website by Id default response has a 4xx status code
func (o *UpdateWebsiteByIDDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update website by Id default response has a 5xx status code
func (o *UpdateWebsiteByIDDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update website by Id default response a status code equal to that given
func (o *UpdateWebsiteByIDDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update website by Id default response
func (o *UpdateWebsiteByIDDefault) Code() int {
	return o._statusCode
}

func (o *UpdateWebsiteByIDDefault) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /website/websites/{id}][%d] updateWebsiteById default %s", o._statusCode, payload)
}

func (o *UpdateWebsiteByIDDefault) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[PUT /website/websites/{id}][%d] updateWebsiteById default %s", o._statusCode, payload)
}

func (o *UpdateWebsiteByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *UpdateWebsiteByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
