// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/logicmonitor/lm-sdk-go/v3/models"
)

// NewVerifyStorageAccountsPermissionsParams creates a new VerifyStorageAccountsPermissionsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewVerifyStorageAccountsPermissionsParams() *VerifyStorageAccountsPermissionsParams {
	return &VerifyStorageAccountsPermissionsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewVerifyStorageAccountsPermissionsParamsWithTimeout creates a new VerifyStorageAccountsPermissionsParams object
// with the ability to set a timeout on a request.
func NewVerifyStorageAccountsPermissionsParamsWithTimeout(timeout time.Duration) *VerifyStorageAccountsPermissionsParams {
	return &VerifyStorageAccountsPermissionsParams{
		timeout: timeout,
	}
}

// NewVerifyStorageAccountsPermissionsParamsWithContext creates a new VerifyStorageAccountsPermissionsParams object
// with the ability to set a context for a request.
func NewVerifyStorageAccountsPermissionsParamsWithContext(ctx context.Context) *VerifyStorageAccountsPermissionsParams {
	return &VerifyStorageAccountsPermissionsParams{
		Context: ctx,
	}
}

// NewVerifyStorageAccountsPermissionsParamsWithHTTPClient creates a new VerifyStorageAccountsPermissionsParams object
// with the ability to set a custom HTTPClient for a request.
func NewVerifyStorageAccountsPermissionsParamsWithHTTPClient(client *http.Client) *VerifyStorageAccountsPermissionsParams {
	return &VerifyStorageAccountsPermissionsParams{
		HTTPClient: client,
	}
}

/*
VerifyStorageAccountsPermissionsParams contains all the parameters to send to the API endpoint

	for the verify storage accounts permissions operation.

	Typically these are written to a http.Request.
*/
type VerifyStorageAccountsPermissionsParams struct {

	// UserAgent.
	//
	// Default: "Logicmonitor/GO-SDK"
	UserAgent *string

	// Body.
	Body *models.RestAzureStorageAccountVerify

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the verify storage accounts permissions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VerifyStorageAccountsPermissionsParams) WithDefaults() *VerifyStorageAccountsPermissionsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the verify storage accounts permissions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VerifyStorageAccountsPermissionsParams) SetDefaults() {
	var (
		userAgentDefault = string("Logicmonitor/GO-SDK")
	)

	val := VerifyStorageAccountsPermissionsParams{
		UserAgent: &userAgentDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the verify storage accounts permissions params
func (o *VerifyStorageAccountsPermissionsParams) WithTimeout(timeout time.Duration) *VerifyStorageAccountsPermissionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the verify storage accounts permissions params
func (o *VerifyStorageAccountsPermissionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the verify storage accounts permissions params
func (o *VerifyStorageAccountsPermissionsParams) WithContext(ctx context.Context) *VerifyStorageAccountsPermissionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the verify storage accounts permissions params
func (o *VerifyStorageAccountsPermissionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the verify storage accounts permissions params
func (o *VerifyStorageAccountsPermissionsParams) WithHTTPClient(client *http.Client) *VerifyStorageAccountsPermissionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the verify storage accounts permissions params
func (o *VerifyStorageAccountsPermissionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUserAgent adds the userAgent to the verify storage accounts permissions params
func (o *VerifyStorageAccountsPermissionsParams) WithUserAgent(userAgent *string) *VerifyStorageAccountsPermissionsParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the verify storage accounts permissions params
func (o *VerifyStorageAccountsPermissionsParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithBody adds the body to the verify storage accounts permissions params
func (o *VerifyStorageAccountsPermissionsParams) WithBody(body *models.RestAzureStorageAccountVerify) *VerifyStorageAccountsPermissionsParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the verify storage accounts permissions params
func (o *VerifyStorageAccountsPermissionsParams) SetBody(body *models.RestAzureStorageAccountVerify) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *VerifyStorageAccountsPermissionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.UserAgent != nil {

		// header param User-Agent
		if err := r.SetHeaderParam("User-Agent", *o.UserAgent); err != nil {
			return err
		}
	}
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
