// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// AlertFilters alert filters
//
// swagger:model AlertFilters
type AlertFilters struct {

	// datapoint filters
	DatapointFilters []*DatapointFilterItem `json:"datapointFilters,omitempty"`

	// datapoints filter mode
	// Enum: ["INCLUDE","EXCLUDE"]
	DatapointsFilterMode string `json:"datapointsFilterMode,omitempty"`

	// is ignore Sdt alerts
	IsIgnoreSDTAlerts bool `json:"isIgnoreSdtAlerts,omitempty"`
}

// Validate validates this alert filters
func (m *AlertFilters) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateDatapointFilters(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDatapointsFilterMode(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *AlertFilters) validateDatapointFilters(formats strfmt.Registry) error {
	if swag.IsZero(m.DatapointFilters) { // not required
		return nil
	}

	for i := 0; i < len(m.DatapointFilters); i++ {
		if swag.IsZero(m.DatapointFilters[i]) { // not required
			continue
		}

		if m.DatapointFilters[i] != nil {
			if err := m.DatapointFilters[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("datapointFilters" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("datapointFilters" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

var alertFiltersTypeDatapointsFilterModePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["INCLUDE","EXCLUDE"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		alertFiltersTypeDatapointsFilterModePropEnum = append(alertFiltersTypeDatapointsFilterModePropEnum, v)
	}
}

const (

	// AlertFiltersDatapointsFilterModeINCLUDE captures enum value "INCLUDE"
	AlertFiltersDatapointsFilterModeINCLUDE string = "INCLUDE"

	// AlertFiltersDatapointsFilterModeEXCLUDE captures enum value "EXCLUDE"
	AlertFiltersDatapointsFilterModeEXCLUDE string = "EXCLUDE"
)

// prop value enum
func (m *AlertFilters) validateDatapointsFilterModeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, alertFiltersTypeDatapointsFilterModePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *AlertFilters) validateDatapointsFilterMode(formats strfmt.Registry) error {
	if swag.IsZero(m.DatapointsFilterMode) { // not required
		return nil
	}

	// value enum
	if err := m.validateDatapointsFilterModeEnum("datapointsFilterMode", "body", m.DatapointsFilterMode); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this alert filters based on the context it is used
func (m *AlertFilters) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateDatapointFilters(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *AlertFilters) contextValidateDatapointFilters(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.DatapointFilters); i++ {

		if m.DatapointFilters[i] != nil {

			if swag.IsZero(m.DatapointFilters[i]) { // not required
				return nil
			}

			if err := m.DatapointFilters[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("datapointFilters" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("datapointFilters" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *AlertFilters) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *AlertFilters) UnmarshalBinary(b []byte) error {
	var res AlertFilters
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
