// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// AppliesToFunction applies to function
//
// swagger:model AppliesToFunction
type AppliesToFunction struct {

	// The Access Groups Id's
	// Example: 1, 2, 3
	// Unique: true
	AccessGroupIds []int32 `json:"accessGroupIds,omitempty"`

	// Access group Details in response
	AccessGroups []*AccessGroup `json:"accessGroups,omitempty"`

	// The metadata checksum for the LMModule content
	// Read Only: true
	Checksum string `json:"checksum,omitempty"`

	// The AppliesTo Function code. Note that special characters may need to be escaped.
	// Required: true
	Code *string `json:"code"`

	// The description of the AppliesTo Function
	Description string `json:"description,omitempty"`

	// The ID of the AppliesTo Function
	// Read Only: true
	// Minimum: 0
	ID int32 `json:"id,omitempty"`

	// The local module's IntegrationMetadata, readable for troubleshooting purposes
	// Read Only: true
	InstallationMetadata *IntegrationMetadata `json:"installationMetadata,omitempty"`

	// The lineage Id of the LMModule
	// Read Only: true
	LineageID string `json:"lineageId,omitempty"`

	// The name of the AppliesTo Function
	// Required: true
	Name *string `json:"name"`
}

// Validate validates this applies to function
func (m *AppliesToFunction) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAccessGroupIds(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAccessGroups(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCode(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateID(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateInstallationMetadata(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *AppliesToFunction) validateAccessGroupIds(formats strfmt.Registry) error {
	if swag.IsZero(m.AccessGroupIds) { // not required
		return nil
	}

	if err := validate.UniqueItems("accessGroupIds", "body", m.AccessGroupIds); err != nil {
		return err
	}

	return nil
}

func (m *AppliesToFunction) validateAccessGroups(formats strfmt.Registry) error {
	if swag.IsZero(m.AccessGroups) { // not required
		return nil
	}

	for i := 0; i < len(m.AccessGroups); i++ {
		if swag.IsZero(m.AccessGroups[i]) { // not required
			continue
		}

		if m.AccessGroups[i] != nil {
			if err := m.AccessGroups[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *AppliesToFunction) validateCode(formats strfmt.Registry) error {

	if err := validate.Required("code", "body", m.Code); err != nil {
		return err
	}

	return nil
}

func (m *AppliesToFunction) validateID(formats strfmt.Registry) error {
	if swag.IsZero(m.ID) { // not required
		return nil
	}

	if err := validate.MinimumInt("id", "body", int64(m.ID), 0, false); err != nil {
		return err
	}

	return nil
}

func (m *AppliesToFunction) validateInstallationMetadata(formats strfmt.Registry) error {
	if swag.IsZero(m.InstallationMetadata) { // not required
		return nil
	}

	if m.InstallationMetadata != nil {
		if err := m.InstallationMetadata.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("installationMetadata")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("installationMetadata")
			}
			return err
		}
	}

	return nil
}

func (m *AppliesToFunction) validateName(formats strfmt.Registry) error {

	if err := validate.Required("name", "body", m.Name); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this applies to function based on the context it is used
func (m *AppliesToFunction) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateAccessGroups(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateChecksum(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateInstallationMetadata(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLineageID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *AppliesToFunction) contextValidateAccessGroups(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.AccessGroups); i++ {

		if m.AccessGroups[i] != nil {

			if swag.IsZero(m.AccessGroups[i]) { // not required
				return nil
			}

			if err := m.AccessGroups[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *AppliesToFunction) contextValidateChecksum(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "checksum", "body", string(m.Checksum)); err != nil {
		return err
	}

	return nil
}

func (m *AppliesToFunction) contextValidateID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "id", "body", int32(m.ID)); err != nil {
		return err
	}

	return nil
}

func (m *AppliesToFunction) contextValidateInstallationMetadata(ctx context.Context, formats strfmt.Registry) error {

	if m.InstallationMetadata != nil {

		if swag.IsZero(m.InstallationMetadata) { // not required
			return nil
		}

		if err := m.InstallationMetadata.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("installationMetadata")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("installationMetadata")
			}
			return err
		}
	}

	return nil
}

func (m *AppliesToFunction) contextValidateLineageID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "lineageId", "body", string(m.LineageID)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *AppliesToFunction) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *AppliesToFunction) UnmarshalBinary(b []byte) error {
	var res AppliesToFunction
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
