// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"bytes"
	"context"
	"encoding/json"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// CloudWatchAutoDiscoveryMethod cloud watch auto discovery method
//
// swagger:model CloudWatchAutoDiscoveryMethod
type CloudWatchAutoDiscoveryMethod struct {

	// cluster dimension
	// Required: true
	ClusterDimension *string `json:"clusterDimension"`

	// cluster dimension value
	ClusterDimensionValue string `json:"clusterDimensionValue,omitempty"`

	// metric name
	MetricName string `json:"metricName,omitempty"`

	// namespace
	// Required: true
	Namespace *string `json:"namespace"`

	// node dimension
	// Required: true
	NodeDimension *string `json:"nodeDimension"`

	// period
	Period string `json:"period,omitempty"`
}

// Name gets the name of this subtype
func (m *CloudWatchAutoDiscoveryMethod) Name() string {
	return "ad_cloudwatch"
}

// SetName sets the name of this subtype
func (m *CloudWatchAutoDiscoveryMethod) SetName(val string) {
}

// UnmarshalJSON unmarshals this object with a polymorphic type from a JSON structure
func (m *CloudWatchAutoDiscoveryMethod) UnmarshalJSON(raw []byte) error {
	var data struct {

		// cluster dimension
		// Required: true
		ClusterDimension *string `json:"clusterDimension"`

		// cluster dimension value
		ClusterDimensionValue string `json:"clusterDimensionValue,omitempty"`

		// metric name
		MetricName string `json:"metricName,omitempty"`

		// namespace
		// Required: true
		Namespace *string `json:"namespace"`

		// node dimension
		// Required: true
		NodeDimension *string `json:"nodeDimension"`

		// period
		Period string `json:"period,omitempty"`
	}
	buf := bytes.NewBuffer(raw)
	dec := json.NewDecoder(buf)
	dec.UseNumber()

	if err := dec.Decode(&data); err != nil {
		return err
	}

	var base struct {
		/* Just the base type fields. Used for unmashalling polymorphic types.*/

		Name string `json:"name"`
	}
	buf = bytes.NewBuffer(raw)
	dec = json.NewDecoder(buf)
	dec.UseNumber()

	if err := dec.Decode(&base); err != nil {
		return err
	}

	var result CloudWatchAutoDiscoveryMethod

	if base.Name != result.Name() {
		/* Not the type we're looking for. */
		return errors.New(422, "invalid name value: %q", base.Name)
	}

	result.ClusterDimension = data.ClusterDimension
	result.ClusterDimensionValue = data.ClusterDimensionValue
	result.MetricName = data.MetricName
	result.Namespace = data.Namespace
	result.NodeDimension = data.NodeDimension
	result.Period = data.Period

	*m = result

	return nil
}

// MarshalJSON marshals this object with a polymorphic type to a JSON structure
func (m CloudWatchAutoDiscoveryMethod) MarshalJSON() ([]byte, error) {
	var b1, b2, b3 []byte
	var err error
	b1, err = json.Marshal(struct {

		// cluster dimension
		// Required: true
		ClusterDimension *string `json:"clusterDimension"`

		// cluster dimension value
		ClusterDimensionValue string `json:"clusterDimensionValue,omitempty"`

		// metric name
		MetricName string `json:"metricName,omitempty"`

		// namespace
		// Required: true
		Namespace *string `json:"namespace"`

		// node dimension
		// Required: true
		NodeDimension *string `json:"nodeDimension"`

		// period
		Period string `json:"period,omitempty"`
	}{

		ClusterDimension: m.ClusterDimension,

		ClusterDimensionValue: m.ClusterDimensionValue,

		MetricName: m.MetricName,

		Namespace: m.Namespace,

		NodeDimension: m.NodeDimension,

		Period: m.Period,
	})
	if err != nil {
		return nil, err
	}
	b2, err = json.Marshal(struct {
		Name string `json:"name"`
	}{

		Name: m.Name(),
	})
	if err != nil {
		return nil, err
	}

	return swag.ConcatJSON(b1, b2, b3), nil
}

// Validate validates this cloud watch auto discovery method
func (m *CloudWatchAutoDiscoveryMethod) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateClusterDimension(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNamespace(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNodeDimension(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *CloudWatchAutoDiscoveryMethod) validateClusterDimension(formats strfmt.Registry) error {

	if err := validate.Required("clusterDimension", "body", m.ClusterDimension); err != nil {
		return err
	}

	return nil
}

func (m *CloudWatchAutoDiscoveryMethod) validateNamespace(formats strfmt.Registry) error {

	if err := validate.Required("namespace", "body", m.Namespace); err != nil {
		return err
	}

	return nil
}

func (m *CloudWatchAutoDiscoveryMethod) validateNodeDimension(formats strfmt.Registry) error {

	if err := validate.Required("nodeDimension", "body", m.NodeDimension); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this cloud watch auto discovery method based on the context it is used
func (m *CloudWatchAutoDiscoveryMethod) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// MarshalBinary interface implementation
func (m *CloudWatchAutoDiscoveryMethod) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *CloudWatchAutoDiscoveryMethod) UnmarshalBinary(b []byte) error {
	var res CloudWatchAutoDiscoveryMethod
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
