// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// LogPartition log partition
//
// swagger:model LogPartition
type LogPartition struct {

	// Partition active state
	// Required: true
	Active *bool `json:"active"`

	// changelogs
	Changelogs []LogPartitionChangelog `json:"changelogs,omitempty"`

	// Partition Criteria
	// Example: example
	Criteria string `json:"criteria,omitempty"`

	// Partition description
	// Example: Example Description
	Description string `json:"description,omitempty"`

	// Partition Fullname
	// Example: Example Partition
	// Read Only: true
	Fullname string `json:"fullname,omitempty"`

	// Partition Id
	// Example: 1
	// Read Only: true
	ID string `json:"id,omitempty"`

	// Partition Name
	// Example: partition
	// Required: true
	Name *string `json:"name"`

	// Parent Partition Id
	// Example: 2
	Parent int32 `json:"parent,omitempty"`

	// Epoch time when partition was paused
	// Read Only: true
	PausedAt int64 `json:"pausedAt,omitempty"`

	// Partition Priority
	// Example: 100
	Priority int32 `json:"priority,omitempty"`

	// Partition Retention in days
	// Example: 7
	// Required: true
	Retention *int32 `json:"retention"`

	// Tenant Name
	// Example: tenant
	Tenant string `json:"tenant,omitempty"`

	// Partition user permission
	// Read Only: true
	UserPermission string `json:"userPermission,omitempty"`
}

// Validate validates this log partition
func (m *LogPartition) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateActive(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateRetention(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *LogPartition) validateActive(formats strfmt.Registry) error {

	if err := validate.Required("active", "body", m.Active); err != nil {
		return err
	}

	return nil
}

func (m *LogPartition) validateName(formats strfmt.Registry) error {

	if err := validate.Required("name", "body", m.Name); err != nil {
		return err
	}

	return nil
}

func (m *LogPartition) validateRetention(formats strfmt.Registry) error {

	if err := validate.Required("retention", "body", m.Retention); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this log partition based on the context it is used
func (m *LogPartition) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateFullname(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidatePausedAt(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUserPermission(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *LogPartition) contextValidateFullname(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "fullname", "body", string(m.Fullname)); err != nil {
		return err
	}

	return nil
}

func (m *LogPartition) contextValidateID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "id", "body", string(m.ID)); err != nil {
		return err
	}

	return nil
}

func (m *LogPartition) contextValidatePausedAt(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "pausedAt", "body", int64(m.PausedAt)); err != nil {
		return err
	}

	return nil
}

func (m *LogPartition) contextValidateUserPermission(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "userPermission", "body", string(m.UserPermission)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *LogPartition) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *LogPartition) UnmarshalBinary(b []byte) error {
	var res LogPartition
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
