// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// LogSource log source
//
// swagger:model LogSource
type LogSource struct {

	// The Access Groups Id's
	// Example: 1, 2, 3
	// Unique: true
	AccessGroupIds []int32 `json:"accessGroupIds,omitempty"`

	// Module's access groups
	AccessGroups []*AccessGroup `json:"accessGroups,omitempty"`

	// The appliesToScript
	AppliesToScript string `json:"appliesToScript,omitempty"`

	// changelogs
	Changelogs []*UpdateReasons `json:"changelogs,omitempty"`

	// The metadata checksum for the LMModule content
	// Read Only: true
	Checksum string `json:"checksum,omitempty"`

	// collectionAttribute
	CollectionAttribute interface{} `json:"collectionAttribute,omitempty"`

	// collection interval
	CollectionInterval *Duration `json:"collectionInterval,omitempty"`

	// collection method
	// Enum: ["INVALID","WIN_EVENT","SYSLOG","DUMMY","SCRAPE_LOGS","KUBERNETES_EVENT","KUBERNETES_POD","SCRIPT","SAAS_O365_AUDIT_LOGS","SNMP_TRAP"]
	CollectionMethod string `json:"collectionMethod,omitempty"`

	// description
	Description string `json:"description,omitempty"`

	// filters
	Filters []*RestLogSourceFilterV3 `json:"filters,omitempty"`

	// group
	Group string `json:"group,omitempty"`

	// The ID of the LMModule
	// Read Only: true
	ID int32 `json:"id,omitempty"`

	// The local module's IntegrationMetadata, readable for troubleshooting purposes
	// Read Only: true
	InstallationMetadata *IntegrationMetadata `json:"installationMetadata,omitempty"`

	// The lineageId the LMModule belongs to
	// Read Only: true
	LineageID string `json:"lineageId,omitempty"`

	// log fields
	LogFields []*LogSourceLogField `json:"logFields,omitempty"`

	// The log source name
	Name string `json:"name,omitempty"`

	// resource mapping
	ResourceMapping []*RestLogSourceResourceMappingV3 `json:"resourceMapping,omitempty"`

	// tags
	Tags []string `json:"tags,omitempty"`

	// The technicalNotes
	TechnicalNotes string `json:"technicalNotes,omitempty"`
}

// Validate validates this log source
func (m *LogSource) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAccessGroupIds(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAccessGroups(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateChangelogs(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCollectionInterval(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCollectionMethod(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateFilters(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateInstallationMetadata(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLogFields(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateResourceMapping(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *LogSource) validateAccessGroupIds(formats strfmt.Registry) error {
	if swag.IsZero(m.AccessGroupIds) { // not required
		return nil
	}

	if err := validate.UniqueItems("accessGroupIds", "body", m.AccessGroupIds); err != nil {
		return err
	}

	return nil
}

func (m *LogSource) validateAccessGroups(formats strfmt.Registry) error {
	if swag.IsZero(m.AccessGroups) { // not required
		return nil
	}

	for i := 0; i < len(m.AccessGroups); i++ {
		if swag.IsZero(m.AccessGroups[i]) { // not required
			continue
		}

		if m.AccessGroups[i] != nil {
			if err := m.AccessGroups[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *LogSource) validateChangelogs(formats strfmt.Registry) error {
	if swag.IsZero(m.Changelogs) { // not required
		return nil
	}

	for i := 0; i < len(m.Changelogs); i++ {
		if swag.IsZero(m.Changelogs[i]) { // not required
			continue
		}

		if m.Changelogs[i] != nil {
			if err := m.Changelogs[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("changelogs" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("changelogs" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *LogSource) validateCollectionInterval(formats strfmt.Registry) error {
	if swag.IsZero(m.CollectionInterval) { // not required
		return nil
	}

	if m.CollectionInterval != nil {
		if err := m.CollectionInterval.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("collectionInterval")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("collectionInterval")
			}
			return err
		}
	}

	return nil
}

var logSourceTypeCollectionMethodPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["INVALID","WIN_EVENT","SYSLOG","DUMMY","SCRAPE_LOGS","KUBERNETES_EVENT","KUBERNETES_POD","SCRIPT","SAAS_O365_AUDIT_LOGS","SNMP_TRAP"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		logSourceTypeCollectionMethodPropEnum = append(logSourceTypeCollectionMethodPropEnum, v)
	}
}

const (

	// LogSourceCollectionMethodINVALID captures enum value "INVALID"
	LogSourceCollectionMethodINVALID string = "INVALID"

	// LogSourceCollectionMethodWINEVENT captures enum value "WIN_EVENT"
	LogSourceCollectionMethodWINEVENT string = "WIN_EVENT"

	// LogSourceCollectionMethodSYSLOG captures enum value "SYSLOG"
	LogSourceCollectionMethodSYSLOG string = "SYSLOG"

	// LogSourceCollectionMethodDUMMY captures enum value "DUMMY"
	LogSourceCollectionMethodDUMMY string = "DUMMY"

	// LogSourceCollectionMethodSCRAPELOGS captures enum value "SCRAPE_LOGS"
	LogSourceCollectionMethodSCRAPELOGS string = "SCRAPE_LOGS"

	// LogSourceCollectionMethodKUBERNETESEVENT captures enum value "KUBERNETES_EVENT"
	LogSourceCollectionMethodKUBERNETESEVENT string = "KUBERNETES_EVENT"

	// LogSourceCollectionMethodKUBERNETESPOD captures enum value "KUBERNETES_POD"
	LogSourceCollectionMethodKUBERNETESPOD string = "KUBERNETES_POD"

	// LogSourceCollectionMethodSCRIPT captures enum value "SCRIPT"
	LogSourceCollectionMethodSCRIPT string = "SCRIPT"

	// LogSourceCollectionMethodSAASO365AUDITLOGS captures enum value "SAAS_O365_AUDIT_LOGS"
	LogSourceCollectionMethodSAASO365AUDITLOGS string = "SAAS_O365_AUDIT_LOGS"

	// LogSourceCollectionMethodSNMPTRAP captures enum value "SNMP_TRAP"
	LogSourceCollectionMethodSNMPTRAP string = "SNMP_TRAP"
)

// prop value enum
func (m *LogSource) validateCollectionMethodEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, logSourceTypeCollectionMethodPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *LogSource) validateCollectionMethod(formats strfmt.Registry) error {
	if swag.IsZero(m.CollectionMethod) { // not required
		return nil
	}

	// value enum
	if err := m.validateCollectionMethodEnum("collectionMethod", "body", m.CollectionMethod); err != nil {
		return err
	}

	return nil
}

func (m *LogSource) validateFilters(formats strfmt.Registry) error {
	if swag.IsZero(m.Filters) { // not required
		return nil
	}

	for i := 0; i < len(m.Filters); i++ {
		if swag.IsZero(m.Filters[i]) { // not required
			continue
		}

		if m.Filters[i] != nil {
			if err := m.Filters[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("filters" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("filters" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *LogSource) validateInstallationMetadata(formats strfmt.Registry) error {
	if swag.IsZero(m.InstallationMetadata) { // not required
		return nil
	}

	if m.InstallationMetadata != nil {
		if err := m.InstallationMetadata.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("installationMetadata")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("installationMetadata")
			}
			return err
		}
	}

	return nil
}

func (m *LogSource) validateLogFields(formats strfmt.Registry) error {
	if swag.IsZero(m.LogFields) { // not required
		return nil
	}

	for i := 0; i < len(m.LogFields); i++ {
		if swag.IsZero(m.LogFields[i]) { // not required
			continue
		}

		if m.LogFields[i] != nil {
			if err := m.LogFields[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("logFields" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("logFields" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *LogSource) validateResourceMapping(formats strfmt.Registry) error {
	if swag.IsZero(m.ResourceMapping) { // not required
		return nil
	}

	for i := 0; i < len(m.ResourceMapping); i++ {
		if swag.IsZero(m.ResourceMapping[i]) { // not required
			continue
		}

		if m.ResourceMapping[i] != nil {
			if err := m.ResourceMapping[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("resourceMapping" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("resourceMapping" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this log source based on the context it is used
func (m *LogSource) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateAccessGroups(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateChangelogs(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateChecksum(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateCollectionInterval(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateFilters(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateInstallationMetadata(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLineageID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLogFields(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateResourceMapping(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *LogSource) contextValidateAccessGroups(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.AccessGroups); i++ {

		if m.AccessGroups[i] != nil {

			if swag.IsZero(m.AccessGroups[i]) { // not required
				return nil
			}

			if err := m.AccessGroups[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *LogSource) contextValidateChangelogs(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Changelogs); i++ {

		if m.Changelogs[i] != nil {

			if swag.IsZero(m.Changelogs[i]) { // not required
				return nil
			}

			if err := m.Changelogs[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("changelogs" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("changelogs" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *LogSource) contextValidateChecksum(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "checksum", "body", string(m.Checksum)); err != nil {
		return err
	}

	return nil
}

func (m *LogSource) contextValidateCollectionInterval(ctx context.Context, formats strfmt.Registry) error {

	if m.CollectionInterval != nil {

		if swag.IsZero(m.CollectionInterval) { // not required
			return nil
		}

		if err := m.CollectionInterval.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("collectionInterval")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("collectionInterval")
			}
			return err
		}
	}

	return nil
}

func (m *LogSource) contextValidateFilters(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Filters); i++ {

		if m.Filters[i] != nil {

			if swag.IsZero(m.Filters[i]) { // not required
				return nil
			}

			if err := m.Filters[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("filters" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("filters" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *LogSource) contextValidateID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "id", "body", int32(m.ID)); err != nil {
		return err
	}

	return nil
}

func (m *LogSource) contextValidateInstallationMetadata(ctx context.Context, formats strfmt.Registry) error {

	if m.InstallationMetadata != nil {

		if swag.IsZero(m.InstallationMetadata) { // not required
			return nil
		}

		if err := m.InstallationMetadata.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("installationMetadata")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("installationMetadata")
			}
			return err
		}
	}

	return nil
}

func (m *LogSource) contextValidateLineageID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "lineageId", "body", string(m.LineageID)); err != nil {
		return err
	}

	return nil
}

func (m *LogSource) contextValidateLogFields(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.LogFields); i++ {

		if m.LogFields[i] != nil {

			if swag.IsZero(m.LogFields[i]) { // not required
				return nil
			}

			if err := m.LogFields[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("logFields" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("logFields" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *LogSource) contextValidateResourceMapping(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.ResourceMapping); i++ {

		if m.ResourceMapping[i] != nil {

			if swag.IsZero(m.ResourceMapping[i]) { // not required
				return nil
			}

			if err := m.ResourceMapping[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("resourceMapping" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("resourceMapping" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *LogSource) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *LogSource) UnmarshalBinary(b []byte) error {
	var res LogSource
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
