// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"bytes"
	"context"
	"encoding/json"
	"io"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// NetflowGroupWidgetData netflow group widget data
//
// swagger:model NetflowGroupWidgetData
type NetflowGroupWidgetData struct {
	titleField string

	itemsField []NetflowDataBase

	// total
	// Read Only: true
	Total int32 `json:"total,omitempty"`
}

// Title gets the title of this subtype
func (m *NetflowGroupWidgetData) Title() string {
	return m.titleField
}

// SetTitle sets the title of this subtype
func (m *NetflowGroupWidgetData) SetTitle(val string) {
	m.titleField = val
}

// Type gets the type of this subtype
func (m *NetflowGroupWidgetData) Type() string {
	return "groupNetflow"
}

// SetType sets the type of this subtype
func (m *NetflowGroupWidgetData) SetType(val string) {
}

// Items gets the items of this subtype
func (m *NetflowGroupWidgetData) Items() []NetflowDataBase {
	return m.itemsField
}

// SetItems sets the items of this subtype
func (m *NetflowGroupWidgetData) SetItems(val []NetflowDataBase) {
	m.itemsField = val
}

// UnmarshalJSON unmarshals this object with a polymorphic type from a JSON structure
func (m *NetflowGroupWidgetData) UnmarshalJSON(raw []byte) error {
	var data struct {
		Items json.RawMessage `json:"items,omitempty"`

		// total
		// Read Only: true
		Total int32 `json:"total,omitempty"`
	}
	buf := bytes.NewBuffer(raw)
	dec := json.NewDecoder(buf)
	dec.UseNumber()

	if err := dec.Decode(&data); err != nil {
		return err
	}

	var base struct {
		/* Just the base type fields. Used for unmashalling polymorphic types.*/

		Title string `json:"title,omitempty"`

		Type string `json:"type,omitempty"`
	}
	buf = bytes.NewBuffer(raw)
	dec = json.NewDecoder(buf)
	dec.UseNumber()

	if err := dec.Decode(&base); err != nil {
		return err
	}

	var allOfItems []NetflowDataBase
	if string(data.Items) != "null" {
		items, err := UnmarshalNetflowDataBaseSlice(bytes.NewBuffer(data.Items), runtime.JSONConsumer())
		if err != nil && err != io.EOF {
			return err
		}
		allOfItems = items
	}

	var result NetflowGroupWidgetData

	result.titleField = base.Title

	if base.Type != result.Type() {
		/* Not the type we're looking for. */
		return errors.New(422, "invalid type value: %q", base.Type)
	}

	result.itemsField = allOfItems
	result.Total = data.Total

	*m = result

	return nil
}

// MarshalJSON marshals this object with a polymorphic type to a JSON structure
func (m NetflowGroupWidgetData) MarshalJSON() ([]byte, error) {
	var b1, b2, b3 []byte
	var err error
	b1, err = json.Marshal(struct {

		// total
		// Read Only: true
		Total int32 `json:"total,omitempty"`
	}{

		Total: m.Total,
	})
	if err != nil {
		return nil, err
	}
	b2, err = json.Marshal(struct {
		Title string `json:"title,omitempty"`

		Type string `json:"type,omitempty"`

		Items []NetflowDataBase `json:"items,omitempty"`
	}{

		Title: m.Title(),

		Type: m.Type(),

		Items: m.Items(),
	})
	if err != nil {
		return nil, err
	}

	return swag.ConcatJSON(b1, b2, b3), nil
}

// Validate validates this netflow group widget data
func (m *NetflowGroupWidgetData) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateItems(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NetflowGroupWidgetData) validateItems(formats strfmt.Registry) error {

	if swag.IsZero(m.Items()) { // not required
		return nil
	}

	for i := 0; i < len(m.Items()); i++ {

		if err := m.itemsField[i].Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("items" + "." + strconv.Itoa(i))
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("items" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

// ContextValidate validate this netflow group widget data based on the context it is used
func (m *NetflowGroupWidgetData) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateItems(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateTotal(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NetflowGroupWidgetData) contextValidateType(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "type", "body", string(m.Type())); err != nil {
		return err
	}

	return nil
}

func (m *NetflowGroupWidgetData) contextValidateItems(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "items", "body", []NetflowDataBase(m.Items())); err != nil {
		return err
	}

	for i := 0; i < len(m.Items()); i++ {

		if swag.IsZero(m.itemsField[i]) { // not required
			return nil
		}

		if err := m.itemsField[i].ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("items" + "." + strconv.Itoa(i))
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("items" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

func (m *NetflowGroupWidgetData) contextValidateTotal(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "total", "body", int32(m.Total)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *NetflowGroupWidgetData) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NetflowGroupWidgetData) UnmarshalBinary(b []byte) error {
	var res NetflowGroupWidgetData
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
