// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// TopologySource topology source
//
// swagger:model TopologySource
type TopologySource struct {

	// The Access Groups Id's
	// Example: 1, 2, 3
	// Unique: true
	AccessGroupIds []int32 `json:"accessGroupIds,omitempty"`

	// Module's access groups
	AccessGroups []*AccessGroup `json:"accessGroups,omitempty"`

	// The Applies To for the LMModule
	AppliesTo string `json:"appliesTo,omitempty"`

	// The TopologySource audit Version
	AuditVersion int64 `json:"auditVersion,omitempty"`

	// The metadata checksum for the LMModule content
	// Read Only: true
	Checksum string `json:"checksum,omitempty"`

	// The TopologySource data collect interval in seconds, default 3600
	// Enum: [1800,3600,14400,43200]
	CollectInterval int32 `json:"collectInterval,omitempty"`

	// The topology will be build on properties or traditional way, default 'script'
	// Required: true
	CollectionMethod *string `json:"collectionMethod"`

	// collector's attributes to collect topologies
	// Required: true
	CollectorAttribute *ScriptCollectorAttribute `json:"collectorAttribute"`

	// The description for the LMModule
	Description string `json:"description,omitempty"`

	// The group the LMModule is in
	Group string `json:"group,omitempty"`

	// The ID of the LMModule
	// Read Only: true
	ID int32 `json:"id,omitempty"`

	// The local module's IntegrationMetadata, readable for troubleshooting purposes
	// Read Only: true
	InstallationMetadata *IntegrationMetadata `json:"installationMetadata,omitempty"`

	// The lineageId the LMModule belongs to
	// Read Only: true
	LineageID string `json:"lineageId,omitempty"`

	// The TopologySource name
	// Required: true
	Name *string `json:"name"`

	// The Tags for the LMModule
	Tags string `json:"tags,omitempty"`

	// The Technical Notes for the LMModule
	Technology string `json:"technology,omitempty"`

	// The TopologySource version
	Version int64 `json:"version,omitempty"`
}

// Validate validates this topology source
func (m *TopologySource) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAccessGroupIds(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAccessGroups(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCollectInterval(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCollectionMethod(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCollectorAttribute(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateInstallationMetadata(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *TopologySource) validateAccessGroupIds(formats strfmt.Registry) error {
	if swag.IsZero(m.AccessGroupIds) { // not required
		return nil
	}

	if err := validate.UniqueItems("accessGroupIds", "body", m.AccessGroupIds); err != nil {
		return err
	}

	return nil
}

func (m *TopologySource) validateAccessGroups(formats strfmt.Registry) error {
	if swag.IsZero(m.AccessGroups) { // not required
		return nil
	}

	for i := 0; i < len(m.AccessGroups); i++ {
		if swag.IsZero(m.AccessGroups[i]) { // not required
			continue
		}

		if m.AccessGroups[i] != nil {
			if err := m.AccessGroups[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

var topologySourceTypeCollectIntervalPropEnum []interface{}

func init() {
	var res []int32
	if err := json.Unmarshal([]byte(`[1800,3600,14400,43200]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		topologySourceTypeCollectIntervalPropEnum = append(topologySourceTypeCollectIntervalPropEnum, v)
	}
}

// prop value enum
func (m *TopologySource) validateCollectIntervalEnum(path, location string, value int32) error {
	if err := validate.EnumCase(path, location, value, topologySourceTypeCollectIntervalPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *TopologySource) validateCollectInterval(formats strfmt.Registry) error {
	if swag.IsZero(m.CollectInterval) { // not required
		return nil
	}

	// value enum
	if err := m.validateCollectIntervalEnum("collectInterval", "body", m.CollectInterval); err != nil {
		return err
	}

	return nil
}

func (m *TopologySource) validateCollectionMethod(formats strfmt.Registry) error {

	if err := validate.Required("collectionMethod", "body", m.CollectionMethod); err != nil {
		return err
	}

	return nil
}

func (m *TopologySource) validateCollectorAttribute(formats strfmt.Registry) error {

	if err := validate.Required("collectorAttribute", "body", m.CollectorAttribute); err != nil {
		return err
	}

	if m.CollectorAttribute != nil {
		if err := m.CollectorAttribute.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("collectorAttribute")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("collectorAttribute")
			}
			return err
		}
	}

	return nil
}

func (m *TopologySource) validateInstallationMetadata(formats strfmt.Registry) error {
	if swag.IsZero(m.InstallationMetadata) { // not required
		return nil
	}

	if m.InstallationMetadata != nil {
		if err := m.InstallationMetadata.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("installationMetadata")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("installationMetadata")
			}
			return err
		}
	}

	return nil
}

func (m *TopologySource) validateName(formats strfmt.Registry) error {

	if err := validate.Required("name", "body", m.Name); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this topology source based on the context it is used
func (m *TopologySource) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateAccessGroups(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateChecksum(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateCollectorAttribute(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateInstallationMetadata(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLineageID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *TopologySource) contextValidateAccessGroups(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.AccessGroups); i++ {

		if m.AccessGroups[i] != nil {

			if swag.IsZero(m.AccessGroups[i]) { // not required
				return nil
			}

			if err := m.AccessGroups[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("accessGroups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *TopologySource) contextValidateChecksum(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "checksum", "body", string(m.Checksum)); err != nil {
		return err
	}

	return nil
}

func (m *TopologySource) contextValidateCollectorAttribute(ctx context.Context, formats strfmt.Registry) error {

	if m.CollectorAttribute != nil {

		if err := m.CollectorAttribute.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("collectorAttribute")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("collectorAttribute")
			}
			return err
		}
	}

	return nil
}

func (m *TopologySource) contextValidateID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "id", "body", int32(m.ID)); err != nil {
		return err
	}

	return nil
}

func (m *TopologySource) contextValidateInstallationMetadata(ctx context.Context, formats strfmt.Registry) error {

	if m.InstallationMetadata != nil {

		if swag.IsZero(m.InstallationMetadata) { // not required
			return nil
		}

		if err := m.InstallationMetadata.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("installationMetadata")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("installationMetadata")
			}
			return err
		}
	}

	return nil
}

func (m *TopologySource) contextValidateLineageID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "lineageId", "body", string(m.LineageID)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *TopologySource) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *TopologySource) UnmarshalBinary(b []byte) error {
	var res TopologySource
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
