// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// VizFilterItem viz filter item
//
// swagger:model VizFilterItem
type VizFilterItem struct {

	// inclusion type
	// Read Only: true
	// Enum: ["INCLUDE","EXCLUDE"]
	InclusionType string `json:"inclusionType,omitempty"`

	// label
	// Read Only: true
	Label string `json:"label,omitempty"`

	// name
	// Read Only: true
	Name string `json:"name,omitempty"`

	// type
	// Read Only: true
	// Enum: ["SYNONYM","RESOURCE_PROPERTY"]
	Type string `json:"type,omitempty"`

	// value
	// Read Only: true
	Value []*LabelValuePair `json:"value,omitempty"`
}

// Validate validates this viz filter item
func (m *VizFilterItem) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateInclusionType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateValue(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var vizFilterItemTypeInclusionTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["INCLUDE","EXCLUDE"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		vizFilterItemTypeInclusionTypePropEnum = append(vizFilterItemTypeInclusionTypePropEnum, v)
	}
}

const (

	// VizFilterItemInclusionTypeINCLUDE captures enum value "INCLUDE"
	VizFilterItemInclusionTypeINCLUDE string = "INCLUDE"

	// VizFilterItemInclusionTypeEXCLUDE captures enum value "EXCLUDE"
	VizFilterItemInclusionTypeEXCLUDE string = "EXCLUDE"
)

// prop value enum
func (m *VizFilterItem) validateInclusionTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, vizFilterItemTypeInclusionTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *VizFilterItem) validateInclusionType(formats strfmt.Registry) error {
	if swag.IsZero(m.InclusionType) { // not required
		return nil
	}

	// value enum
	if err := m.validateInclusionTypeEnum("inclusionType", "body", m.InclusionType); err != nil {
		return err
	}

	return nil
}

var vizFilterItemTypeTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["SYNONYM","RESOURCE_PROPERTY"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		vizFilterItemTypeTypePropEnum = append(vizFilterItemTypeTypePropEnum, v)
	}
}

const (

	// VizFilterItemTypeSYNONYM captures enum value "SYNONYM"
	VizFilterItemTypeSYNONYM string = "SYNONYM"

	// VizFilterItemTypeRESOURCEPROPERTY captures enum value "RESOURCE_PROPERTY"
	VizFilterItemTypeRESOURCEPROPERTY string = "RESOURCE_PROPERTY"
)

// prop value enum
func (m *VizFilterItem) validateTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, vizFilterItemTypeTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *VizFilterItem) validateType(formats strfmt.Registry) error {
	if swag.IsZero(m.Type) { // not required
		return nil
	}

	// value enum
	if err := m.validateTypeEnum("type", "body", m.Type); err != nil {
		return err
	}

	return nil
}

func (m *VizFilterItem) validateValue(formats strfmt.Registry) error {
	if swag.IsZero(m.Value) { // not required
		return nil
	}

	for i := 0; i < len(m.Value); i++ {
		if swag.IsZero(m.Value[i]) { // not required
			continue
		}

		if m.Value[i] != nil {
			if err := m.Value[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("value" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("value" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this viz filter item based on the context it is used
func (m *VizFilterItem) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateInclusionType(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLabel(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateName(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateType(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateValue(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VizFilterItem) contextValidateInclusionType(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "inclusionType", "body", string(m.InclusionType)); err != nil {
		return err
	}

	return nil
}

func (m *VizFilterItem) contextValidateLabel(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "label", "body", string(m.Label)); err != nil {
		return err
	}

	return nil
}

func (m *VizFilterItem) contextValidateName(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "name", "body", string(m.Name)); err != nil {
		return err
	}

	return nil
}

func (m *VizFilterItem) contextValidateType(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "type", "body", string(m.Type)); err != nil {
		return err
	}

	return nil
}

func (m *VizFilterItem) contextValidateValue(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "value", "body", []*LabelValuePair(m.Value)); err != nil {
		return err
	}

	for i := 0; i < len(m.Value); i++ {

		if m.Value[i] != nil {

			if swag.IsZero(m.Value[i]) { // not required
				return nil
			}

			if err := m.Value[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("value" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("value" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *VizFilterItem) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VizFilterItem) UnmarshalBinary(b []byte) error {
	var res VizFilterItem
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
